/*
 * ***** BEGIN LICENSE BLOCK *****
 * Zimbra Collaboration Suite, Network Edition.
 * Copyright (C) 2007, 2008, 2009, 2012, 2013, 2014 Zimbra, Inc.  All Rights Reserved.
 * ***** END LICENSE BLOCK *****
 */

/**
* @class ZaAccountMoveViewController controls display of Account Move view
* @contructor ZaAccountMoveViewController
* @param appCtxt
* @param container
* @author Greg Solovyev
**/

function ZaAccountMoveViewController(appCtxt, container) {
	ZaXFormViewController.call(this, appCtxt, container,"ZaAccountMoveViewController");
	this._UICreated = false;
	this._helpURL = location.pathname + "help/admin/html/managing_accounts/moving_a_mailbox.htm?locid=" + AjxEnv.DEFAULT_LOCALE;		
	this.tabConstructor = ZaAccountMoveXFormView ;
}

ZaAccountMoveViewController.prototype = new ZaXFormViewController();
ZaAccountMoveViewController.prototype.constructor = ZaAccountMoveViewController;

ZaController.setViewMethods["ZaAccountMoveViewController"] = new Array();
/**
*	@method show
*	@param entry - isntance of ZaServer class
*/
ZaAccountMoveViewController.prototype.show = 
function(entry) {
	if (! this.selectExistingTabByItemId(entry.id)){
		this._setView(entry, true);
	}
}


ZaAccountMoveViewController.prototype.setEnabled = 
function(enable) {
	//this._view.setEnabled(enable);
}

ZaController.setViewMethods["ZaAccountMoveViewController"].push(ZaXFormViewController.setViewMethod);

//Listeners for default toolbar buttons (close, save, delete)
/**
* member of ZaXFormViewController
* @param 	ev event object
* 			noPopView - It should be set to true when close a hidden tab
* handles the Close button click. Returns to the list view.
**/ 
ZaAccountMoveViewController.prototype.closeButtonListener =
function(ev, noPopView, func, obj, params) {
	if(this._view.isDirty()) {
		var args = new Object();
		args["obj"] = ZaApp.getInstance();		
		args["params"] = null;
		args["func"] = ZaApp.prototype.popView;
					
		ZaApp.getInstance().dialogs["confirmMessageDialog"].setMessage(AjxMessageFormat.format(com_zimbra_backuprestore.BNR_WarningPurge,[this._currentObject[ZaAccountMove.A_originalSource], this._currentObject.account[ZaAccount.A_name]] ), DwtMessageDialog.WARNING_STYLE);
		ZaApp.getInstance().dialogs["confirmMessageDialog"].registerCallback(DwtDialog.YES_BUTTON, this.discardAndGoAway, this, args);		
		ZaApp.getInstance().dialogs["confirmMessageDialog"].registerCallback(DwtDialog.NO_BUTTON, ZaApp.getInstance().dialogs["confirmMessageDialog"].popdown, ZaApp.getInstance().dialogs["confirmMessageDialog"]);		
		ZaApp.getInstance().dialogs["confirmMessageDialog"].popup();
	}else{
		ZaApp.getInstance().popView();
	}
}