/*
 * ***** BEGIN LICENSE BLOCK *****
 * Zimbra Collaboration Suite, Network Edition.
 * Copyright (C) 2009, 2010, 2011, 2012, 2013, 2014 Zimbra, Inc.  All Rights Reserved.
 * ***** END LICENSE BLOCK *****
 */
ZaAllGrantsViewController = function (appCtxt, container) {
    ZaXFormViewController.call(this, appCtxt, container, "ZaAllGrantsViewController");
    this._UICreated = false;
    this._helpURL = ZaAllGrantsViewController.helpURL;

    this.tabConstructor = ZaAllGrantsXFormView;

    this.addCreationListener(new AjxListener(this, this.handleGrantCreation));
    this.addRemovalListener(new AjxListener(this, this.handleGrantRemoval));
}

ZaAllGrantsViewController.prototype = new ZaXFormViewController();
ZaAllGrantsViewController.prototype.constructor = ZaAllGrantsViewController;
ZaAllGrantsViewController.helpURL = location.pathname + ZaUtil.HELP_URL + "manage_delegated_admin_grants.htm?locid=" + AjxEnv.DEFAULT_LOCALE;

ZaController.setViewMethods["ZaAllGrantsViewController"] = new Array();
ZaController.initPopupMenuMethods["ZaAllGrantsViewController"] = new Array();
ZaController.changeActionsStateMethods["ZaAllGrantsViewController"] = new Array();

/**
 *    @method show
 *    @param entry - isntance of ZaAccount class
 *    @param skipRefresh - forces to skip entry.refresh() call.
 *           When getting account from an alias the account is retreived from the server using ZaAccount.load()
 *            so there is no need to refresh it.
 */

ZaAllGrantsViewController.prototype.show =
function(entry, openInNewTab, skipRefresh) {
    if ( !this.selectExistingTabByItemId(entry[ZaGrant.A_grantee_id])) {
        this._setView(entry, openInNewTab, skipRefresh);
    }
}
/*
ZaAllGrantsViewController.initToolbarMethod =
function () {

    this._toolbarOrder.push(ZaOperation.NEW);
    this._toolbarOrder.push(ZaOperation.EDIT);
    this._toolbarOrder.push(ZaOperation.DELETE);
    this._toolbarOrder.push(ZaOperation.SEP);
    this._toolbarOrder.push(ZaOperation.CLOSE);

    this._toolbarOperations[ZaOperation.NEW] = new ZaOperation(ZaOperation.NEW,
            com_zimbra_delegatedadmin.Bt_grant, com_zimbra_delegatedadmin.Grant_New_tt,
            "Permission", "PermissionDis",
            new AjxListener(this, this.addGrantsListener));

    this._toolbarOperations[ZaOperation.EDIT] = new ZaOperation(ZaOperation.EDIT,
            ZaMsg.TBB_Edit,com_zimbra_delegatedadmin.Grant_Edit_tt,
            "Properties", "PropertiesDis",
            new AjxListener(this, this.editGrantsListener));

    this._toolbarOperations[ZaOperation.DELETE] = new ZaOperation(ZaOperation.DELETE,
            com_zimbra_delegatedadmin.Bt_revoke, com_zimbra_delegatedadmin.Grant_Delete_tt,
    "Delete", "DeleteDis",
            new AjxListener(this, this.deleteGrantsListener));
   
    this._toolbarOperations[ZaOperation.CLOSE] = new ZaOperation(ZaOperation.CLOSE,
            ZaMsg.TBB_Close, ZaMsg.ALTBB_Close_tt, "Close", "CloseDis",
            new AjxListener(this, this.closeButtonListener));

    this._toolbarOperations[ZaOperation.SEP] = new ZaOperation(ZaOperation.SEP);

}
//ZaController.initToolbarMethods["ZaAllGrantsViewController"].push(ZaAllGrantsViewController.initToolbarMethod);
*/
ZaAllGrantsViewController.initPopupMenuMethod =
function () {
    this._popupOrder.push(ZaOperation.NEW);
    this._popupOrder.push(ZaOperation.EDIT);
    this._popupOrder.push(ZaOperation.DELETE);
    this._popupOrder.push(ZaOperation.CLOSE);

    this._popupOperations[ZaOperation.NEW] = new ZaOperation(ZaOperation.NEW,
            com_zimbra_delegatedadmin.Bt_grant, com_zimbra_delegatedadmin.Grant_New_tt,
            "Permission", "PermissionDis",
            new AjxListener(this, this.addGrantsListener));

    this._popupOperations[ZaOperation.EDIT] = new ZaOperation(ZaOperation.EDIT,
            ZaMsg.TBB_Edit,com_zimbra_delegatedadmin.Grant_Edit_tt,
            "Properties", "PropertiesDis",
            new AjxListener(this, this.editGrantsListener));

    this._popupOperations[ZaOperation.DELETE] = new ZaOperation(ZaOperation.DELETE,
            com_zimbra_delegatedadmin.Bt_revoke, com_zimbra_delegatedadmin.Grant_Delete_tt,
    "Delete", "DeleteDis",
            new AjxListener(this, this.deleteGrantsListener));

    this._popupOperations[ZaOperation.CLOSE] = new ZaOperation(ZaOperation.CLOSE,
            ZaMsg.TBB_Close, ZaMsg.ALTBB_Close_tt, "Close", "CloseDis",
            new AjxListener(this, this.closeButtonListener));
}
ZaController.initPopupMenuMethods["ZaAllGrantsViewController"].push(ZaAllGrantsViewController.initPopupMenuMethod);

ZaAllGrantsViewController.changeActionsStateMethod =
function () {
	if(this._contentView.getObject().currentTab == 1) {
	    var selected = this._contentView.getSelectedDirectGrant();
	    if (!selected || !selected instanceof Array || selected.length == 0) {
	        this._popupOperations[ZaOperation.DELETE].setEnabled(false);
	        this._popupOperations[ZaOperation.EDIT].setEnabled(false);
	    } else if (selected.length == 1) {
	        this._popupOperations[ZaOperation.DELETE].setEnabled(true);
	        this._popupOperations[ZaOperation.EDIT].setEnabled(true);
	    } else if (selected.length > 1) {
	        this._popupOperations[ZaOperation.DELETE].setEnabled(true);
	        this._popupOperations[ZaOperation.EDIT].setEnabled(false);
	    }
	} else {
        this._popupOperations[ZaOperation.DELETE].setEnabled(false);
        this._popupOperations[ZaOperation.EDIT].setEnabled(false);
	}
}
ZaController.changeActionsStateMethods["ZaAllGrantsViewController"].push(ZaAllGrantsViewController.changeActionsStateMethod);

ZaAllGrantsViewController.prototype.getAppBarAction = function () {
    if (AjxUtil.isEmpty(this._appbarOperation)) {
    	this._appbarOperation = {};
        this._appbarOperation[ZaOperation.CLOSE] = new ZaOperation(ZaOperation.CLOSE, ZaMsg.TBB_Close, ZaMsg.ALTBB_Close_tt, "", "", new AjxListener(this, this.closeButtonListener));
    }

    return this._appbarOperation;
}

ZaAllGrantsViewController.prototype.closeButtonListener = function() {
    var tree = ZaZimbraAdmin.getInstance().getOverviewPanelController().getOverviewPanel().getFolderTree();
    var rootItem = tree.getCurrentRootItem();
    var rootPath = tree.getABPath(rootItem.getData("dataItem"));
    tree.setSelectionByPath(rootPath, undefined, undefined, undefined, undefined, undefined, true);
}

ZaAllGrantsViewController.prototype.getPopUpOperation =
function() {
    return this._popupOperations;
}

ZaAllGrantsViewController.prototype.editGrantsListener = function () {
    var form = this._contentView._localXForm ;
    var directGrantsListViewItem = form.getItemsById (ZaGrant.A3_directGrantsList) [0] ;

    var selectedGrants = directGrantsListViewItem.getSelection();
    this._currentObject._uuid = "grantee" + this._currentObject.id;
    if (selectedGrants && selectedGrants.length == 1) {
    	var item = selectedGrants [0] ;
    	

        var obj = ZaUtil.deepCloneObject (item, ["_evtMgr"]);
        this._currentObject._uuid = obj._uuid = "grantee_" + obj[ZaGrant.A_right] + "_" + this._currentObject.id;
        obj.name = this._currentObject.grantee;
        
        this.editRigthDlg = new ZaGrantDialog (
                ZaApp.getInstance().getAppCtxt().getShell(),
                this._currentObject,
                ZaApp.getInstance(), 
                com_zimbra_delegatedadmin.Title_edit_rights + " (" +  this._currentObject.grantee + ")",
                ZaGrant.A_grantee, 
                true);

        this.editRigthDlg.registerCallback(ZaGrantDialog.EDIT_FINISH_BUTTON,
                ZaGrantDialog.prototype.editRightAndFinish, this.editRigthDlg,
                [form, item, false]);
        
        if (obj[ZaGrant.A_right].indexOf("get.") == 0 || obj[ZaGrant.A_right].indexOf("set.")== 0) {
            obj[ZaGrant.A_right_type] = "inline" ;
            obj [ZaGrant.A_inline_right] = ZaGrantDialog.getInlineRightAttrsByName (obj[ZaGrant.A_right]) ;
        } else { //if it is not "inline", it must be "system"
            obj[ZaGrant.A_right_type] = "system" ;
        }
        obj[ZaGrant.A2_isAdmin] = this._currentObject [ZaGrant.A2_isAdmin];
        if((obj[ZaGrant.A_grantee_type] == ZaGrant.GRANTEE_TYPE.usr || obj[ZaGrant.A_grantee_type] == ZaGrant.GRANTEE_TYPE.grp) && obj[ZaGrant.A2_isAdmin] == "1")
            this.editRigthDlg.targetTypeChoices.setChoices(ZaZimbraRights.targetType);
        else this.editRigthDlg.targetTypeChoices.setChoices([ZaItem.ACCOUNT, ZaItem.DL, ZaItem.DOMAIN, ZaItem.GLOBAL_GRANT]);
        this.editRigthDlg.targetTypeChoices.dirtyChoices();

        this.editRigthDlg.setObject(obj);
        this.editRigthDlg.popup();
        this.editRigthDlg.refresh () ;
    }
}

ZaAllGrantsViewController.prototype.addGrantsListener = function () {
    var newGrant = new ZaGrant();
    
	var obj = {};
	obj._uuid = "grantee" + this._currentObject.id;
	obj.name = this._currentObject.grantee;
	obj[ZaGrant.A_grantee] = this._currentObject [ZaGrant.A_grantee];
    obj[ZaGrant.A_grantee_type] = this._currentObject [ZaGrant.A_grantee_type];
    obj[ZaGrant.A2_isAdmin] = this._currentObject [ZaGrant.A2_isAdmin];

    obj.setAttrs = {} ;
    obj.setAttrs.all = true ;
    
	this.grantRightDlg = new ZaGrantDialog (
            ZaApp.getInstance().getAppCtxt().getShell(),
            obj,
            ZaApp.getInstance(),
            com_zimbra_delegatedadmin.Title_grant_rights + " (" + obj.name + ")",
            ZaGrant.A_grantee, false);

    this.grantRightDlg.registerCallback(ZaGrantDialog.ADD_FINISH_BUTTON,
                ZaGrantDialog.prototype.grantRight,
                this.grantRightDlg, [this._contentView._localXForm, false]);
        this.grantRightDlg.registerCallback(ZaGrantDialog.ADD_MORE_BUTTON,
               ZaGrantDialog.prototype.grantRight,
                this.grantRightDlg, [this._contentView._localXForm, true]);



    if((obj[ZaGrant.A_grantee_type] == ZaGrant.GRANTEE_TYPE.usr || obj[ZaGrant.A_grantee_type] == ZaGrant.GRANTEE_TYPE.grp) && obj[ZaGrant.A2_isAdmin] == "1")
        this.grantRightDlg.targetTypeChoices.setChoices(ZaZimbraRights.targetType);
    else this.grantRightDlg.targetTypeChoices.setChoices([ZaItem.ACCOUNT, ZaItem.DL, ZaItem.DOMAIN, ZaItem.GLOBAL_GRANT]);
    this.grantRightDlg.targetTypeChoices.dirtyChoices();

    this.grantRightDlg.setObject(obj);
	this.grantRightDlg.popup();
    this.grantRightDlg.refresh ();
}


ZaAllGrantsViewController.prototype.revokeGrant = function () {
    var form = this._contentView._localXForm ;
    var directGrantsListViewItem = form.getItemsById (ZaGrant.A3_directGrantsList) [0] ;
    var selectedGrants = directGrantsListViewItem.getSelection();
    if (selectedGrants && selectedGrants.length > 0) {
        for (var i = 0; i < selectedGrants.length; i ++) {
// TODO: when multiselection enabled, we need a progress dialog to show the progress
            if (ZaGrant.revokeMethod (selectedGrants[i])) {
// fire the removal event.
                this.fireRemovalEvent (selectedGrants[i]) ;
            } else {
                break ; //jump out if failed.
            }
        }
    }

    this.revokeRightDlg.popdown () ;
}

ZaAllGrantsViewController.prototype.deleteGrantsListener = function () {
    var form = this._contentView._localXForm ;
    var directGrantsListViewItem = form.getItemsById (ZaGrant.A3_directGrantsList) [0] ;

    var selectedGrant = directGrantsListViewItem.getSelection();
    if (selectedGrant && selectedGrant.length >= 1) {
        if(!this.revokeRightDlg) {
            this.revokeRightDlg = new ZaMsgDialog (
                    ZaApp.getInstance().getAppCtxt().getShell(),
                    null, [DwtDialog.YES_BUTTON, DwtDialog.NO_BUTTON]);
        }
        this.revokeRightDlg.registerCallback(DwtDialog.YES_BUTTON, this.revokeGrant, this, null);
        var confirmMsg =  com_zimbra_delegatedadmin.confirm_delete_grants + ZaTargetPermission.getDlMsgFromGrant(selectedGrant) ;
        this.revokeRightDlg.setMessage (confirmMsg,  DwtMessageDialog.INFO_STYLE) ;
        this.revokeRightDlg.popup ();
    } else {
        ZaApp.getInstance().getCurrentController().popupMsgDialog (com_zimbra_delegatedadmin.no_grant_selected_msg) ;
    }
}

/**
 *    @method setViewMethod
 *    @param entry - isntance of ZaAccount class
 */
ZaAllGrantsViewController.setViewMethod =
function(entry) {
    try {
        if (!this._UICreated) {
  //          this._initToolbar();
            this._initPopupMenu();
            //make sure these are last

            //this._toolbar = new ZaToolBar(this._container, this._toolbarOperations, this._toolbarOrder);
//            this._editBt = this._toolbar.getButton (ZaOperation.EDIT);
//            this._deleteBt = this._toolbar.getButton (ZaOperation.DELETE );
           
            this._contentView = this._view = new this.tabConstructor(this._container, entry);
            var elements = new Object();
            elements[ZaAppViewMgr.C_APP_CONTENT] = this._view;
            ZaApp.getInstance().getAppViewMgr().createView(this.getContentViewId(), elements);
            this._UICreated = true;
            //associate the controller with the view by viewId
            ZaApp.getInstance()._controllers[this.getContentViewId()] = this;
        }
        ZaApp.getInstance().pushView(this.getContentViewId());

        entry[ZaModel.currentTab] = "1";
        this._currentObject = entry;
        this._currentObject._uuid = entry.id;
        this._view.setObject(entry);


    } catch (ex) {
        this._handleException(ex, "ZaAllGrantsViewController.prototype._setView", null, false);
    }
}
ZaController.setViewMethods["ZaAllGrantsViewController"].push(ZaAllGrantsViewController.setViewMethod);



/**
* @param ev
* This listener is invoked by ZaGrantController or any other controller that can create an ZaGrant object
**/
ZaAllGrantsViewController.prototype.handleGrantCreation =
function (ev) {
	if(ev) {
		//add the new ZaGrant to the controlled list
        var grant = ev.getDetails() ;
		if (grant != null) {
            var directGrantsList = this._currentObject [ZaGrant.A3_directGrantsList] ;
            directGrantsList.push (grant) ;

			if (this._contentView)  {
                var xform = this._contentView._localXForm ;
                xform.setInstanceValue (directGrantsList,ZaGrant.A3_directGrantsList ) ;
            }
		}
	}
}

/**
* @param ev
* This listener is invoked by ZaGrantController or any other controller that can remove an ZaGrant object
**/
ZaAllGrantsViewController.prototype.handleGrantRemoval =
function (ev) {
	if(ev) {
        var grant = ev.getDetails() ;
              if (grant != null) {
              var directGrantsList = this._currentObject [ZaGrant.A3_directGrantsList] ;
              AjxUtil.arrayRemove (directGrantsList, grant) ;
              if (this._contentView)  {
                var xform = this._contentView._localXForm ;
                xform.setInstanceValue (directGrantsList,ZaGrant.A3_directGrantsList ) ;
              }                    
		}
	}
}
