/*
 * ***** BEGIN LICENSE BLOCK *****
 * Zimbra Collaboration Suite, Network Edition.
 * Copyright (C) 2005, 2006, 2007, 2008, 2009, 2012, 2013, 2014 Zimbra, Inc.  All Rights Reserved.
 * ***** END LICENSE BLOCK *****
 */
/**
* @class ZaBackup
* @contructor ZaBackup
* this class is a model for doing backup and restore operations
* @author Greg Solovyev
**/
function ZaBackup() {
	ZaItem.call(this, "ZaBackup");
	this[ZaBackup.A_label] = "";
	this.server = "";
	this.accounts = null;
	this.live=0;
	this[ZaServerBackup.A_activateOperation] = 0;
	this[ZaModel.currentStep] = 1;
	this[ZaBackup.A_pageNumber] = 1;
	this[ZaBackup.A_target] = ZaHotBackup.DEFAULT_BACKUP_TARGET;
	this[ZaBackup.A_accountListStatus] = ZaBackup.ACC_LIST_STATUS_NONE;
	this[ZaBackup.A_backupListOffset] = 0;
	this[ZaBackup.A_backupListCount] = ZaSettings.RESULTSPERPAGE;
	this[ZaBackup.A_accountListOffset] = 0;
	this[ZaBackup.A_accountListCount] = 0;	
	this[ZaBackup.A_create] = false;
}

ZaBackup.prototype = new ZaItem;
ZaBackup.prototype.constructor = ZaBackup;
ZaBackup.A_serverId = "serverId";
ZaBackup.A_serverName = "serverName";
ZaBackup.A_target = "target";
ZaBackup.A_label = "label";
ZaBackup.A_fromDate = "list";
ZaBackup.A_backupLabelList = "backupLabelList";
ZaBackup.A_selectedLabels = "selectedlabels";
ZaBackup.A_method = "method";
ZaBackup.A_accountPool = "accountPool";
ZaBackup.A_Accounts = "accounts";
ZaBackup.A_more = "more";
ZaBackup.A_from = "from";
ZaBackup.A_to = "to";
ZaBackup.A_type = "type";
ZaBackup.A_incrLabel = "incr-label";
ZaBackup.A_backupListOffset = "backupListOffset";
ZaBackup.A_backupListCount = "backupListCount";
ZaBackup.A_accountListStatus = "accountListStatus";
ZaBackup.A_accountListOffset = "accountListOffset";
ZaBackup.A_accountListCount = "accountListCount";
ZaBackup.A_failedAccountListOffset = "failedAccountListOffset";
ZaBackup.A_failedAccountListCount = "failedccountListCount";
ZaBackup.A_moreFailedAcc = "moreFailedAcc";
ZaBackup.A_directory = "directory";
ZaBackup.A_create = "create";
ZaBackup.A_writable = "writable";
ZaBackup.A_readable = "readable";
ZaBackup.A_exists = "exists";

ZaBackup.A_pageNumber = "pageNumber";
ZaBackup.A_failedAccPageNumber = "failedAccPageNumber"
ZaBackup.METHOD_INCREMENTAL = "incremental";
ZaBackup.METHOD_FULL = "full";
ZaBackup.METHOD_ABORT = "abort";


ZaBackup.ACC_LIST_STATUS_NONE = "NONE";
ZaBackup.ACC_LIST_STATUS_ALL = "ALL";
ZaBackup.ACC_LIST_STATUS_ERROR = "ERROR";
/**
* @method static queryBackups
* @param serverId:string - zimbraId of the server to which the SOAP request will be sent
* @param target:string - path to the location of backups
* @param label:string
* @param fromDate:timestamp
* @param verbose:Boolean
* @param callback:AjxCallback - callback that will be invoked by ZmCsfeCommand
**/
/*
ZaBackup.queryBackups = 
function (serverId, target, label, fromDate, toDate, limit, verbose, callback) {
	var soapDoc = AjxSoapDoc.create("BackupQueryRequest", "urn:zimbraAdmin", null);
	var queryEl = soapDoc.set("query", "");
	if(target) {
		queryEl.setAttribute("target", AjxStringUtil.trim(target, true));
	}
	if(label) {
		queryEl.setAttribute("label", label);
	}

	if(verbose) {
		queryEl.setAttribute("verbose", verbose);
	}
	this.asynCommand = new ZmCsfeCommand();
	var params = new Object();
	params.soapDoc = soapDoc;	
	if(callback) {
	
		params.asyncMode = true;
		params.callback = callback;
		params.targetServer = serverId;
//		params.useXml = true;		
	}
	this.asynCommand.invoke(params);	
}*/

ZaBackup.queryBackups = 
function (obj,callback) {
	var soapDoc = AjxSoapDoc.create("BackupQueryRequest", "urn:zimbraAdmin", null);
	var queryEl = soapDoc.set("query", "");
	if(obj[ZaBackup.A_target]) {
		queryEl.setAttribute(ZaBackup.A_target, AjxStringUtil.trim(obj[ZaBackup.A_target], true));
	}
	if(obj[ZaBackup.A_label]) {
		queryEl.setAttribute(ZaBackup.A_label, obj[ZaBackup.A_label]);
	}

	if(obj[ZaBackup.A_backupListOffset] != null) {
		queryEl.setAttribute(ZaBackup.A_backupListOffset, obj[ZaBackup.A_backupListOffset]);
	}

	if(obj[ZaBackup.A_backupListCount] != null) {
		queryEl.setAttribute(ZaBackup.A_backupListCount, obj[ZaBackup.A_backupListCount]);
	}
	
	if(obj[ZaBackup.A_to]) {
		queryEl.setAttribute(ZaBackup.A_to, obj[ZaBackup.A_to]);
	}
	
	if(obj[ZaBackup.A_from]) {
		queryEl.setAttribute(ZaBackup.A_from, obj[ZaBackup.A_from]);
	}	
		
	if(obj[ZaBackup.A_accountListOffset] != null) {
		queryEl.setAttribute(ZaBackup.A_accountListOffset, obj[ZaBackup.A_accountListOffset]);
	}

	if(obj[ZaBackup.A_accountListCount] != null) {
		queryEl.setAttribute(ZaBackup.A_accountListCount, obj[ZaBackup.A_accountListCount]);
	}
		
	if(obj[ZaBackup.A_accountListStatus] != null) {
		queryEl.setAttribute(ZaBackup.A_accountListStatus, obj[ZaBackup.A_accountListStatus]);
	}		
	
	if(obj[ZaBackup.A_type] != null) {
		queryEl.setAttribute(ZaBackup.A_type, obj[ZaBackup.A_type]);
	}
	this.asynCommand = new ZmCsfeCommand();
	var params = new Object();
	params.soapDoc = soapDoc;
	params.noAuthToken = true;	
	if(callback) {
		params.asyncMode = true;
		params.callback = callback;
		params.targetServer = obj[ZaBackup.A_serverId];
	}
	this.asynCommand.invoke(params);	
}


ZaBackup.queryFailedAccounts = 
function (obj,callback) {
	var soapDoc = AjxSoapDoc.create("BackupQueryRequest", "urn:zimbraAdmin", null);
	var queryEl = soapDoc.set("query", "");
	if(obj[ZaBackup.A_target]) {
		queryEl.setAttribute(ZaBackup.A_target, AjxStringUtil.trim(obj[ZaBackup.A_target], true));
	}
	if(obj[ZaBackup.A_label]) {
		queryEl.setAttribute(ZaBackup.A_label, obj[ZaBackup.A_label]);
	}
	
	if(obj[ZaBackup.A_failedAccountListOffset] != null) {
		queryEl.setAttribute(ZaBackup.A_accountListOffset, obj[ZaBackup.A_failedAccountListOffset]);
	}

	if(obj[ZaBackup.A_failedAccountListCount] != null) {
		queryEl.setAttribute(ZaBackup.A_accountListCount, obj[ZaBackup.A_failedAccountListCount]);
	}

	queryEl.setAttribute(ZaBackup.A_accountListStatus, ZaBackup.ACC_LIST_STATUS_ERROR);
	
	this.asynCommand = new ZmCsfeCommand();
	var params = new Object();
	params.soapDoc = soapDoc;	
	params.noAuthToken = true;
	if(callback) {
		params.asyncMode = true;
		params.callback = callback;
		params.targetServer = obj[ZaBackup.A_serverId];
	}
	this.asynCommand.invoke(params);	
}
/**
* @method static runBackupQuery
* @param serverId:string - zimbraId of the server to which the SOAP request will be sent
* @param method:string - full|incremental|abort
* @param target:string - path to the location of backups
* @param accounts:Array - array of account names 
* @param callback:AjxCallback - callback that will be invoked by ZmCsfeCommand
**/
ZaBackup.runBackupQuery = function (serverId,method,target,accounts,backupLabel,callback) {
	var soapDoc = AjxSoapDoc.create("BackupRequest", "urn:zimbraAdmin", null);
	var backupEl = soapDoc.set("backup", "");
	if(target && method != ZaBackup.METHOD_INCREMENTAL) {
		backupEl.setAttribute("target", AjxStringUtil.trim(target, true));
	}
	if(method) {
		backupEl.setAttribute("method", method);
		if(method == ZaBackup.METHOD_ABORT) {
			if(backupLabel) {
				backupEl.setAttribute("label", AjxStringUtil.trim(backupLabel, true));			
			} else {
				throw(new AjxException(com_zimbra_backuprestore.ERROR_BACKUP_TITLE_3, AjxException.INVALID_PARAM, "ZaBackup.runBackupQuery", com_zimbra_backuprestore.ERROR_BACKUP_3));
			}
		}
	}	
	if(!accounts && method!=ZaBackup.METHOD_ABORT) {
		throw(new AjxException(com_zimbra_backuprestore.ERROR_BACKUP_TITLE_2, AjxException.INVALID_PARAM, "ZaBackup.runBackupQuery", com_zimbra_backuprestore.ERROR_BACKUP_2));
	} else if (method!=ZaBackup.METHOD_ABORT) { 
		var cnt = accounts.length;
		for(var i = 0; i < cnt; i ++) {
			var accEl = soapDoc.set("account", "", backupEl);
			accEl.setAttribute("name", accounts[i]);
		}
	}	
	this.asynCommand = new ZmCsfeCommand();
	var params = new Object();
	params.soapDoc = soapDoc;
	params.noAuthToken = true;	
	if(callback) {
		params.asyncMode = true;
		params.callback = callback;
		params.targetServer = serverId;
	}
	this.asynCommand.invoke(params);	
}
/**
* @method static queryAccountBackup
* @param serverId:string - zimbraId of the server to which the SOAP request will be sent
* @param target:string - path to the location of backups
* @param accounts:Array - array of account names 
* @param callback:AjxCallback - callback that will be invoked by ZmCsfeCommand
**/
/*
ZaBackup.queryAccountBackup = 
function (serverId, target, accounts, callback) {
	var soapDoc = AjxSoapDoc.create("BackupAccountQueryRequest", "urn:zimbraAdmin", null);
	var queryEl = soapDoc.set("query", "");
	if(target) {
		queryEl.setAttribute("target", AjxStringUtil.trim(target, true));
	}
	if(!accounts) {
		throw(new AjxException("accounts parameter cannot be null", AjxException.INVALID_PARAM, "ZaBackup.queryAccountBackup", com_zimbra_backuprestore.ERROR_BACKUP_1));
	} 
	var cnt = accounts.length;
	for(var i = 0; i < cnt; i ++) {
		var accEl = soapDoc.set("a", "", queryEl);
		accEl.setAttribute("name", accounts[i]);
	}
	
	this.asynCommand = new ZmCsfeCommand();
	var params = new Object();
	params.soapDoc = soapDoc;	
	if(callback) {
		params.asyncMode = true;
		params.callback = callback;
		params.targetServer = serverId;
		params.useXml = true;
	}
	this.asynCommand.invoke(params);	
}*/
ZaBackup.queryAccountBackup = 
function (obj, callback) {
	var soapDoc = AjxSoapDoc.create("BackupAccountQueryRequest", "urn:zimbraAdmin", null);
	var queryEl = soapDoc.set("query", "");
	if(obj[ZaBackup.A_target]) {
		queryEl.setAttribute(ZaBackup.A_target, AjxStringUtil.trim(obj[ZaBackup.A_target], true));
	}
	if(obj[ZaBackup.A_type]) {
		queryEl.setAttribute(ZaBackup.A_type, obj[ZaBackup.A_type]);
	}
	if(obj[ZaBackup.A_to]) {
		queryEl.setAttribute(ZaBackup.A_to, obj[ZaBackup.A_to]);
	}
	if(obj[ZaBackup.A_from]) {
		queryEl.setAttribute(ZaBackup.A_from, obj[ZaBackup.A_from]);
	}	
	if(obj[ZaBackup.A_backupListOffset]) {
		queryEl.setAttribute(ZaBackup.A_backupListOffset, obj[ZaBackup.A_backupListOffset]);
	}		
	if(obj[ZaBackup.A_backupListCount]) {
		queryEl.setAttribute(ZaBackup.A_backupListCount, obj[ZaBackup.A_backupListCount]);
	}
	if(!obj[ZaRestore.A_accountNames]) {
		throw(new AjxException("accounts parameter cannot be null", AjxException.INVALID_PARAM, "ZaBackup.queryAccountBackup", com_zimbra_backuprestore.ERROR_BACKUP_1));
	} 
	var accounts = obj[ZaRestore.A_accountNames];
	var cnt = accounts.length;
	for(var i = 0; i < cnt; i ++) {
		var accEl = soapDoc.set("account", "", queryEl);
		accEl.setAttribute("name", accounts[i]);
	}
	
	this.asynCommand = new ZmCsfeCommand();
	var params = new Object();
	params.soapDoc = soapDoc;
	params.noAuthToken = true;	
	if(callback) {
		params.asyncMode = true;
		params.callback = callback;
		params.targetServer = obj[ZaBackup.A_serverId];
	}
	this.asynCommand.invoke(params);	
}

ZaBackup.queryTargetPath = 
function (obj,callback) {
	var soapDoc = AjxSoapDoc.create("CheckDirectoryRequest", "urn:zimbraAdmin", null);
	var queryEl = soapDoc.set(ZaBackup.A_directory, "");
	if(obj[ZaBackup.A_target]) {
		queryEl.setAttribute("path", AjxStringUtil.trim(obj[ZaBackup.A_target], true));
	}
	if(obj[ZaBackup.A_create]) {
		queryEl.setAttribute("create", "1");
	} else {
		queryEl.setAttribute("create", "0");		
	}
	

	var command = new ZmCsfeCommand();
	var params = new Object();
	params.soapDoc = soapDoc;
	params.noAuthToken = true;	
	if(callback) {
		params.asyncMode = true;
		params.callback = callback;
		params.targetServer = obj[ZaBackup.A_serverId];
		command.invoke(params);	
	} else {
		return command.invoke(params);
	}

}
