/*
 * ***** BEGIN LICENSE BLOCK *****
 * Zimbra Collaboration Suite, Network Edition.
 * Copyright (C) 2006, 2007, 2008, 2009, 2012, 2013, 2014 Zimbra, Inc.  All Rights Reserved.
 * ***** END LICENSE BLOCK *****
 */
/**
* @class ZaBackupLabel
* @contructor ZaBackupLabel
* @author Greg Solovyev
**/
function ZaBackupLabel() {
	ZaItem.call(this,  "ZaBackupLabel");
	this.label = "";
	this[ZaBackup.A_pageNumber] = 1;
	this.live=0;
	this[ZaBackup.A_accountListOffset] = 0;
	this[ZaBackup.A_accountListCount] = 0;
	this[ZaBackup.A_accountListStatus] = ZaBackup.ACC_LIST_STATUS_ALL ;
	this[ZaModel.currentTab] = 1;
	this[ZaBackupLabel.A_accounts] = [];
	this[ZaBackupLabel.A_accounts]._version=1;
	this[ZaBackupLabel.A_failedAccounts] = [];
	this[ZaBackupLabel.A_failedAccounts]._version=1;
}
ZaItem.loadMethods["ZaBackupLabel"] = new Array();
ZaItem.initMethods["ZaBackupLabel"] = new Array();

ZaBackupLabel.prototype = new ZaItem;
ZaBackupLabel.prototype.constructor = ZaBackupLabel;
ZaBackupLabel.A_type = "type";
ZaBackupLabel.A_label = "label";
ZaBackupLabel.A_live = "live";
ZaBackupLabel.A_aborted = "aborted";
ZaBackupLabel.A_status = "status";
ZaBackupLabel.A_start = "start";
ZaBackupLabel.A_total = "total";
ZaBackupLabel.A_end = "end";
ZaBackupLabel.A_accounts = "accounts";
ZaBackupLabel.A_failedAccounts = "failedAccounts";

ZaBackupLabel.A_account = "account";
ZaBackupLabel.A_error = "error";
ZaBackupLabel.A_moreAccounts = "more";
ZaBackupLabel.A_content = "_content";
ZaBackupLabel.A_completionCount = "completionCount";
ZaBackupLabel.A_errorCount = "errorCount";
ZaBackupLabel.A_completedAccounts = "completedAccounts";
ZaBackupLabel.A_currAccounts = "currentAccounts";
ZaBackupLabel.A_errorMessage = "errorMessage";

ZaBackupLabel.TYPE_INCREMENTAL = "incremental";
ZaBackupLabel.TYPE_FULL = "full";

ZaBackupLabel.STATUS_NOTSTARTED = "NOTSTARTED";
ZaBackupLabel.STATUS_INPROGRESS = "INPROGRESS";
ZaBackupLabel.STATUS_COMPLETED = "COMPLETED";
ZaBackupLabel.STATUS_ERROR = "ERROR";

ZaBackupLabel.prototype.toString = function () {
	return [this[ZaBackupLabel.A_label],this[ZaBackupLabel.A_start],this[ZaBackupLabel.A_end],this[ZaBackupLabel.A_live]].join(",");
}

ZaBackupLabel.prototype.initFromJS = function (obj) {
	if(obj instanceof Array)
		obj = obj[0];
		
	this[ZaBackupLabel.A_error] = [];
	this[ZaBackupLabel.A_type] = obj[ZaBackupLabel.A_type];
    this[ZaBackupLabel.A_label] = obj[ZaBackupLabel.A_label];
    this[ZaBackupLabel.A_live] = obj[ZaBackupLabel.A_live];
    this[ZaBackupLabel.A_aborted] = obj[ZaBackupLabel.A_aborted];
    this[ZaBackupLabel.A_start] = obj[ZaBackupLabel.A_start];
    this[ZaBackupLabel.A_end] = obj[ZaBackupLabel.A_end];
    
    if(obj[ZaBackupLabel.A_error]) { 
    	this[ZaBackupLabel.A_error] = obj[ZaBackupLabel.A_error];
    }

    if(obj[ZaBackupLabel.A_accounts] && obj[ZaBackupLabel.A_accounts][0]) { 
    	this[ZaBackup.A_more] = obj[ZaBackupLabel.A_accounts][0][ZaBackup.A_more];
    	this[ZaBackupLabel.A_total] = obj[ZaBackupLabel.A_accounts][0][ZaBackupLabel.A_total];
    	this[ZaBackupLabel.A_completionCount] = obj[ZaBackupLabel.A_accounts][0][ZaBackupLabel.A_completionCount];
    	this[ZaBackupLabel.A_errorCount] = obj[ZaBackupLabel.A_accounts][0][ZaBackupLabel.A_errorCount];
    	this[ZaBackupLabel.A_moreAccounts] = obj[ZaBackupLabel.A_accounts][0][ZaBackupLabel.A_moreAccounts];
    	if(obj[ZaBackupLabel.A_accounts][0][ZaBackupLabel.A_account] && obj[ZaBackupLabel.A_accounts][0][ZaBackupLabel.A_account] instanceof Array) {
	    	var cnt = obj[ZaBackupLabel.A_accounts][0][ZaBackupLabel.A_account].length;
	    	for(var i =0; i< cnt; i++) {
	    		this[ZaBackupLabel.A_accounts].push(obj[ZaBackupLabel.A_accounts][0][ZaBackupLabel.A_account][i]);
	    	}
	    	 
    	}	
    }

    if(obj[ZaBackupLabel.A_currAccounts] && obj[ZaBackupLabel.A_currAccounts][0]) { 
    	if(obj[ZaBackupLabel.A_currAccounts][0][ZaBackupLabel.A_account] && obj[ZaBackupLabel.A_currAccounts][0][ZaBackupLabel.A_account] instanceof Array) {
	    	this[ZaBackupLabel.A_currAccounts] = obj[ZaBackupLabel.A_currAccounts][0][ZaBackupLabel.A_account];
    	}	
    }
    
   
    if(obj[ZaBackupLabel.A_currAccounts] && typeof(obj[ZaBackupLabel.A_currAccounts]) == "string") {
    	if (obj[ZaBackupLabel.A_currAccounts].indexOf(",")>-1) {
		    this[ZaBackupLabel.A_currAccounts] = obj[ZaBackupLabel.A_currAccounts].split(",");
    	} else {
    		this[ZaBackupLabel.A_currAccounts] = [obj[ZaBackupLabel.A_currAccounts]];
    	}
    }
    
    this[ZaBackupLabel.A_status] = (
    	(this[ZaBackupLabel.A_live] == "0" ||  this[ZaBackupLabel.A_live] == false) 
    		? 
	    	(
	    		((obj[ZaBackupLabel.A_error] && obj[ZaBackupLabel.A_error].length>0) || this[ZaBackupLabel.A_errorCount]>0) 
	    		?
	    			com_zimbra_backuprestore.BNR_CompletedErrors 
	    		: 
	    			(obj[ZaBackupLabel.A_aborted] ? com_zimbra_backuprestore.BNR_Aborted : com_zimbra_backuprestore.BNR_Completed)
	    	) 
	    : 
	     (((obj[ZaBackupLabel.A_error] && obj[ZaBackupLabel.A_error].length>0)|| this[ZaBackupLabel.A_errorCount]>0) ? com_zimbra_backuprestore.BNR_RunningErrors : com_zimbra_backuprestore.BNR_Status_Running));    
}

ZaBackupLabel.loadMethod = 
function(by, val) {
	var soapDoc = AjxSoapDoc.create("BackupQueryRequest", "urn:zimbraAdmin", null);
	var queryEl = soapDoc.set("query", "");
	queryEl.setAttribute("target", AjxStringUtil.trim(this[ZaBackup.A_target], true));
	queryEl.setAttribute("label", this[ZaBackupLabel.A_label]);
	queryEl.setAttribute(ZaBackup.A_accountListStatus, ZaBackup.ACC_LIST_STATUS_ALL);
	queryEl.setAttribute(ZaBackup.A_accountListCount, ZaSettings.RESULTSPERPAGE);
	var synCommand = new ZmCsfeCommand();
	var params = new Object();
	params.soapDoc = soapDoc;	
	//params.useXml = true;		
	params.noAuthToken = true;
	params.asyncMode = false;
	var backup = synCommand.invoke(params).Body.BackupQueryResponse.backup;
	this.initFromJS(backup);
}
ZaItem.loadMethods["ZaBackupLabel"].push(ZaBackupLabel.loadMethod);


/**
* Returns HTML for a tool tip for this account.
*/
ZaBackupLabel.prototype.getToolTip =
function() {
	// update/null if modified
	if (!this._toolTip) {
		var html = new Array(20);
		var idx = 0;
		html[idx++] = "<table cellpadding='0' cellspacing='0' border='0'>";
		html[idx++] = "<tr valign='center'><td colspan='2' align='left'>";
		html[idx++] = "<div style='border-bottom: 1px solid black; white-space:nowrap; overflow:hidden;width:350' >";
		html[idx++] = "<table cellpadding='0' cellspacing='0' border='0' style='width:100%;'>";
		html[idx++] = "<tr valign='center'><td><b>";
		html[idx++] = this[ZaBackupLabel.A_label];
		html[idx++] = "</b></td><td align='right'>";
		html[idx++] = AjxImg.getImageHtml("Backup");		
		html[idx++] = "</td>";
		html[idx++] = "</table></div></td></tr>";
		if(this[ZaBackupLabel.A_total]) {
			html[idx++] = "<tr><td colspan='2' align='center'>";
			html[idx++] = this[ZaBackupLabel.A_total];
			html[idx++] = " ";
			html[idx++] = com_zimbra_backuprestore.BNR_Accounts;
			if(this[ZaBackupLabel.A_completionCount] > 0) {
				html[i++] = "( ";			
				html[i++] = com_zimbra_backuprestore.BNR_Completed;
				html[i++] = ": ";			
				html[i++] = this[ZaBackupLabel.A_completionCount];
				html[i++] = " )";						
			}
			html[idx++] = "</td></tr>";
		}
		html[idx++] = "</table>";
		this._toolTip = html.join("");
	}
	return this._toolTip;
}

ZaBackupLabel.myXModel = {
	items:[
		{id:ZaBackupLabel.A_accounts, type:_LIST_, listItem:{type:_STRING_}}
	]
}
