/*
 * ***** BEGIN LICENSE BLOCK *****
 * Zimbra Collaboration Suite, Network Edition.
 * Copyright (C) 2008, 2009, 2010, 2011, 2012, 2014 Zimbra, Inc.  All Rights Reserved.
 * ***** END LICENSE BLOCK *****
 */
/**
 * This is used to add the extension views to the main admin console UI
 *
 *
 **/

if(ZaSettings && ZaSettings.EnabledZimlet["com_zimbra_delegatedadmin"]){
	if(window.console && window.console.log) console.log("Loaded ZaDelegatedAdminExt.js");

	function ZaDelegatedAdminExt() {
	};

//ZaSettings.RIGHTS_ENABLED = true ;
//ZaSettings.GRANTS_ENABLED = true ;
ZaEvent.S_RIGHT = ZaEvent.EVENT_SOURCE_INDEX++;
ZaEvent.S_GRANT = ZaEvent.EVENT_SOURCE_INDEX++;
ZaItem.RIGHT = "right";
ZaItem.GRANT = "grant";

ZaZimbraAdmin._RIGHTS = ZaZimbraAdmin.VIEW_INDEX++;
ZaZimbraAdmin._RIGHTS_LIST_VIEW = ZaZimbraAdmin.VIEW_INDEX++;
ZaZimbraAdmin._GRANTS = ZaZimbraAdmin.VIEW_INDEX++;
ZaZimbraAdmin._GLOBAL_GRANTS_LIST_VIEW = ZaZimbraAdmin.VIEW_INDEX++;

ZaSettings.RIGHT_LIST_VIEW = "rightListView";
ZaSettings.ALL_UI_COMPONENTS.push({ value: ZaSettings.RIGHT_LIST_VIEW, label: com_zimbra_delegatedadmin.UI_Comp_RightListView });
ZaSettings.OVERVIEW_CONFIG_ITEMS.push(ZaSettings.RIGHT_LIST_VIEW);
ZaSettings.GLOBAL_PERMISSION_VIEW = "globalPermissionView";
ZaSettings.ALL_UI_COMPONENTS.push({ value: ZaSettings.GLOBAL_PERMISSION_VIEW, label: com_zimbra_delegatedadmin.UI_Comp_GlobalPermView });
ZaSettings.OVERVIEW_CONFIG_ITEMS.push(ZaSettings.GLOBAL_PERMISSION_VIEW);
ZaSettings.DOMAIN_ACCT_LIMIT_TAB = "viewAdminConsoleDomainLimitsTab";

if (ZaOverviewPanelController.treeModifiers) {
    ZaOverviewPanelController.treeModifiers.push(ZaRight.rightsOvTreeModifier);
    ZaOverviewPanelController.treeModifiers.push(ZaGrant.grantsOvTreeModifier);
}

ZaApp.prototype.getRightViewController =
function(viewId) {
    if (viewId && this._controllers[viewId] != null) {
        return this._controllers[viewId];
    } else {
        var c = this._controllers[viewId] = new ZaRightViewController(this._appCtxt, this._container, this);
        return c;
    }
}

ZaApp.prototype.getRightsListController =
function() {
    if (this._controllers[ZaZimbraAdmin._RIGHTS_LIST_VIEW] == null) {
        this._controllers[ZaZimbraAdmin._RIGHTS_LIST_VIEW] = new ZaRightsListViewController(this._appCtxt, this._container, this);
    }
    return this._controllers[ZaZimbraAdmin._RIGHTS_LIST_VIEW];
}


ZaApp.prototype.getGrantViewController =
function(viewId) {
    if (viewId && this._controllers[viewId] != null) {
        return this._controllers[viewId];
    } else {
        var c = this._controllers[viewId] = new ZaGrantViewController(this._appCtxt, this._container, this);
        return c;
    }
}

ZaApp.prototype.getGlobalGrantListController =
function() {
    if (this._controllers[ZaZimbraAdmin._GLOBAL_GRANTS_LIST_VIEW] == null) {
        this._controllers[ZaZimbraAdmin._GLOBAL_GRANTS_LIST_VIEW] = new ZaGlobalGrantListViewController(this._appCtxt, this._container, this);
    }
    return this._controllers[ZaZimbraAdmin._GLOBAL_GRANTS_LIST_VIEW];
}


//Add the View Rights toolbar button
ZaOperation.VIEW_EFFECTIVE_RIGHTS = ++ ZA_OP_INDEX;
ZaOperation.CONFIG_GRANTS = ++ ZA_OP_INDEX ;

if (ZaController.initPopupMenuMethods["ZaAccountListController"]) {
    ZaAccountListController.initExtraPopupMethod = function () {
        //if (ZaZimbraAdmin.isGlobalAdmin()) {
              this._popupOperations[ZaOperation.CONFIG_GRANTS] =
                        new ZaOperation(ZaOperation.CONFIG_GRANTS, com_zimbra_delegatedadmin.bt_config_grants,
                        com_zimbra_delegatedadmin.bt_config_grants_tt, "Permission", "PermissionDis",
                        new AjxListener(this, ZaDelegatedAdminExt._configGrantsListener)
                    );
        //}
	this._popupOperations[ZaOperation.VIEW_EFFECTIVE_RIGHTS] =
        		new ZaOperation(ZaOperation.VIEW_EFFECTIVE_RIGHTS, com_zimbra_delegatedadmin.ACTBB_ViewRights,
                	com_zimbra_delegatedadmin.ACTBB_ViewRights_tt,"RightObject", "RightObjectDis",
                	new AjxListener(this, ZaDelegatedAdminExt._viewRightsListener)
                );
    }
    ZaController.initPopupMenuMethods["ZaAccountListController"].push(ZaAccountListController.initExtraPopupMethod);
}


if(ZaController.initPopupMenuMethods["ZaDomainListController"]) {
    ZaDomainListController.initExtraPopupMethod = function () {
        this._popupOperations[ZaOperation.CONFIG_GRANTS] =
            new ZaOperation(ZaOperation.CONFIG_GRANTS, com_zimbra_delegatedadmin.bt_config_grants,
            com_zimbra_delegatedadmin.bt_config_grants_tt, "Permission", "PermissionDis",
            new AjxListener(this, ZaDelegatedAdminExt._configGrantsListener)
        );
    }
    ZaController.initPopupMenuMethods["ZaDomainListController"].push(ZaDomainListController.initExtraPopupMethod);
}

ZaDelegatedAdminExt._viewRightsListener =
function (ev) {
    var item ;
    if (this instanceof ZaAccountListController) {
        var selectedItems = this._contentView.getSelection() ;
        if (selectedItems && selectedItems.length == 1) {
            item = selectedItems [0];
        }
    } else if (this instanceof ZaAccountViewController || this instanceof ZaDLController) {
        item = this._currentObject;
    }

    if (item != null) {
        var effectiveRights = new ZaEffectiveRights(item);
        effectiveRights.load();
        var erCtrl = new ZaEffectiveRightsViewController(this._appCtxt, this._container) ;
        erCtrl.show(effectiveRights, true);
    }
}

ZaDelegatedAdminExt._configGrantsListener =
function (ev) {
    var item ;
    var allGrants = {} ;
    if (this instanceof ZaAccountListController) {
        var selectedItems = this._contentView.getSelection() ;
        if (selectedItems && selectedItems.length == 1) {
            item = selectedItems [0];
            if(item.attrs[ZaAccount.A_zimbraIsAdminAccount] == "TRUE"
                    || item.attrs[ZaAccount.A_zimbraIsDelegatedAdminAccount] == "TRUE"
                    || item.attrs[ZaDistributionList.A_isAdminGroup] == "TRUE")
                allGrants[ZaGrant.A2_isAdmin] = "1";
            else allGrants[ZaGrant.A2_isAdmin] = "0";
        }
    } else if (this instanceof ZaDomainListController) {
        var selectedItems = this._contentView.getSelection() ;
        item = selectedItems [0];
        allGrants[ZaGrant.A2_isAdmin] = "0";
    } else if (this instanceof ZaAccountViewController) {
        item = this._currentObject;
        if(item.attrs[ZaAccount.A_zimbraIsAdminAccount] == "TRUE"
                || item.attrs[ZaAccount.A_zimbraIsDelegatedAdminAccount] == "TRUE")
            allGrants[ZaGrant.A2_isAdmin] = "1";
        else allGrants[ZaGrant.A2_isAdmin] = "0";
    } else if (this instanceof ZaDLController || this instanceof ZaDomainController) {
        item = this._currentObject;
        if (item.attrs[ZaDistributionList.A_isAdminGroup] == "TRUE") {
            allGrants[ZaGrant.A2_isAdmin] = "1";
        } else {
            allGrants[ZaGrant.A2_isAdmin] = "0";
        }
    }

    if (item != null) {
        allGrants[ZaGrant.A_grantee] = item.name;
        allGrants[ZaGrant.A_grantee_id] = item.id;
        allGrants[ZaGrant.A2_grantsListSelectedItems] = [];
        allGrants[ZaGrant.A3_directGrantsList] = [];
        allGrants[ZaGrant.A3_indirectGrantsList] = [];

        var granteeType ;
        if (item.type == ZaItem.ACCOUNT) {
            granteeType = ZaGrant.GRANTEE_TYPE.usr ;
        }  else if (item.type == ZaItem.DL) {
            granteeType = ZaGrant.GRANTEE_TYPE.grp ;
        } else if(item.type == ZaItem.DOMAIN)
            granteeType = "dom";

        allGrants[ZaGrant.A_grantee_type] = granteeType ;

        var params = {
            isAllGrants: true ,
            grantee: {
                type: granteeType ,
                all: "1",
                val: item.name,
                by: "name"
            }
        };
        var allGrantsList = ZaGrant.load.call(item, params) ;
        for (var i = 0; i < allGrantsList.length; i ++) {

            if ( allGrantsList[i][ZaGrant.A_grantee] == allGrants[ZaGrant.A_grantee] ) {
                allGrants[ZaGrant.A3_directGrantsList].push (allGrantsList[i]) ;
            } else {
                allGrants[ZaGrant.A3_indirectGrantsList].push (allGrantsList[i]) ;               
            }
        }

        var erCtrl = new ZaAllGrantsViewController (this._appCtxt, this._container) ;
        erCtrl.show(allGrants, true);
    }
}

ZaDelegatedAdminExt.changeActionsStateMethod =
function () {
    if (!this._contentView)
        return;

    var cnt = this._contentView.getSelectionCount();
    if (cnt == 1) {
        var item = this._contentView.getSelection()[0];
        if (item) {
            if (item.type != ZaItem.ACCOUNT && item.type != ZaItem.DL && item.type != ZaItem.DOMAIN) {
                if (this._popupOperations[ZaOperation.VIEW_EFFECTIVE_RIGHTS]) {
                    this._popupOperations[ZaOperation.VIEW_EFFECTIVE_RIGHTS].enabled = false;
                }

                if (this._popupOperations[ZaOperation.CONFIG_GRANTS]) {
                    this._popupOperations[ZaOperation.CONFIG_GRANTS].enabled = false;
                }
            }else {
                ZaDelegatedAdminExt.checkRights.call (this, item) ;
            }
        } else {
            if (this._popupOperations[ZaOperation.VIEW_EFFECTIVE_RIGHTS]) {
                this._popupOperations[ZaOperation.VIEW_EFFECTIVE_RIGHTS].enabled = false;
            }

            if (this._popupOperations[ZaOperation.CONFIG_GRANTS]) {
                this._popupOperations[ZaOperation.CONFIG_GRANTS].enabled = false;
            }
        }
    } else {
        if (this._popupOperations[ZaOperation.VIEW_EFFECTIVE_RIGHTS]) {
            this._popupOperations[ZaOperation.VIEW_EFFECTIVE_RIGHTS].enabled = false;
        }

        if (this._popupOperations[ZaOperation.CONFIG_GRANTS]) {
            this._popupOperations[ZaOperation.CONFIG_GRANTS].enabled = false;
        }

    }
}
ZaController.changeActionsStateMethods["ZaAccountListController"].push(ZaDelegatedAdminExt.changeActionsStateMethod);
ZaController.changeActionsStateMethods["ZaDomainListController"].push(ZaDelegatedAdminExt.changeActionsStateMethod);



//Add the view rights button to the account view
if (ZaController.initPopupMenuMethods["ZaAccountViewController"]) {
    ZaAccountViewController.initExtraPopupMethod = function () {
        this._popupOperations[ZaOperation.VIEW_EFFECTIVE_RIGHTS] =
                new ZaOperation(ZaOperation.VIEW_EFFECTIVE_RIGHTS, com_zimbra_delegatedadmin.ACTBB_ViewRights,
                        com_zimbra_delegatedadmin.ACTBB_ViewRights_tt,"RightObject", "RightObjectDis",
                        new AjxListener(this, ZaDelegatedAdminExt._viewRightsListener)
                );

        this._popupOperations[ZaOperation.CONFIG_GRANTS] =
                new ZaOperation(ZaOperation.CONFIG_GRANTS, com_zimbra_delegatedadmin.bt_config_grants,
                        com_zimbra_delegatedadmin.bt_config_grants_tt, "Permission", "PermissionDis",
                        new AjxListener(this, ZaDelegatedAdminExt._configGrantsListener)
                );
    }
    ZaController.initPopupMenuMethods["ZaAccountViewController"].push(ZaAccountViewController.initExtraPopupMethod);
}


//Add the view rights button to the DL view
if (ZaController.initPopupMenuMethods["ZaDLController"]) {
    ZaDLController.initExtraPopupMethod = function () {
        this._popupOperations[ZaOperation.VIEW_EFFECTIVE_RIGHTS] =
                new ZaOperation(ZaOperation.VIEW_EFFECTIVE_RIGHTS, com_zimbra_delegatedadmin.ACTBB_ViewRights,
                        com_zimbra_delegatedadmin.ACTBB_ViewRights_tt,"RightObject", "RightObjectDis",
                        new AjxListener(this, ZaDelegatedAdminExt._viewRightsListener)
                );

        this._popupOperations[ZaOperation.CONFIG_GRANTS] =
                new ZaOperation(ZaOperation.CONFIG_GRANTS, com_zimbra_delegatedadmin.bt_config_grants,
                        com_zimbra_delegatedadmin.bt_config_grants_tt, "Permission", "PermissionDis",
                        new AjxListener(this, ZaDelegatedAdminExt._configGrantsListener)
                );
    }
    ZaController.initPopupMenuMethods["ZaDLController"].push(ZaDLController.initExtraPopupMethod);
}

//Add the view rights button to the Domain view
if (ZaController.initPopupMenuMethods["ZaDomainController"]) {
    ZaDomainController.initExtraPopupMethod = function () {
        this._popupOperations[ZaOperation.CONFIG_GRANTS] =
                new ZaOperation(ZaOperation.CONFIG_GRANTS, com_zimbra_delegatedadmin.bt_config_grants,
                        com_zimbra_delegatedadmin.bt_config_grants_tt, "Permission", "PermissionDis",
                        new AjxListener(this, ZaDelegatedAdminExt._configGrantsListener)
                );
    }
    ZaController.initPopupMenuMethods["ZaDomainController"].push(ZaDomainController.initExtraPopupMethod);
}

ZaDelegatedAdminExt.changeViewActionStateMethod = function () {
    if (!this._currentObject)
        return;
    ZaDelegatedAdminExt.checkRights.call (this, this._currentObject) ;
}
ZaController.changeActionsStateMethods["ZaAccountViewController"].push(ZaDelegatedAdminExt.changeViewActionStateMethod);
ZaController.changeActionsStateMethods["ZaDLController"].push(ZaDelegatedAdminExt.changeViewActionStateMethod);
ZaController.changeActionsStateMethods["ZaDomainController"].push(ZaDelegatedAdminExt.changeViewActionStateMethod);

//check whether "View Rights" or "Configure Grants" button should be enabled based on the rights
ZaDelegatedAdminExt.checkRights = function (item) {
    if (!item) return ;
    if (AjxUtil.isEmpty(item.rights) && item.id) {
        item.loadEffectiveRights("id", item.id, false) ;
    }
    //if account is global admin "View Rights" and "Configure Grants" button should be disabled
    if(item.attrs[ZaAccount.A_zimbraIsAdminAccount] == "TRUE"){
        if (this._popupOperations != null){
            if (this._popupOperations[ZaOperation.VIEW_EFFECTIVE_RIGHTS]) {
                this._popupOperations[ZaOperation.VIEW_EFFECTIVE_RIGHTS].enabled = false;
            }
        }
        if (this._popupOperations != null) {
        	if (this._popupOperations[ZaOperation.CONFIG_GRANTS]) {
        		this._popupOperations[ZaOperation.CONFIG_GRANTS].enabled = false;
        	}
        }
        return;
    } else if (this._popupOperations != null) {
        this._popupOperations[ZaOperation.CONFIG_GRANTS].enabled =
            ZaItem.hasReadPermission(ZaItem.A_zimbraACE, item);
    }

    if (((item.type == ZaItem.ACCOUNT) && ZaItem.hasRight(ZaRight.VIEW_RIGHTS_USR_RIGHT, item)
            && (item.attrs[ZaAccount.A_zimbraIsAdminAccount] == "TRUE" || item.attrs[ZaAccount.A_zimbraIsDelegatedAdminAccount] == "TRUE"))
          || ((item.type == ZaItem.DL) && ZaItem.hasRight(ZaRight.VIEW_RIGHTS_GRP_RIGHT, item)
		&& item.attrs[ZaDistributionList.A_isAdminGroup] == "TRUE")){
        //good, admin has the right to "view rights" on this target
//        console.log("Enable View Rights") ;
    } else {
        if (this._popupOperations != null){
            if (this._popupOperations[ZaOperation.VIEW_EFFECTIVE_RIGHTS]) {
                this._popupOperations[ZaOperation.VIEW_EFFECTIVE_RIGHTS].enabled = false;
            }
        }
    }
}

}


