/*
 * ***** BEGIN LICENSE BLOCK *****
 * Zimbra Collaboration Suite, Network Edition.
 * Copyright (C) 2011, 2012, 2013, 2014 Zimbra, Inc.  All Rights Reserved.
 * ***** END LICENSE BLOCK *****
 */
/**
 * Created by IntelliJ IDEA.
 * User: qinan
 * Date: 5/13/11
 * Time: 4:05 PM
 * To change this template use File | Settings | File Templates.
 */

function ZaRightsSearchXFormView (parent) {
	ZaTabView.call(this, parent,"ZaRightsSearchXFormView", "DwtTabView ZaXFormListView", ZaId.TAB_VIEWRIGHTS);
	this.initForm(ZaRight.myXModel,this.getMyXForm());
	this._localXForm.removeListener(DwtEvent.XFORMS_VALUE_CHANGED, this.formChangeListener);
	this._localXForm.setController(ZaApp.getInstance());
}

ZaRightsSearchXFormView.prototype = new ZaTabView();
ZaRightsSearchXFormView.prototype.constructor = ZaRightsSearchXFormView;
ZaTabView.XFormModifiers["ZaRightsSearchXFormView"] = new Array();

ZaRightsSearchXFormView.prototype.toString =
function() {
	return "ZaRightsSearchXFormView";
}

ZaRightsSearchXFormView.prototype.getTabTitle =
function () {
	return com_zimbra_delegatedadmin.manage_rights_title ;
}

ZaRightsSearchXFormView.prototype.getTabIcon =
function () {
	return "RightObject";
}

ZaRightsSearchXFormView.prototype.setObject =
function (entry) {
    var instance = this._localXForm.getInstance()
    if(!instance) instance = {};
    if(!entry)
        instance[ZaRight.A2_allRightsList] = [];
    else instance[ZaRight.A2_allRightsList] = entry.getArray();
    if(!instance[ZaRight.A2_searchRightQuery])
        instance[ZaRight.A2_filteredRightsList] = instance[ZaRight.A2_allRightsList];
    instance[ZaRight.A2_filterType] = "all";
    this._localXForm.setInstance(instance);

}

ZaRightsSearchXFormView.getCustomHeight = function () {
	try {
		var form = this.getForm();
		var formParentElement = this.getForm().parent.getHtmlElement();
		var totalHeight = parseInt(formParentElement.style.height);
		if(isNaN(totalHeight)) {
			totalHeight = formParentElement.clientHeight ? formParentElement.clientHeight : formParentElement.offsetHeight;
		}
		var formHeaders = form.getItemsById("xform_header");
		var headerHeight = 0;
		if(formHeaders) {
			var formHeader = formHeaders[0];
			if(formHeader) {
				headerHeight = formHeader.getElement().clientHeight ? formHeader.getElement().clientHeight : formHeader.getElement().offsetHeight;
			}
		}
		if(totalHeight<=0)
			return "100%";
		else
			return totalHeight - headerHeight - 2;
	} catch (ex) {

	}
	return "100%";
};

ZaRightsSearchXFormView.getCustomWidth = function () {
	try {

		var form = this.getForm();
		var formParentElement = this.getForm().parent.getHtmlElement();
		var totalWidth = parseInt(formParentElement.style.width);
		if(isNaN(totalWidth)) {
			totalWidth = formParentElement.clientWidth ? formParentElement.clientWidth : formParentElement.offsetWidth;
		}

		if(totalWidth<=0)
			return "100%";
		else
			return totalWidth;
	} catch (ex) {

	}
	return "100%";
};

ZaRightsSearchXFormView.onSelectionListener = function(ev) {
	if (ev.detail == DwtListView.ITEM_DBL_CLICKED) {
		if(ev.item) {
			this._selectedItem = ev.item;
			ZaApp.getInstance().getRightViewController().show(ev.item);
            var parentPath = ZaTree.getPathByArray([ZaMsg.OVP_home, ZaMsg.OVP_configure, com_zimbra_delegatedadmin.OVP_rights]);
            ZaZimbraAdmin.getInstance().getOverviewPanelController().addObjectItem(parentPath, ev.item.name, null, false, false, ev.item);
		}
	} else {
		ZaApp.getInstance().getRightsListController().changeActionsState();
	}
}

ZaRightsSearchXFormView.rightsFilter = function(allrights, name, type, sensitive) {
    var result = [];
    if(!allrights)  return result;
    if(!name && !type) return allrights;

    for(var i = 0; i < allrights.length; i++) {
        var flag_name = true;
        var flag_type = true;
        var right = allrights[i];
        var iscase = sensitive?sensitive:"FALSE";

        if(name) {
            if(iscase == "TRUE" && right.attrs[ZaRight.A_name].indexOf(name) < 0)
                flag_name = false;
            else if(iscase == "FALSE" && right.attrs[ZaRight.A_name].toLowerCase().indexOf(name.toLowerCase()) < 0)
                flag_name = false;
        }
        if(type && right.attrs[ZaRight.A_type] != type)
            flag_type = false;

        if(flag_name && flag_type) result.push(right);

    }

    return result;
}

ZaRightsSearchXFormView.querySearch = function(ev) {
    var instance = this.getInstance();
    if(!instance)
        return;

    var query = instance[ZaRight.A2_searchRightQuery];
    var type = instance[ZaRight.A2_filterType];
    var sensitive = instance[ZaRight.A2_filterCaseSensitiveEnabled];
    var allrights = instance[ZaRight.A2_allRightsList];
    var result = ZaRightsSearchXFormView.rightsFilter(allrights,query,(type=="all"?null:type),sensitive);
    this.getModel().setInstanceValue(instance, ZaRight.A2_filteredRightsList, result) ;
}

ZaRightsSearchXFormView.createPopupMenu = function (listWidget) {
	popupOperations = [new ZaOperation(ZaOperation.EDIT, ZaMsg.TBB_View, com_zimbra_delegatedadmin.RIGHT_View_tt, "Properties", "PropertiesDis", new AjxListener(this, ZaRightsSearchXFormView.viewRightsListener))];

	listWidget.actionMenu = new ZaPopupMenu(listWidget, "ActionMenu", null, popupOperations);
	listWidget.addActionListener(new AjxListener(listWidget, ZaRightsSearchXFormView.listActionListener));
	listWidget.xFormItem = this;
}

ZaRightsSearchXFormView.listActionListener = function (ev) {
	this.actionMenu.popup(0, ev.docX, ev.docY);
}

ZaRightsSearchXFormView.viewRightsListener = function (ev) {
    var selection = this.getSelection();
    if(selection.length > 0)
        ZaApp.getInstance().getRightViewController().show(selection[0]);
}

ZaRightsSearchXFormView.myXFormModifier = function(xFormObject) {
	xFormObject.tableCssStyle="width:100%;overflow:auto;";

	xFormObject.items = [
		{type:_GROUP_, visibilityChecks:[], colSizes:["100px","120px","3px","*","80px","30px","100px"], numCols:7, width:"100%", id:"xform_header",
			items:[
                {type: _OSELECT1_, ref:ZaRight.A2_filterType, label: com_zimbra_delegatedadmin.LBL_searchRights,
                   labelLocation: _LEFT_, choices: ZaRight.FILTER_TYPE_CHOICES, align:_RIGHT_
                },
				{type:_TEXTFIELD_, width:"100%", ref:ZaRight.A2_searchRightQuery,
					containerCssClass:"search_field_container", label:"",
					cssClass:"search_input", visibilityChecks:[], enableDisableChecks:[],
                    elementChanged: function(elementValue,instanceValue, event) {
                              var charCode = event.charCode;
                              if (charCode == 13 || charCode == 3) {
                                  ZaRightsSearchXFormView.querySearch.call(this);
                              } else {
                                  this.getForm().itemChanged(this, elementValue, event);
                              }
                    }
				},
				{type:_DWT_BUTTON_, label:com_zimbra_delegatedadmin.BTL_searchButton, id: "searchRightButton",
					onActivate:ZaRightsSearchXFormView.querySearch,
                    visibilityChecks:[], enableDisableChecks:[]
                },
                {ref:ZaRight.A2_filterCaseSensitiveEnabled, type:_CHECKBOX_,subLabel:"",
                    msgName:com_zimbra_delegatedadmin.LBL_searchCaseSensitive, labelLocation: _RIGHT_,
                    label:com_zimbra_delegatedadmin.LBL_searchCaseSensitive, trueValue:"TRUE", falseValue:"FALSE"
                }
			]
		},
		{type:_SPACER_, colSpan:3},
	        {ref:ZaRight.A2_filteredRightsList, colSpan:3,cssClass: "ZaFullPageXFormListView",
	    	        onSelection:ZaRightsSearchXFormView.onSelectionListener,
                        type:_DWT_LIST_,
	   		forceUpdate: true,createPopupMenu:ZaRightsSearchXFormView.createPopupMenu,
	   		multiselect:false, widgetClass:ZaRightsListView,headerList:ZaRightsListView._getHeaderList(),
                        getCustomHeight:ZaRightsSearchXFormView.getCustomHeight,
	   		getCustomWidth:ZaRightsSearchXFormView.getCustomWidth, visibilityChecks:[], enableDisableChecks:[]
	   	}
	];
};
ZaTabView.XFormModifiers["ZaRightsSearchXFormView"].push(ZaRightsSearchXFormView.myXFormModifier);
