/*
 * ***** BEGIN LICENSE BLOCK *****
 * Zimbra Collaboration Suite, Network Edition.
 * Copyright (C) 2009, 2010, 2011, 2013, 2014 Zimbra, Inc.  All Rights Reserved.
 * ***** END LICENSE BLOCK *****
 */
if(ZaSettings && ZaSettings.EnabledZimlet["com_zimbra_delegatedadmin"]){

function ZaUIComponent () {}
ZaUIComponent.A_inheritedUIComponents = "inheritedUIComponents";

//zimbraAdminConsoleUIComponents   view in account permission view
ZaUIComponent.accountTargetXFormModifier = function (xFormObject, entry) {

    //check if the UI component is enabled
    var uiEnabled  = ZaTabView.isTAB_ENABLED(entry,[ZaAccount.A_zimbraAdminConsoleUIComponents], []);
    // it should only be meaningful for delegated admins
    uiEnabled = (uiEnabled && ZaDelegatedAdmin.isDelegatedAdmin (entry));

    if (!uiEnabled) return ;

    var tabBar, switchGroup, tabIx ;
    for (var i=0; i < xFormObject.items.length; i ++) {
        if (xFormObject.items[i].type == _TAB_BAR_) {
            tabBar = xFormObject.items[i] ;
        }

        if (xFormObject.items[i].type == _SWITCH_) {
            switchGroup = xFormObject.items[i]
        }
    }

    if (tabBar && switchGroup) {
        tabIx = ++this.TAB_INDEX;
        tabBar.choices.push({value:tabIx, label: com_zimbra_delegatedadmin.Tab_ui_components}) ;
    }

    var caseItem = {type:_ZATABCASE_, id:"target_form_ui_comp_tab", numCols:1, colSizes:["800px"],
            caseKey:  tabIx,
            items:[
                {type: _SPACER_, height: 10},    
                { type: _DWT_ALERT_, width: "98%",
				    style: DwtAlert.INFORMATION, iconVisible: false,
                    content: com_zimbra_delegatedadmin.HELP_NOTES_UI_COMP },
                { type: _DWT_ALERT_, width: "98%",
                    style: DwtAlert.INFORMATION, iconVisible: true,
                    visibilityChecks: [ ZaUIComponent.isCartBlancheUISet ],
                    content: com_zimbra_delegatedadmin.CartBlacheUIEnabled },
                {type:_TOP_GROUPER_, label: com_zimbra_delegatedadmin.Label_ui_comp, id:"ui_comp_grouper",
                    colSizes:["800px"],numCols:1 ,
                    items : ZaUIComponent.getUIComponentsXFormItem ()
                }
            ]
    };

    switchGroup.items.push(caseItem);
    return ;
}

ZaUIComponent.UIComponentsItem = {
    id: ZaAccount.A_zimbraAdminConsoleUIComponents, ref: "attrs/" + ZaAccount.A_zimbraAdminConsoleUIComponents,
    outputType: _LIST_,    //it is important to set the attr value in OSELECT_XFormItem
    type: _LIST_, listItems: { type: _STRING_ }
};

ZaUIComponent.InheritedUIComponentsItem = {
    id: ZaUIComponent.A_inheritedUIComponents, ref: ZaUIComponent.A_inheritedUIComponents,
    outputType: _LIST_,    //it is important to set the attr value in OSELECT_XFormItem
    type: _LIST_, listItems: { type: _STRING_ }
};

ZaUIComponent.isCartBlancheUISet = function () {
    var value = this.getInstanceValue (ZaAccount.A_zimbraAdminConsoleUIComponents) ;
    if (value != null) {
        for (var i = 0; i < value.length; i ++) {
            if (value [i] == ZaSettings.CARTE_BLANCHE_UI)  {
                return true ;
            }
        }
    }

    return false ;
}

ZaUIComponent.isCartBlancheUINotSet = function () {
    return ! ZaUIComponent.isCartBlancheUISet.call (this) ;
}

ZaUIComponent.getUIComponentsXFormItem  = function (choiceWidth) {
    var w = choiceWidth || 400 ;
    var list =
        { type: _GROUP_, colSpan:"*", numCols: 2, colSize: [w, w], items: [
               {type: _OUTPUT_, value: com_zimbra_delegatedadmin.tLabel_direct_ui_comp,
                   cssStyle: "font-size:12px;",
                   align: _LEFT_ },
               {type: _OUTPUT_, value: com_zimbra_delegatedadmin.tLabel_indirect_ui_comp,
                   cssStyle: "font-size:12px;",
                   align: _LEFT_ },
               {type:_ZA_CHECKBOX_LIST_, numCols: 1, colSizes: [ w], choicesWidth: w,
                    selectRef:ZaAccount.A_zimbraAdminConsoleUIComponents,
                    ref:ZaAccount.A_zimbraAdminConsoleUIComponents,
                    enableDisableChecks : [ ZaUIComponent.isCartBlancheUINotSet ],
                    choices:ZaSettings.ALL_UI_COMPONENTS
               } ,
               { type:_ZA_CHECKBOX_LIST_, numCols: 1, colSizes: [ w], choicesWidth: w,
//                    ref:ZaUIComponent.A_inheritedUIComponents,
                    selectRef:ZaUIComponent.A_inheritedUIComponents,
                    enableDisableChecks: false,
                    choices:ZaSettings.ALL_UI_COMPONENTS
               }
            ]
        };

    return [list];
}

/**
 * set the  ZaUIComponent.A_inheritedUIComponents
 */

ZaUIComponent.accountObjectModifer =
function () {
    var inheritedUIComps = [];
    var comps = [];
    var permission = "";
    if(ZaItem.DL == this._containedObject.type) {
    	permission = ZaDistributionList.RIGHT_VIEW_ADMINUI_COMPONENTS;	
    } else if(ZaItem.ACCOUNT == this._containedObject.type) {
    	permission = ZaAccount.RIGHT_VIEW_ADMINUI_COMPONENTS;
    }
    
    if(permission != "" && ZaItem.hasRight(permission,this._containedObject)) {
    	comps = ZaSettings.getUIComponents (this._containedObject) ;
    }
    
    for(var i=0;i<comps.length;i++) {
        if (comps[i].inherited) {
            inheritedUIComps.push(comps[i]._content) ;
        }
    }

    this._containedObject [ZaUIComponent.A_inheritedUIComponents] = inheritedUIComps ;

    //keep the assign default da views and rights checkbox checked if assign the rights succeed
    var controller = ZaApp.getInstance ().getCurrentController () ;
    if ( controller._currentObject && controller._currentObject [ZaAccount.A2_isAssignDefaultDARights] == "TRUE" ) {
        this._containedObject [ZaAccount.A2_isAssignDefaultDARights] = "TRUE" ;    
    }
}

ZaUIComponent.uiCompObjectModifer = function () {
    if (this.attrs[ZaAccount.A_zimbraAdminConsoleUIComponents]) {
        if(!(this.attrs[ZaAccount.A_zimbraAdminConsoleUIComponents] instanceof Array)) {
            this.attrs[ZaAccount.A_zimbraAdminConsoleUIComponents] = [this.attrs[ZaAccount.A_zimbraAdminConsoleUIComponents]];
        }
    }
}

if (ZaAccount) {
    ZaAccount.myXModel.items.push(ZaUIComponent.UIComponentsItem);
    ZaAccount.myXModel.items.push(ZaUIComponent.InheritedUIComponentsItem);
}

if (ZaItem.ObjectModifiers["ZaAccount"]){
    ZaItem.ObjectModifiers["ZaAccount"].push(ZaUIComponent.uiCompObjectModifer) ;
}

if (ZaTabView.ObjectModifiers["ZaAccountXFormView"]){
    ZaTabView.ObjectModifiers["ZaAccountXFormView"].push(ZaUIComponent.accountObjectModifer) ;
}

if (ZaTabView.ObjectModifiers["ZaDLXFormView"]){
    ZaTabView.ObjectModifiers["ZaDLXFormView"].push(ZaUIComponent.accountObjectModifer) ;
}


if (ZaTabView.XFormModifiers["ZaAccountXFormView"]){
    ZaSettings.ACCOUNT_UI_COMP_TAB = "accountUIComponentsTab" ;
//    ZaSettings.ALL_UI_COMPONENTS.push({ value: ZaSettings.ACCOUNT_UI_COMP_TAB, label: com_zimbra_delegatedadmin.UI_Comp_AccountsUICompTab });
    ZaTabView.XFormModifiers["ZaAccountXFormView"].push(ZaUIComponent.accountTargetXFormModifier);
}

if (ZaDistributionList) {
    ZaDistributionList.myXModel.items.push(ZaUIComponent.UIComponentsItem);
    ZaDistributionList.myXModel.items.push(ZaUIComponent.InheritedUIComponentsItem);
}

if (ZaItem.ObjectModifiers["ZaDistributionList"]){
    ZaItem.ObjectModifiers["ZaDistributionList"].push(ZaUIComponent.uiCompObjectModifer) ;
}

if (ZaTabView.XFormModifiers["ZaDLXFormView"]){
    ZaSettings.DL_UI_COMP_TAB = "dlUIComponentsTab" ;
//    ZaSettings.ALL_UI_COMPONENTS.push({ value: ZaSettings.DL_UI_COMP_TAB, label: com_zimbra_delegatedadmin.UI_Comp_dlUICompTab });
    ZaTabView.XFormModifiers["ZaDLXFormView"].push(ZaUIComponent.accountTargetXFormModifier);
}
}
