/*
 * ***** BEGIN LICENSE BLOCK *****
 * Zimbra Collaboration Suite, Network Edition.
 * Copyright (C) 2007, 2008, 2009, 2013, 2014 Zimbra, Inc.  All Rights Reserved.
 * ***** END LICENSE BLOCK *****
 */

function ZaXMBxAttachmentPicker(parent) {
	ZaXMBxPicker.call(this, parent, ZaXMBxPicker.ATTACHMENT);
    this._checkedItems = {};
};

ZaXMBxAttachmentPicker.prototype = new ZaXMBxPicker;
ZaXMBxAttachmentPicker.prototype.constructor = ZaXMBxAttachmentPicker;

ZaXMBxPicker.CTOR[ZaXMBxPicker.ATTACHMENT] = ZaXMBxAttachmentPicker;

ZaXMBxAttachmentPicker.NONE	= 1;
ZaXMBxAttachmentPicker.ANY	= 2;
ZaXMBxAttachmentPicker.SPEC	= 3;
ZaXMBxAttachmentPicker.FILE	= 4;
ZaXMBxAttachmentPicker.KNOWN = 5;
ZaXMBxAttachmentPicker.RADIO_BUTTONS = [ZaXMBxAttachmentPicker.NONE, ZaXMBxAttachmentPicker.ANY, ZaXMBxAttachmentPicker.SPEC, ZaXMBxAttachmentPicker.KNOWN, ZaXMBxAttachmentPicker.FILE];
ZaXMBxAttachmentPicker.MSG_KEY = new Object();
ZaXMBxAttachmentPicker.MSG_KEY[ZaXMBxAttachmentPicker.NONE]	= "XMBX_noAtt";
ZaXMBxAttachmentPicker.MSG_KEY[ZaXMBxAttachmentPicker.ANY]	= "XMBX_anyAtt";
ZaXMBxAttachmentPicker.MSG_KEY[ZaXMBxAttachmentPicker.KNOWN]= "XMBX_knownAtt";
ZaXMBxAttachmentPicker.MSG_KEY[ZaXMBxAttachmentPicker.SPEC]	= "XMBX_specAtt";
ZaXMBxAttachmentPicker.MSG_KEY[ZaXMBxAttachmentPicker.FILE]	= "XMBX_specFile";
ZaXMBxAttachmentPicker.RADIO_CHECKED = ZaXMBxAttachmentPicker.KNOWN;

ZaXMBxAttachmentPicker.ATT_KEY = "_att_";

ZaXMBxAttachmentPicker.prototype.toString = 
function() {
	return "ZaXMBxAttachmentPicker";
};

ZaXMBxAttachmentPicker.prototype._newType =
function(tree, atts) {
	var ti = new DwtTreeItem({parent:tree,className:"AdminTreeItem"});
	ti.setImage(atts[0].image);
	ti.setData(ZaXMBxAttachmentPicker.ATT_KEY, atts[0].desc);
	ti.setText(atts[0].desc);
	var types = new Array();
	for (var i = 0; i < atts.length; i++) {
		types.push(atts[i].type);
	}
	ti.setToolTipContent(types.join("<br />"));
	return ti;
};

ZaXMBxAttachmentPicker.prototype._newRadio =
function(radioId) {
	var html = new Array(5);
	var text = com_zimbra_xmbxsearch[ZaXMBxAttachmentPicker.MSG_KEY[radioId]];
	var checked = (radioId == ZaXMBxAttachmentPicker.RADIO_CHECKED) ? "checked" : "";
	var id = this._radioId[radioId];
	var i = 0;
	html[i++] = "<tr valign='middle'><td align='left'>";
	html[i++] = "<input type='radio' name='r'";
	html[i++] = checked;
	html[i++] = " id='";
	html[i++] = id;
	html[i++] = "'></td><td align='left'>";
	html[i++] = text;
	html[i++] = "</td></tr>";

	return html.join("");
};

ZaXMBxAttachmentPicker.prototype._setupRadio =
function(radioId) {
	var id = this._radioId[radioId];
	var rb = this._radio[radioId] = document.getElementById(id);
	Dwt.setHandler(rb, DwtEvent.ONCLICK, ZaXMBxAttachmentPicker._radioChange);
	rb._picker = this;
	rb._radioId = radioId;
};

ZaXMBxAttachmentPicker.prototype._setupPicker =
function(parent) {

	var picker = new DwtComposite(parent);

    this._radio = {};
    this._radioId = {};

	for (var i = 0; i < ZaXMBxAttachmentPicker.RADIO_BUTTONS.length; i++) {
		this._radioId[ZaXMBxAttachmentPicker.RADIO_BUTTONS[i]] = Dwt.getNextId();
	}

	var treeId = Dwt.getNextId();
	var fileDivId = Dwt.getNextId();
	var mimeDivId = Dwt.getNextId();	
	var fileInputId = Dwt.getNextId();
	var mimeInputId = Dwt.getNextId();	
	
	var html = new Array(10);
	var idx = 0;
	html[idx++] = "<table cellpadding='2' cellspacing='0' border='0'>";
	for (var i = 0; i < ZaXMBxAttachmentPicker.RADIO_BUTTONS.length; i++) {
		html[idx++] = this._newRadio(ZaXMBxAttachmentPicker.RADIO_BUTTONS[i]);
	}
	html[idx++] = "</table>";
	html[idx++] = "<div style='display:none; padding: 0 5' id='";
	html[idx++] = fileDivId;
	html[idx++] = "'><hr /><table border=0><tr><td width=1%>";
	html[idx++] = com_zimbra_xmbxsearch.XMBX_filename;
	html[idx++] = ":</td><td>";
	html[idx++] = Dwt.CARET_HACK_BEGIN;
	html[idx++] = "<input type='text' nowrap style='width:90%' id='";
	html[idx++] = fileInputId;
	html[idx++] = "'>";
	html[idx++] = Dwt.CARET_HACK_END;
	html[idx++] = "</td></tr></table></div>";
	html[idx++] = "<div id='";
	html[idx++] = treeId;
	html[idx++] = "'><hr /></div>";


	html[idx++] = "<div style='display:none; padding: 0 5' id='";
	html[idx++] = mimeDivId;
	html[idx++] = "'><hr /><table border=0><tr><td width=1%>";
	html[idx++] = com_zimbra_xmbxsearch.XMBX_mimename;
	html[idx++] = ":</td></tr><tr><td>";
	html[idx++] = Dwt.CARET_HACK_BEGIN;
	html[idx++] = "<textarea cols=20 rows=10 style='width:90%' id='";
	html[idx++] = mimeInputId;
	html[idx++] = "'></textarea>";
	html[idx++] = Dwt.CARET_HACK_END;
	html[idx++] = "</td></tr></table></div>";
	html[idx++] = "<div id='";
	html[idx++] = treeId;
	html[idx++] = "'><hr /></div>";
	picker.getHtmlElement().innerHTML = html.join("");

	for (var i = 0; i < ZaXMBxAttachmentPicker.RADIO_BUTTONS.length; i++) {
		this._setupRadio(ZaXMBxAttachmentPicker.RADIO_BUTTONS[i]);
	}

	// set up filename input field
	this._fileNameDiv = document.getElementById(fileDivId);
	this._mimeNameDiv = document.getElementById(mimeDivId);
	this._fileNameInput = document.getElementById(fileInputId);
	this._mimeNameInput = document.getElementById(mimeInputId);	
	Dwt.setHandler(this._fileNameInput, DwtEvent.ONKEYUP, ZaXMBxAttachmentPicker._onChange);
	Dwt.setHandler(this._mimeNameInput, DwtEvent.ONKEYUP, ZaXMBxAttachmentPicker._onChange);	
	Dwt.associateElementWithObject(this._fileNameInput, this,fileInputId );
	Dwt.associateElementWithObject(this._mimeNameInput, this, mimeInputId);	

	// set up attachment tree widget
	this._tree = new DwtTree(picker, DwtTree.CHECKEDITEM_STYLE);
	this._tree.addSelectionListener(new AjxListener(this, this._treeListener));	

	this._attsByDesc = {};
	var attDesc = [];
	var curDesc = null;

	for (var i in ZaXMBxMimeTable.table) {
		var desc = ZaXMBxMimeTable.table[i].desc;
		if (desc != curDesc) {
			this._attsByDesc[desc] = new Array();
			attDesc.push(desc);
		}
		this._attsByDesc[desc].push(ZaXMBxMimeTable.table[i]);
		curDesc = desc;
	}
	for (var i = 0; i < attDesc.length; i++) {
		var ti = this._newType(this._tree, this._attsByDesc[attDesc[i]]);
		ti.setChecked(false,true);
	}

	this._treeDiv = document.getElementById(treeId);
	this._treeDiv.appendChild(this._tree.getHtmlElement());
	Dwt.setVisible(this._treeDiv, ZaXMBxAttachmentPicker.RADIO_CHECKED == ZaXMBxAttachmentPicker.RADIO_CHECKED);

	this._updateQuery();


/*	var attachTypeList = new ZmAttachmentTypeList(this.shell.getData(ZmAppCtxt.LABEL));
	var respCallback = new AjxCallback(this, this._handleResponseSetupPicker, [attachTypeList, this._tree, treeId]);
	attachTypeList.load(respCallback);*/
};

ZaXMBxAttachmentPicker.prototype._updateQuery =
function() {
	if (this._radio[ZaXMBxAttachmentPicker.ANY].checked) {
		this.setQuery("attachment:any");
	} else if (this._radio[ZaXMBxAttachmentPicker.NONE].checked) {
		this.setQuery("attachment:none");
	} else if (this._radio[ZaXMBxAttachmentPicker.FILE].checked) {
		var query = "filename:(" + this._fileNameInput.value + ")";
		this.setQuery(query);
	} else if (this._radio[ZaXMBxAttachmentPicker.SPEC].checked) {
		if(this._mimeNameInput.value) {
			if(this._mimeNameInput.value.indexOf(",") !=-1 || this._mimeNameInput.value.indexOf("\n") !=-1) {
				var tmpVar = this._mimeNameInput.value;
				if(tmpVar.indexOf("\n"))
					tmpVar=this._mimeNameInput.value.replace(/(,\n)/g,",");
					
				var types = tmpVar.split(/[,\n]/);
				if (types.length) {
					var attStr = types.join(" OR ");
					if (types.length > 1) {
						attStr = "(" + attStr + ")";
					}
					this.setQuery("attachment:" + attStr);
				}			
			} else {
				this.setQuery("attachment:" + this._mimeNameInput.value);
			}
		}
	} else {
		var types = [];
		for (var desc in this._checkedItems) {
			var atts = this._attsByDesc[desc];
			for (var i = 0; i < atts.length; i++) {
				types.push('"' + atts[i].type + '"');
			}
		}
		if (types.length) {
			var attStr = types.join(" OR ");
			if (types.length > 1) {
				attStr = "(" + attStr + ")";
			}
			this.setQuery("attachment:" + attStr);
		} else {
			this.setQuery("");
		}
	}
//	this.execute();
};

ZaXMBxAttachmentPicker.prototype._treeListener =
function(ev) {
 	if (ev.detail == DwtTree.ITEM_CHECKED) {
 		// bug fix #7057 - remove when new version of safari is release
 		// see http://bugzilla.opendarwin.org/show_bug.cgi?id=7279
 		if (AjxEnv.isSafari) {
 			ev.item._checkBox.checked = !ev.item._checkBox.checked;
 		}
 		var ti = ev.item;
 		var checked = ti.getChecked();
		if (checked) {
			this._checkedItems[ti.getData(ZaXMBxAttachmentPicker.ATT_KEY)] = true;
		} else {
			delete this._checkedItems[ti.getData(ZaXMBxAttachmentPicker.ATT_KEY)];
		}
		this._updateQuery();
 	}
};

ZaXMBxAttachmentPicker._radioChange =
function(ev) {
	var element = DwtUiEvent.getTarget(ev);
	var picker = element._picker;

	Dwt.setVisible(picker._treeDiv, (element._radioId == ZaXMBxAttachmentPicker.KNOWN));

	var dispFilename = element._radioId == ZaXMBxAttachmentPicker.FILE ? Dwt.DISPLAY_BLOCK : Dwt.DISPLAY_NONE;
	Dwt.setDisplay(picker._fileNameDiv, dispFilename);
	if (element._radioId == ZaXMBxAttachmentPicker.FILE) {
		picker._fileNameInput.focus();
//		return;
	}

	var dispMimename = element._radioId == ZaXMBxAttachmentPicker.SPEC ? Dwt.DISPLAY_BLOCK : Dwt.DISPLAY_NONE;
	Dwt.setDisplay(picker._mimeNameDiv, dispMimename);
	if (element._radioId == ZaXMBxAttachmentPicker.SPEC) {
		picker._mimeNameInput.focus();
//		return;
	}

	picker._updateQuery();
};

ZaXMBxAttachmentPicker._onChange =
function(ev) {
	var element = DwtUiEvent.getTarget(ev);
	var picker = Dwt.getObjectFromElement(element,element.id);
	picker._updateQuery();
	return true;
};
