/*
 * ***** BEGIN LICENSE BLOCK *****
 * Zimbra Collaboration Suite, Network Edition.
 * Copyright (C) 2007, 2009, 2013, 2014 Zimbra, Inc.  All Rights Reserved.
 * ***** END LICENSE BLOCK *****
 */

function ZaXMBxDomainPicker(parent) {
	ZaXMBxPicker.call(this, parent, ZaXMBxPicker.DOMAIN);
};

ZaXMBxDomainPicker.prototype = new ZaXMBxPicker;
ZaXMBxDomainPicker.prototype.constructor = ZaXMBxDomainPicker;

ZaXMBxPicker.CTOR[ZaXMBxPicker.DOMAIN] = ZaXMBxDomainPicker;

ZaXMBxDomainPicker.prototype.toString = 
function() {
	return "ZaXMBxDomainPicker";
};

ZaXMBxDomainPicker.prototype._setupPicker =
function(parent) {

    this._elements = new Object();
	this._divIds = new Object();
    var picker = new DwtComposite(parent);
	var fromId = Dwt.getNextId();
	var toId = Dwt.getNextId();
	var domainDivId = Dwt.getNextId();	
	var domainInputId = Dwt.getNextId();	
    var html = new Array(100);
    var idx = 0;

	html[idx++] = "<table cellpadding='3' cellspacing='0' border='0' style='width:100%;'>";
	html[idx++] = "<tr align='center' valign='middle'>";
	html[idx++] = "<td align='left'><input type='checkbox' checked id='" + fromId + "'/> " + com_zimbra_xmbxsearch.XMBX_from + "</td>";
	html[idx++] = "<td align='left'><input type='checkbox' id='" + toId + "'/> " + com_zimbra_xmbxsearch.XMBX_toCc + "</td>";
	html[idx++] = "</tr><tr>";
	html[idx++] = "<td align='left' colSpan=2>";
	html[idx++] = com_zimbra_xmbxsearch.XMBX_domainname;
	html[idx++] = ":</td></tr><tr><td align='left' colSpan=2>";
	html[idx++] = Dwt.CARET_HACK_BEGIN;
	html[idx++] = "<textarea cols=20 rows=10 style='width:90%' id='";
	html[idx++] = domainInputId;
	html[idx++] = "'></textarea>";
	html[idx++] = Dwt.CARET_HACK_END;
	html[idx++] = "</td></tr>";
	html[idx++] = "</table>";


	picker.getHtmlElement().innerHTML = html.join("");

	// set up input fields
	this._domainNameDiv = document.getElementById(domainDivId);
	this._domainNameInput = document.getElementById(domainInputId);	
	this._from = document.getElementById(fromId);
	this._to = document.getElementById(toId);

	Dwt.setHandler(this._domainNameInput, DwtEvent.ONKEYUP, ZaXMBxDomainPicker._onChange);	
	Dwt.setHandler(this._from, DwtEvent.ONCHANGE, ZaXMBxDomainPicker._onChange);
	Dwt.setHandler(this._to, DwtEvent.ONCHANGE, ZaXMBxDomainPicker._onChange);

	Dwt.associateElementWithObject(this._domainNameInput, this, domainInputId);	
	Dwt.associateElementWithObject(this._from, this, fromId);	
	Dwt.associateElementWithObject(this._to, this, toId);	
	this._updateQuery();
};

ZaXMBxDomainPicker.prototype._updateQuery =
function() {
	if(this._domainNameInput.value) {
		var domains = [];
		var values = [];
		var query = [];		
		var idx = 0;
		
		var headers = new Array();
		if (this._from.checked)
			headers.push("from");
		if (this._to.checked)
			headers.push("to", "cc");
		var numHeaders = headers.length;
	
		if (numHeaders == 0) {
			this.setQuery("");
			this.execute();
			return;
	 	}		
		
		if(this._domainNameInput.value.indexOf(",") !=-1 || this._domainNameInput.value.indexOf("\n") !=-1) {
			var tmpVar = this._domainNameInput.value;
			if(tmpVar.indexOf("\n"))
				tmpVar=this._domainNameInput.value.replace(/(,\n)/g,",");			

			values = tmpVar.split(/[,\n]/);
		} else {
			values = [this._domainNameInput.value];
		}
		var cnt = values.length;
		for (var i=0;i<cnt;i++) {
			if(values[i] && values[i].length>2)
			domains[idx++] = "@" + values[i];
		}

		var domainExpr = ["(",domains.join(" OR "), ")"].join("");

		idx = 0;
		if (numHeaders > 1) 
			query[idx++] = "(";

		for (var h in headers) {
			if (h > 0)
				query[idx++] = " OR ";
			query[idx++] = headers[h];
			query[idx++] = ":";
			query[idx++] = domainExpr;			
		}			
		if (numHeaders > 1) 
			query[idx++] = ")";		
			
		this.setQuery(query.join(""));
	}
};

ZaXMBxDomainPicker._onChange =
function(ev) {
	var element = DwtUiEvent.getTarget(ev);
	var picker = Dwt.getObjectFromElement(element,element.id);
	picker._updateQuery();
	return true;
};
