/*
 * ***** BEGIN LICENSE BLOCK *****
 * Zimbra Collaboration Suite, Network Edition.
 * Copyright (C) 2007, 2009, 2012, 2013, 2014 Zimbra, Inc.  All Rights Reserved.
 * ***** END LICENSE BLOCK *****
 */

function ZaXMBxFlagPicker(parent) {
	ZaXMBxPicker.call(this, parent, ZaXMBxPicker.FLAG);
};

ZaXMBxFlagPicker.prototype = new ZaXMBxPicker;
ZaXMBxFlagPicker.prototype.constructor = ZaXMBxFlagPicker;

ZaXMBxPicker.CTOR[ZaXMBxPicker.FLAG] = ZaXMBxFlagPicker;

ZaXMBxFlagPicker.prototype.toString = 
function() {
	return "ZaXMBxFlagPicker";
};

ZaXMBxFlagPicker.prototype._setupPicker =
function(parent) {
	var tree = this._tree = new DwtTree(parent, DwtTree.CHECKEDITEM_STYLE);
	tree.addSelectionListener(new AjxListener(this, ZaXMBxFlagPicker.prototype._treeListener));
	
	var ti = this._flagged = new DwtTreeItem({parent:tree,className:"AdminTreeItem"});
	ti.setText(com_zimbra_xmbxsearch.XMBX_flagged);
	ti.setImage("FlagRed");
	
	ti = this._unflagged = new DwtTreeItem({parent:tree,className:"AdminTreeItem"});
	ti.setText(com_zimbra_xmbxsearch.XMBX_unflagged);
	ti.setImage("FlagDis");
	
	tree.addSeparator();

	ti = this._read = new DwtTreeItem({parent:tree,className:"AdminTreeItem"});
	ti.setText(com_zimbra_xmbxsearch.XMBX_read);
	ti.setImage("ReadMessage");
	
	ti = this._unread = new DwtTreeItem({parent:tree,className:"AdminTreeItem"});
	ti.setText(com_zimbra_xmbxsearch.XMBX_unread);
	ti.setImage("UnreadMessage");	

	tree.addSeparator();

	ti = this._replied = new DwtTreeItem({parent:tree,className:"AdminTreeItem"});
	ti.setText(com_zimbra_xmbxsearch.XMBX_replied);
	ti.setImage("Reply");
	
	ti = this._forwarded = new DwtTreeItem({parent:tree,className:"AdminTreeItem"});
	ti.setText(com_zimbra_xmbxsearch.XMBX_forwarded);
	ti.setImage("Forward");	
};

ZaXMBxFlagPicker.prototype._updateQuery = 
function() {
	var query = [];

	if (this._flagged.getChecked()) {
		query.push("is:flagged");
	} else if (this._unflagged.getChecked()) {
		query.push("is:unflagged");
	}

	if (this._read.getChecked()) {
		query.push("is:read");
	} else if (this._unread.getChecked()) {
		query.push("is:unread");
	}
	
	if (this._replied.getChecked()) {
		query.push("is:replied");
	}

	if (this._forwarded.getChecked()) {
		query.push("is:forwarded");
	}

	if (query.length) {
		this.setQuery(query.join(" "));
	} else {
		this.setQuery("");
	}
//	this.execute();
};

ZaXMBxFlagPicker.prototype._treeListener =
function(ev) {
 	if (ev.detail == DwtTree.ITEM_CHECKED) {
 		if (AjxEnv.isSafari)
 			ev.item._checkBox.checked = !ev.item._checkBox.checked;
 		var ti = ev.item;
 		var checked = ti.getChecked();
 		if (ti == this._flagged && checked && this._unflagged.getChecked()) {
 			this._unflagged.setChecked(false);
		} else if (ti == this._unflagged && checked && this._flagged.getChecked()) {
 			this._flagged.setChecked(false);
		} else if (ti == this._read && checked && this._unread.getChecked()) {
 			this._unread.setChecked(false);
		} else if (ti == this._unread && checked && this._read.getChecked()) {
 			this._read.setChecked(false);
 		}
		this._updateQuery();
 	}
};
