/*
 * ***** BEGIN LICENSE BLOCK *****
 * Zimbra Collaboration Suite, Network Edition.
 * Copyright (C) 2007, 2009, 2013, 2014 Zimbra, Inc.  All Rights Reserved.
 * ***** END LICENSE BLOCK *****
 */

function ZaXMBxMimeTable() {
};

// IGNORE means the client will not display these attachment types to the user
ZaXMBxMimeTable.APP					= "application";
ZaXMBxMimeTable.APP_ADOBE_PDF		= "application/pdf";
ZaXMBxMimeTable.APP_ADOBE_PS		= "application/postscript";
//ZaXMBxMimeTable.APP_APPLE_DOUBLE 	= "application/applefile";		// IGNORE
ZaXMBxMimeTable.APP_EXE				= "application/exe";
ZaXMBxMimeTable.APP_MS_DOWNLOAD		= "application/x-msdownload";
ZaXMBxMimeTable.APP_MS_EXCEL		= "application/vnd.ms-excel";
ZaXMBxMimeTable.APP_MS_PPT			= "application/vnd.ms-powerpoint";
ZaXMBxMimeTable.APP_MS_PROJECT		= "application/vnd.ms-project";
//ZaXMBxMimeTable.APP_MS_TNEF			= "application/ms-tnef"; 		// IGNORE
//ZaXMBxMimeTable.APP_MS_TNEF2 		= "application/vnd.ms-tnef"; 	// IGNORE (added per bug 2339)
ZaXMBxMimeTable.APP_MS_VISIO		= "application/vnd.visio";
ZaXMBxMimeTable.APP_MS_WORD			= "application/msword";
ZaXMBxMimeTable.APP_OCTET_STREAM	= "application/octet-stream";
ZaXMBxMimeTable.APP_ZIP				= "application/zip";
ZaXMBxMimeTable.APP_ZIP2			= "application/x-zip-compressed";
ZaXMBxMimeTable.AUDIO				= "audio";
ZaXMBxMimeTable.AUDIO_WAV			= "audio/x-wav";
ZaXMBxMimeTable.AUDIO_MP3			= "audio/mpeg";
ZaXMBxMimeTable.IMG					= "image";
ZaXMBxMimeTable.IMG_GIF				= "image/gif";
ZaXMBxMimeTable.IMG_JPEG			= "image/jpeg";
ZaXMBxMimeTable.IMG_PNG				= "image/png";
ZaXMBxMimeTable.IMG_TIFF			= "image/tiff";
ZaXMBxMimeTable.MSG_RFC822			= "message/rfc822";
//ZaXMBxMimeTable.MULTI_ALT			= "multipart/alternative"; 		// IGNORE
//ZaXMBxMimeTable.MULTI_MIXED			= "multipart/mixed"; 			// IGNORE
//ZaXMBxMimeTable.MULTI_RELATED		= "multipart/related"; 			// IGNORE
//ZaXMBxMimeTable.MULTI_APPLE_DBL 	= "multipart/appledouble"; 		// IGNORE
ZaXMBxMimeTable.TEXT				= "text";
ZaXMBxMimeTable.TEXT_RTF			= "text/enriched";
ZaXMBxMimeTable.TEXT_HTML			= "text/html";
//ZaXMBxMimeTable.TEXT_CAL			= "text/calendar"; 				// IGNORE
ZaXMBxMimeTable.TEXT_JAVA			= "text/x-java";
ZaXMBxMimeTable.TEXT_VCARD			= "text/x-vcard";
ZaXMBxMimeTable.TEXT_PLAIN			= "text/plain";
ZaXMBxMimeTable.TEXT_XML			= "text/xml";
ZaXMBxMimeTable.VIDEO				= "video";
ZaXMBxMimeTable.VIDEO_WMV			= "video/x-ms-wmv";
ZaXMBxMimeTable.XML_ZIMBRA_SHARE	= "xml/x-zimbra-share";

ZaXMBxMimeTable.table = new Object();

// only add types which are NOT ignored by the client	
ZaXMBxMimeTable.table[ZaXMBxMimeTable.APP]					= {type:ZaXMBxMimeTable.APP,desc: com_zimbra_xmbxsearch.XMBX_unknownBinaryType, image: "ExeDoc", imageLarge: "ExeDoc_48"};
ZaXMBxMimeTable.table[ZaXMBxMimeTable.APP_ADOBE_PDF]		= {type:ZaXMBxMimeTable.APP_ADOBE_PDF, desc: com_zimbra_xmbxsearch.XMBX_adobePdfDocument, image: "PDFDoc", imageLarge: "PDFDoc_48"};
ZaXMBxMimeTable.table[ZaXMBxMimeTable.APP_ADOBE_PS]		= {type:ZaXMBxMimeTable.APP_ADOBE_PS, desc: com_zimbra_xmbxsearch.XMBX_adobePsDocument, image: "GenericDoc", imageLarge: "GenericDoc_48"};
ZaXMBxMimeTable.table[ZaXMBxMimeTable.APP_EXE]				= {type:ZaXMBxMimeTable.APP_EXE, desc: com_zimbra_xmbxsearch.XMBX_application, image: "ExeDoc", imageLarge: "ExeDoc_48"};
ZaXMBxMimeTable.table[ZaXMBxMimeTable.APP_MS_DOWNLOAD]		= {type:ZaXMBxMimeTable.APP_MS_DOWNLOAD, desc: com_zimbra_xmbxsearch.XMBX_msDownload, image: "ExeDoc", imageLarge: "ExeDoc_48"};
ZaXMBxMimeTable.table[ZaXMBxMimeTable.APP_MS_EXCEL]		= {type:ZaXMBxMimeTable.APP_MS_EXCEL, desc: com_zimbra_xmbxsearch.XMBX_msExcelDocument, image: "MSExcelDoc", imageLarge: "MSExcelDoc_48"};
ZaXMBxMimeTable.table[ZaXMBxMimeTable.APP_MS_PPT]			= {type:ZaXMBxMimeTable.APP_MS_PPT, desc: com_zimbra_xmbxsearch.XMBX_msPPTDocument, image: "MSPowerpointDoc", imageLarge: "MSPowerpointDoc_48"};
ZaXMBxMimeTable.table[ZaXMBxMimeTable.APP_MS_PROJECT]		= {type:ZaXMBxMimeTable.APP_MS_PROJECT, desc: com_zimbra_xmbxsearch.XMBX_msProjectDocument, image: "MSProjectDoc", imageLarge: "MSProjectDoc_48"};
ZaXMBxMimeTable.table[ZaXMBxMimeTable.APP_MS_VISIO]		= {type:ZaXMBxMimeTable.APP_MS_VISIO, desc: com_zimbra_xmbxsearch.XMBX_msVisioDocument, image: "MSVisioDoc", imageLarge: "MSVisioDoc_48"};
ZaXMBxMimeTable.table[ZaXMBxMimeTable.APP_MS_WORD]			= {type:ZaXMBxMimeTable.APP_MS_WORD, desc: com_zimbra_xmbxsearch.XMBX_msWordDocument, image: "MSWordDoc", imageLarge: "MSWordDoc_48"};
ZaXMBxMimeTable.table[ZaXMBxMimeTable.APP_OCTET_STREAM]	= {type:ZaXMBxMimeTable.APP_OCTET_STREAM, desc: com_zimbra_xmbxsearch.XMBX_octetStream, image: "ExeDoc", imageLarge: "ExeDoc_48"};
ZaXMBxMimeTable.table[ZaXMBxMimeTable.APP_ZIP]				= {type:ZaXMBxMimeTable.APP_ZIP, desc: com_zimbra_xmbxsearch.XMBX_zipFile, image: "ZipDoc", imageLarge: "ZipDoc_48"};
ZaXMBxMimeTable.table[ZaXMBxMimeTable.APP_ZIP2]			= {type:ZaXMBxMimeTable.APP_ZIP2, desc: com_zimbra_xmbxsearch.XMBX_zipFile, image: "ZipDoc", imageLarge: "ZipDoc_48"};
ZaXMBxMimeTable.table[ZaXMBxMimeTable.AUDIO]				= {type:ZaXMBxMimeTable.AUDIO, desc: com_zimbra_xmbxsearch.XMBX_audio, image: "AudioDoc", imageLarge: "Doc_48"};
ZaXMBxMimeTable.table[ZaXMBxMimeTable.AUDIO_WAV]			= {type:ZaXMBxMimeTable.AUDIO_WAV, desc: com_zimbra_xmbxsearch.XMBX_waveAudio, image: "AudioDoc", imageLarge: "AudioDoc_48"};
ZaXMBxMimeTable.table[ZaXMBxMimeTable.AUDIO_MP3]			= {type:ZaXMBxMimeTable.AUDIO_MP3, desc: com_zimbra_xmbxsearch.XMBX_mp3Audio, image: "AudioDoc", imageLarge: "AudioDoc_48"};
ZaXMBxMimeTable.table[ZaXMBxMimeTable.VIDEO]				= {type:ZaXMBxMimeTable.VIDEO, desc: com_zimbra_xmbxsearch.XMBX_video, image: "VideoDoc", imageLarge: "VideoDoc_48"};
ZaXMBxMimeTable.table[ZaXMBxMimeTable.VIDEO_WMV]			= {type:ZaXMBxMimeTable.VIDEO_WMV, desc: com_zimbra_xmbxsearch.XMBX_msWMV, image: "VideoDoc", imageLarge: "VideoDoc_48"};
ZaXMBxMimeTable.table[ZaXMBxMimeTable.IMG]					= {type:ZaXMBxMimeTable.IMG, desc: com_zimbra_xmbxsearch.XMBX_image, image: "ImageDoc", imageLarge: "ImageDoc_48"};
ZaXMBxMimeTable.table[ZaXMBxMimeTable.IMG_GIF]				= {type:ZaXMBxMimeTable.IMG_GIF, desc: com_zimbra_xmbxsearch.XMBX_gifImage, image: "ImageDoc", imageLarge: "ImageDoc_48"};
ZaXMBxMimeTable.table[ZaXMBxMimeTable.IMG_JPEG]			= {type:ZaXMBxMimeTable.IMG_JPEG, desc: com_zimbra_xmbxsearch.XMBX_jpegImage, image: "ImageDoc", imageLarge: "ImageDoc_48"};
ZaXMBxMimeTable.table[ZaXMBxMimeTable.IMG_PNG]				= {type:ZaXMBxMimeTable.IMG_PNG, desc: com_zimbra_xmbxsearch.XMBX_pngImage, image: "ImageDoc", imageLarge: "ImageDoc_48"};
ZaXMBxMimeTable.table[ZaXMBxMimeTable.IMG_TIFF]			= {type:ZaXMBxMimeTable.IMG_TIFF, desc: com_zimbra_xmbxsearch.XMBX_tiffImage, image: "ImageDoc", imageLarge: "ImageDoc_48"};
ZaXMBxMimeTable.table[ZaXMBxMimeTable.MSG_RFC822]			= {type:ZaXMBxMimeTable.MSG_RFC822, desc: com_zimbra_xmbxsearch.XMBX_mailMessage, image: "MessageDoc", imageLarge: "MessageDoc_48"};
ZaXMBxMimeTable.table[ZaXMBxMimeTable.TEXT]				= {type:ZaXMBxMimeTable.TEXT, desc: com_zimbra_xmbxsearch.XMBX_textDocuments, image: "GenericDoc", imageLarge: "GenericDoc_48"};
ZaXMBxMimeTable.table[ZaXMBxMimeTable.TEXT_RTF]			= {type:ZaXMBxMimeTable.TEXT_RTF, desc: com_zimbra_xmbxsearch.XMBX_enrichedText, image: "GenericDoc", imageLarge: "GenericDoc_48"};
ZaXMBxMimeTable.table[ZaXMBxMimeTable.TEXT_HTML]			= {type:ZaXMBxMimeTable.TEXT_HTML, desc: com_zimbra_xmbxsearch.XMBX_htmlDocument, image: "HtmlDoc", imageLarge: "HtmlDoc_48"};
ZaXMBxMimeTable.table[ZaXMBxMimeTable.TEXT_JAVA]			= {type:ZaXMBxMimeTable.TEXT_JAVA, desc: com_zimbra_xmbxsearch.XMBX_javaSource, image: "GenericDoc", imageLarge: "GenericDoc_48"};
ZaXMBxMimeTable.table[ZaXMBxMimeTable.TEXT_PLAIN]			= {type:ZaXMBxMimeTable.TEXT_PLAIN, desc: com_zimbra_xmbxsearch.XMBX_textFile, image: "GenericDoc", imageLarge: "GenericDoc_48"};
ZaXMBxMimeTable.table[ZaXMBxMimeTable.TEXT_XML]			= {type:ZaXMBxMimeTable.TEXT_XML, desc: com_zimbra_xmbxsearch.XMBX_xmlDocument, image: "GenericDoc", imageLarge: "GenericDoc_48"};
