/*
 * ***** BEGIN LICENSE BLOCK *****
 * Zimbra Collaboration Suite, Network Edition.
 * Copyright (C) 2007, 2009, 2013, 2014 Zimbra, Inc.  All Rights Reserved.
 * ***** END LICENSE BLOCK *****
 */

function ZaXMBxPickerGrid(parent) {

	DwtComposite.call(this, parent, "ZaXMBxPickerGrid", DwtControl.RELATIVE_STYLE);

	this.setScrollStyle(DwtControl.SCROLL);
	this.addControlListener(new AjxListener(this, this._controlListener));
	this._pickers = new AjxVector();
}

ZaXMBxPickerGrid.prototype = new DwtComposite;
ZaXMBxPickerGrid.prototype.constructor = ZaXMBxPickerGrid;

ZaXMBxPickerGrid.prototype.toString = 
function() {
	return "ZaXMBxPickerGrid";
}

ZaXMBxPickerGrid.prototype.getToolBar = 
function() {
	return this._toolbar;
}

ZaXMBxPickerGrid.prototype.addPicker =
function(picker, id) {
    this._pickers.add(picker);
    this.layout();
}

ZaXMBxPickerGrid.prototype.getPickers = 
function() {
	return this._pickers;
}

ZaXMBxPickerGrid.prototype.removePicker =
function(picker) {
	var p = this._pickers;
	if (p.size() == 0)
		return;
	if (p.remove(picker)) {
		picker.dispose();
	    this.layout();
    }
}

ZaXMBxPickerGrid.prototype.removeAllPickers =
function() {
	var p = this._pickers;
	while (p.size() > 0) {
		var picker = p.getLast();
		picker.dispose();
	    p.removeLast();
    }
}

ZaXMBxPickerGrid.prototype.layout =
function() {
	if (!this.getVisible())
		return;
	var p = this._pickers;
	var i, x;
	var sz = p.size();
	for (i = 0; i < sz; i++) {
		x = (i == 0) ? 0 : p.get(i - 1).getXW();
		var picker = p.get(i);
		picker.setBounds(x, 0, Dwt.DEFAULT, this.getH());
	}
	return this;
}

ZaXMBxPickerGrid.prototype._controlListener =
function(ev) {
	this.layout();
}


/**	
* @class defines XFormItem type _XMBX_PICKER_GRID_
* @constructor
**/
function ZaXMBx_Picker_Grid_XFormItem() {}
XFormItemFactory.createItemType("_XMBX_PICKER_GRID_", "xmbx_picker_grid", ZaXMBx_Picker_Grid_XFormItem, Dwt_Adaptor_XFormItem)

//	type defaults
ZaXMBx_Picker_Grid_XFormItem.prototype.writeElementDiv = false;
ZaXMBx_Picker_Grid_XFormItem.prototype.widgetClass = DwtListView;

ZaXMBx_Picker_Grid_XFormItem.prototype.constructWidget = function () {

	var widget = new ZaXMBxPickerGrid(this.getForm());
	var width = this.getWidth();
	var height = this.getHeight();
	if(width && height)
		widget.setSize(width, height);
		
	return widget;
};

ZaXMBx_Picker_Grid_XFormItem.prototype.insertWidget = function (form, widget, element) {
	this.getForm()._reparentDwtObject(widget, this.getContainer());
};
