/*
 * ***** BEGIN LICENSE BLOCK *****
 * Zimbra Collaboration Suite, Network Edition.
 * Copyright (C) 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014 Zimbra, Inc.  All Rights Reserved.
 * ***** END LICENSE BLOCK *****
 */

/**
* @constructor
* @class ZaXMBxSearchViewController
**/
function ZaXMBxSearchViewController(appCtxt, container) {
	ZaXFormViewController.call(this, appCtxt, container, "ZaXMBxSearchViewController");
	this._UICreated = false;	
	this._helpURL = ZaXMBxSearchViewController.helpURL;
	//this._toolbarOperations = new Array();
	this._containedObject = null;
}

ZaXMBxSearchViewController.prototype = new ZaXFormViewController();
ZaXMBxSearchViewController.prototype.constructor = ZaXMBxSearchViewController;
ZaXMBxSearchViewController.helpURL = location.pathname + "help/admin/html/search/cross_mailbox_search.htm?locid=" + AjxEnv.DEFAULT_LOCALE;
//ZaController.initToolbarMethods["ZaXMBxSearchViewController"] = new Array();
ZaController.initPopupMenuMethods["ZaXMBxSearchViewController"] = new Array();
ZaController.setViewMethods["ZaXMBxSearchViewController"] = new Array();
ZaController.changeActionsStateMethods["ZaXMBxSearchViewController"] = new Array();


ZaXMBxSearchViewController.prototype.show = 
function(entry) {
	this._containedObject = entry;
	if (! this.selectExistingTabByItemId(entry.id)){
		this._setView(entry, true);
		this.setDirty(false);
	}
	if(entry.attrs[ZaXMBxSearch.A_searchID]) {
		//this._toolbar.enable([ZaOperation.VIEW_XMBXSEARCH_RESULTS], true);
		var status = parseInt(entry.attrs[ZaXMBxSearch.A_status]);
		if (
			((status & ZaXMBxSearch.iSTATUS_FINISHED) == ZaXMBxSearch.iSTATUS_FINISHED) ||
			((status & ZaXMBxSearch.iSTATUS_ABORTING) == ZaXMBxSearch.iSTATUS_ABORTING) ||
			((status & ZaXMBxSearch.iSTATUS_ABORTED) == ZaXMBxSearch.iSTATUS_ABORTED)
			) {
		} else if (status == ZaXMBxSearch.iSTATUS_IDLE) {
//			this._toolbar.enable([ZaOperation.ABORT_SEARCH],false);
//			this._toolbar.enable([ZaOperation.DELETE],true);
		} else {
	//		this._toolbar.enable([ZaOperation.ABORT_SEARCH],true);
	//		this._toolbar.enable([ZaOperation.DELETE],false);
		}		
		
		
	} else {
		/*this._toolbar.enable([ZaOperation.RUN_XMBXSEARCH], true);
		this._toolbar.enable([ZaOperation.ABORT_SEARCH], false);
		this._toolbar.enable([ZaOperation.VIEW_XMBXSEARCH_RESULTS], false);		
		this._toolbar.enable([ZaOperation.DELETE],false);*/
	}
}

ZaXMBxSearchViewController.prototype.getAppBarAction =
function () {
    if (AjxUtil.isEmpty(this._appbarOperation)) {
    	this._appbarOperation[ZaOperation.HELP]=new ZaOperation(ZaOperation.HELP,ZaMsg.TBB_Help, ZaMsg.TBB_Help_tt, "Help", "Help", new AjxListener(this, this._helpButtonListener));
        this._appbarOperation[ZaOperation.RUN_XMBXSEARCH]= new ZaOperation(ZaOperation.RUN_XMBXSEARCH, com_zimbra_xmbxsearch.XMBX_RunSearch, com_zimbra_xmbxsearch.XMBX_RunSearch_tt, "CrossMailboxSearch", "CrossMailboxSearch", new AjxListener(this, this.runSearchButtonListener));
        this._appbarOperation[ZaOperation.CLOSE] = new ZaOperation(ZaOperation.CLOSE, ZaMsg.TBB_Close, ZaMsg.SERTBB_Close_tt, "Close", "CloseDis", new AjxListener(this, this.closeButtonListener));
    }

    return this._appbarOperation;
}

ZaXMBxSearchViewController.prototype.getAppBarOrder =
function () {
    if (AjxUtil.isEmpty(this._appbarOrder)) {
    	this._appbarOrder.push(ZaOperation.HELP);
        this._appbarOrder.push(ZaOperation.RUN_XMBXSEARCH);
        this._appbarOrder.push(ZaOperation.CLOSE);
    }

    return this._appbarOrder;
}

ZaXMBxSearchViewController.initPopupMenuMethod =
function () {
    if (appNewUI) {
        this._popupOperations[ZaOperation.VIEW_XMBXSEARCH_RESULTS] = new ZaOperation(ZaOperation.VIEW_XMBXSEARCH_RESULTS, com_zimbra_xmbxsearch.XMBX_ViewResults, com_zimbra_xmbxsearch.XMBX_ViewResults_tt, "ReadMailbox", "ReadMailboxDis", new AjxListener(this, this.viewResultsListener));

        this._popupOrder.push(ZaOperation.VIEW_XMBXSEARCH_RESULTS);
    }
    this._popupOperations[ZaOperation.ABORT_SEARCH] = new ZaOperation(ZaOperation.ABORT_SEARCH, com_zimbra_xmbxsearch.XMBXTBB_Abort, com_zimbra_xmbxsearch.XMBXTBB_Abort_tt, "Cancel", "Cancel", new AjxListener(this, this.abortButtonListener));
    this._popupOperations[ZaOperation.DELETE] = new ZaOperation(ZaOperation.DELETE, ZaMsg.TBB_Delete, com_zimbra_xmbxsearch.XMBXTBB_Delete_tt, "Delete", "DeleteDis", new AjxListener(this, this.deleteButtonListener));
    this._popupOrder.push(ZaOperation.ABORT_SEARCH);
    this._popupOrder.push(ZaOperation.DELET);
}
ZaController.initPopupMenuMethods["ZaXMBxSearchViewController"].push(ZaXMBxSearchViewController.initPopupMenuMethod);


/*ZaXMBxSearchViewController.initToolbarMethod =
function () {
	this._toolbarOperations.push(new ZaOperation(ZaOperation.RUN_XMBXSEARCH, com_zimbra_xmbxsearch.XMBX_RunSearch, com_zimbra_xmbxsearch.XMBX_RunSearch_tt, "CrossMailboxSearch", "CrossMailboxSearch", new AjxListener(this, this.runSearchButtonListener)));    			
	this._toolbarOperations.push(new ZaOperation(ZaOperation.CLOSE, ZaMsg.TBB_Close, ZaMsg.SERTBB_Close_tt, "Close", "CloseDis", new AjxListener(this, this.closeButtonListener)));    		
	this._toolbarOperations.push(new ZaOperation(ZaOperation.VIEW_XMBXSEARCH_RESULTS, com_zimbra_xmbxsearch.XMBX_ViewResults, com_zimbra_xmbxsearch.XMBX_ViewResults_tt, "ReadMailbox", "ReadMailboxDis", new AjxListener(this, this.viewResultsListener)));
	this._toolbarOperations.push(new ZaOperation(ZaOperation.ABORT_SEARCH, com_zimbra_xmbxsearch.XMBXTBB_Abort, com_zimbra_xmbxsearch.XMBXTBB_Abort_tt,"Cancel","Cancel", new AjxListener(this, this.abortButtonListener)));		
	this._toolbarOperations.push(new ZaOperation(ZaOperation.DELETE, ZaMsg.TBB_Delete, com_zimbra_xmbxsearch.XMBXTBB_Delete_tt,"Delete","DeleteDis", new AjxListener(this, this.deleteButtonListener)));			
}
ZaController.initToolbarMethods["ZaXMBxSearchViewController"].push(ZaXMBxSearchViewController.initToolbarMethod);
*/
ZaXMBxSearchViewController.changeActionsStateMethod = function () {
	if(!this._currentObject)
		return;
	var entry = this._currentObject;
	var status = parseInt(entry.attrs[ZaXMBxSearch.A_status]);
	if(entry.attrs[ZaXMBxSearch.A_searchID]) {
        if(this._popupOperations[ZaOperation.VIEW_XMBXSEARCH_RESULTS])
			this._popupOperations[ZaOperation.VIEW_XMBXSEARCH_RESULTS].enabled = true;
        if(this._popupOperations[ZaOperation.RUN_XMBXSEARCH])
			this._popupOperations[ZaOperation.RUN_XMBXSEARCH].enabled = false;
		if (
			((status & ZaXMBxSearch.iSTATUS_FINISHED) == ZaXMBxSearch.iSTATUS_FINISHED) ||
			((status & ZaXMBxSearch.iSTATUS_ABORTING) == ZaXMBxSearch.iSTATUS_ABORTING) ||
			((status & ZaXMBxSearch.iSTATUS_ABORTED) == ZaXMBxSearch.iSTATUS_ABORTED)
			) {
            if(this._popupOperations[ZaOperation.ABORT_SEARCH])
                this._popupOperations[ZaOperation.ABORT_SEARCH].enabled = false;
            if(this._popupOperations[ZaOperation.DELETE])
                this._popupOperations[ZaOperation.DELETE].enabled = true;
		} else if (status == ZaXMBxSearch.iSTATUS_IDLE) {
            if(this._popupOperations[ZaOperation.ABORT_SEARCH])
                this._popupOperations[ZaOperation.ABORT_SEARCH].enabled = false;
            if(this._popupOperations[ZaOperation.DELETE])
                this._popupOperations[ZaOperation.DELETE].enabled = true;
		} else {
            if(this._popupOperations[ZaOperation.ABORT_SEARCH])
                this._popupOperations[ZaOperation.ABORT_SEARCH].enabled = true;
            if(this._popupOperations[ZaOperation.DELETE])
                this._popupOperations[ZaOperation.DELETE].enabled = false;
		}


	} else {
        if(this._popupOperations[ZaOperation.RUN_XMBXSEARCH])
            this._popupOperations[ZaOperation.RUN_XMBXSEARCH].enabled = true;
        if(this._popupOperations[ZaOperation.ABORT_SEARCH])
            this._popupOperations[ZaOperation.ABORT_SEARCH].enabled = false;
        if(this._popupOperations[ZaOperation.VIEW_XMBXSEARCH_RESULTS])
            this._popupOperations[ZaOperation.VIEW_XMBXSEARCH_RESULTS].enabled = false;
        if(this._popupOperations[ZaOperation.DELETE])
            this._popupOperations[ZaOperation.DELETE].enabled = false;
	}
}
ZaController.changeActionsStateMethods["ZaXMBxSearchViewController"].push(ZaXMBxSearchViewController.changeActionsStateMethod);

ZaXMBxSearchViewController.prototype.runSearchButtonListener = function(ev) {
	var searchObj = this._contentView.getObject();
	//check values
	if(searchObj[ZaXMBxSearch.A_searchAll]==0) {
		if(!searchObj.attrs[ZaXMBxSearch.A_Accounts] || !searchObj.attrs[ZaXMBxSearch.A_Accounts].length) {
			this.popupErrorDialog(com_zimbra_xmbxsearch.XMBX_WARNSpecifyAccountsToSearch, null, null, DwtMessageDialog.WARNING_STYLE);
			return;
		}
	}
	if(searchObj.attrs[ZaXMBxSearch.A_targetFolder]==null || !searchObj.attrs[ZaXMBxSearch.A_targetFolder].length) {
		this.popupErrorDialog(com_zimbra_xmbxsearch.XMBX_WARNSpecifyTargetFolder, null, null, DwtMessageDialog.WARNING_STYLE);
		return;
	}
	if(searchObj.attrs[ZaXMBxSearch.A_query]==null || !searchObj.attrs[ZaXMBxSearch.A_query].length) {
		this.popupErrorDialog(com_zimbra_xmbxsearch.XMBX_WARNSpecifySearchQuery, null, null, DwtMessageDialog.WARNING_STYLE);
		return;
	}	
	
	if(!searchObj.attrs[ZaXMBxSearch.A_targetMbx]) {
		this.popupErrorDialog(com_zimbra_xmbxsearch.XMBX_WARNSpecifyTargetMailbox, null, null, DwtMessageDialog.WARNING_STYLE);
		return;
	}	
	if(searchObj.attrs[ZaXMBxSearch.A_sendNotification]==1) {
		if(!searchObj.attrs[ZaXMBxSearch.A_notificationReceivers] || !searchObj.attrs[ZaXMBxSearch.A_notificationReceivers].length) {
			this.popupErrorDialog(com_zimbra_xmbxsearch.XMBX_WARNSpecifyNotificationReceivers, null, null, DwtMessageDialog.WARNING_STYLE);
			return;
		}
		if(!searchObj.attrs[ZaXMBxSearch.A_notificationMessage] || !searchObj.attrs[ZaXMBxSearch.A_notificationMessage].length) {
			this.popupErrorDialog(com_zimbra_xmbxsearch.XMBX_WARNSpecifyNotificationMessage, null, null, DwtMessageDialog.WARNING_STYLE);
			return;
		}		
		if(!searchObj.attrs[ZaXMBxSearch.A_notificationSubj] || !searchObj.attrs[ZaXMBxSearch.A_notificationSubj].length) {
			this.popupErrorDialog(com_zimbra_xmbxsearch.XMBX_WARNSpecifyNotificationSubj, null, null, DwtMessageDialog.WARNING_STYLE);
			return;
		}			
		
	}		
	
//check if folder exists
	var soapDoc = AjxSoapDoc.create("GetFolderRequest", "urn:zimbraMail", null);
	var getFolderCommand = new ZmCsfeCommand();
	var params = new Object();
	params.soapDoc = soapDoc;
	params.noAuthToken = true;
	params.accountName = searchObj.attrs[ZaXMBxSearch.A_targetMbx];
	var folderEl = soapDoc.set("folder", "");
	
	folderEl.setAttribute("path", searchObj.attrs[ZaXMBxSearch.A_targetFolder]);	
	try {
		var resp = getFolderCommand.invoke(params);
		if (resp && resp.Body && resp.Body.GetFolderResponse && resp.Body.GetFolderResponse.folder) {
			//found the folder
			if(!ZaApp.getInstance().dialogs["ConfirmMessageDialog"])
				ZaApp.getInstance().dialogs["ConfirmMessageDialog"] = new ZaMsgDialog(ZaApp.getInstance().getAppCtxt().getShell(), null, [DwtDialog.YES_BUTTON, DwtDialog.NO_BUTTON], ZaApp.getInstance());			
			
			ZaApp.getInstance().dialogs["ConfirmMessageDialog"].setMessage(AjxMessageFormat.format (com_zimbra_xmbxsearch.XMBX_targetFolderExists,searchObj.attrs[ZaXMBxSearch.A_targetFolder]),  DwtMessageDialog.WARNING_STYLE);
			ZaApp.getInstance().dialogs["ConfirmMessageDialog"].registerCallback(DwtDialog.YES_BUTTON, ZaXMBxSearchViewController.prototype.confirmSameFolder, this);
			ZaApp.getInstance().dialogs["ConfirmMessageDialog"].registerCallback(DwtDialog.NO_BUTTON, ZaXMBxSearchViewController.prototype.cancelSameFolder, this);		
			ZaApp.getInstance().dialogs["ConfirmMessageDialog"].popup();
			return;	
		}
	} catch (ex) {
		//ignore
		if(ex.code == ZmCsfeException.MAIL_NO_SUCH_FOLDER) {
			//good
		} else {
			this._handleException(ex, "ZaXMBxSearchViewController.prototype.runSearchButtonListener", null, false);
			return;			
		}
	}	
	var callback = new AjxCallback(this, ZaXMBxSearchViewController.prototype.createSearchCallback);
	ZaXMBxSearch.createXMbxSearch(searchObj, callback);
}

ZaXMBxSearchViewController.prototype.confirmSameFolder = function () {
 	var searchObj = this._view.getObject();
 	var callback = new AjxCallback(this, ZaXMBxSearchViewController.prototype.createSearchCallback);
	ZaXMBxSearch.createXMbxSearch(searchObj, callback);	
	ZaApp.getInstance().dialogs["ConfirmMessageDialog"].popdown();
}
 
ZaXMBxSearchViewController.prototype.cancelSameFolder = function () {
 	ZaApp.getInstance().dialogs["ConfirmMessageDialog"].popdown();
}

ZaXMBxSearchViewController.prototype.viewResultsListener =
function(ev) {
	try {
		if(this._containedObject) {
			var accountName = this._containedObject.attrs[ZaXMBxSearch.A_targetMbx];
			if(accountName) {
				var account = ZaSearch.findAccount (ZaAccount.A_mail,accountName);
				if(account) {
					ZaAccountListController._viewMailListenerLauncher.call(this, account);
				}
			}
		}
	} catch (ex) {
		this._handleException(ex, "ZaXMBxSearchViewController.prototype.viewResultsListener", null, false);			
	}
}

ZaXMBxSearchViewController.prototype.createSearchCallback = 
function (resp) {
	if(!resp) {
		var ex = new ZmCsfeException(ZMsg.errorEmptyResponse,ZmCsfeException.CSFE_SVC_ERROR,"ZaXMBxSearchViewController.prototype.querySearchesCallback");
		ZaApp.getInstance().getCurrentController()._handleException(ex, "ZaXMBxSearchViewController.prototype.querySearchesCallback");
	}	
	if(resp.isException && resp.isException()) {
		ZaApp.getInstance().getCurrentController()._handleException(resp.getException(), "ZaXMBxSearchViewController.prototype.querySearchesCallback");
	} else {
		var response;
		if(resp.getResponse) {
			response = resp.getResponse();
		} else if(resp.Body.CreateXMbxSearchResponse) {
			response = resp;
		}

		if(response.Body.CreateXMbxSearchResponse[ZaXMBxSearch.E_searchtask]) {
			var searchTaskElement = response.Body.CreateXMbxSearchResponse[ZaXMBxSearch.E_searchtask];
			if(!(searchTaskElement instanceof Array)) {
				searchTaskElement = [searchTaskElement];
			}			
			var searchTask = new ZaXMBxSearch(ZaApp.getInstance());
			searchTask.initFromJS(searchTaskElement[0]);
			if(searchTask.attrs[ZaXMBxSearch.A_status]!=ZaOperation.STATUS_EROR)	{
				this.closeButtonListener.call(this);
				ZaApp.getInstance().getXMbxSearchListController().show(ZaApp.getInstance().getMailServers());
			}
		}

	}	
}

ZaXMBxSearchViewController.prototype.closeSearchCallback = function(resp) {
	this.closeButtonListener.call(this);
	ZaApp.getInstance().getXMbxSearchListController().show(ZaApp.getInstance().getMailServers());
}

ZaXMBxSearchViewController.prototype.abortSearchCallback = function(resp) {
	if(!resp) {
		var ex = new ZmCsfeException(ZMsg.errorEmptyResponse,ZmCsfeException.CSFE_SVC_ERROR,"ZaXMBxSearchViewController.prototype.querySearchesCallback");
		ZaApp.getInstance().getCurrentController()._handleException(ex, "ZaXMBxSearchViewController.prototype.querySearchesCallback");
		this.doSearchQuery(++ix);
	}	
	if(resp.isException && resp.isException()) {
		ZaApp.getInstance().getCurrentController()._handleException(resp.getException(), "ZaXMBxSearchViewController.prototype.querySearchesCallback");
		this.doSearchQuery(++ix);
	} else {
		var response;
		var respBody;
		if(resp.getResponse) {
			response = resp.getResponse();
			respBody = response.Body.GetXMbxSearchesListResponse ? response.Body.GetXMbxSearchesListResponse : response.Body.AbortXMbxSearchResponse;
		} else if(resp.Body.GetXMbxSearchesListResponse) {
			response = resp;
			respBody = response.Body.GetXMbxSearchesListResponse;
		} else if(resp.Body.AbortXMbxSearchResponse) {
			response = resp;
			respBody = response.Body.AbortXMbxSearchResponse;
		}
		
		if(respBody[ZaXMBxSearch.E_searchtask]) {
			var searchTaskElement = respBody[ZaXMBxSearch.E_searchtask];
			if(!(searchTaskElement instanceof Array)) {
				searchTaskElement = [searchTaskElement];
			}			
			var cnt = searchTaskElement.length;
			var searchTask = new ZaXMBxSearch(ZaApp.getInstance());
			searchTask.initFromJS(searchTaskElement[0]);
			this.show(searchTask);
		}
	}}

ZaXMBxSearchViewController.prototype.abortButtonListener =
function(ev) {
	if(this._containedObject) {
		var callback = new AjxCallback(this, this.abortSearchCallback);
		ZaXMBxSearch.abortXMbxSearch(this._containedObject, callback);
	}
	
}

ZaXMBxSearchViewController.prototype.deleteButtonListener =
function(ev) {
	if(this._contentView) {
		if(this._containedObject) {
			var callback = new AjxCallback(this, this.closeSearchCallback);
			ZaXMBxSearch.deleteXMbxSearch(this._containedObject, callback);
		}
	}
}


ZaXMBxSearchViewController.prototype.getPopUpOperation =
function() {
    return this._popupOperations;
}

/**
*	@method setViewMethod 
*	@param entry - isntance of ZaXMBxSearch class
*/
ZaXMBxSearchViewController.setViewMethod =
function(entry) {
	try {
	   	//create toolbar
		if(!this._UICreated) {
			//this._initToolbar();
            this._initPopupMenu();
			//always add Help button at the end of the toolbar		
	
		  	this._contentView = this._view = new ZaXMBxSearchXFormView(this._container, ZaApp.getInstance());
			var elements = new Object();
			elements[ZaAppViewMgr.C_APP_CONTENT] = this._contentView;
            ZaApp.getInstance().getAppViewMgr().createView(this.getContentViewId(), elements);
		    this._UICreated = true;
		    ZaApp.getInstance()._controllers[this.getContentViewId ()] = this ;
	  	}
	
		ZaApp.getInstance().pushView(this.getContentViewId());
	  	this._contentView.setObject(entry);
	} catch (ex) {
		this._handleException(ex, "ZaXMBxSearchViewController.prototype._setView", null, false);	
	}
	this._currentObject = entry;
}
ZaController.setViewMethods["ZaXMBxSearchViewController"].push(ZaXMBxSearchViewController.setViewMethod);
