/*
 * ***** BEGIN LICENSE BLOCK *****
 * Zimbra Collaboration Suite, Network Edition.
 * Copyright (C) 2007, 2009, 2011, 2013, 2014 Zimbra, Inc.  All Rights Reserved.
 * ***** END LICENSE BLOCK *****
 */

function ZaXMBxZimletPicker(parent) {

	ZaXMBxPicker.call(this, parent, ZaXMBxPicker.ZIMLET);
	this._appCtxt = this.shell.getData(ZaAppCtxt.LABEL);
}

ZaXMBxZimletPicker.prototype = new ZaXMBxPicker();
ZaXMBxZimletPicker.prototype.constructor = ZaXMBxZimletPicker;

ZaXMBxPicker.CTOR[ZaXMBxPicker.ZIMLET] = ZaXMBxZimletPicker;

ZaXMBxZimletPicker.prototype.toString = 
function() {
	return "ZaXMBxZimletPicker";
};

/*
ZaXMBxZimletPicker.prototype._addZimlet =
function(tree, text,  type) {
    var ti = this._zimlets[type] = new DwtCheckbox({parent:tree,className:"AdminTreeItem-Text"});
    ti.setText(text);
    //ti.setImage(imageInfo);
};
*/

ZaXMBxZimletPicker.prototype._addZimlet =
function(text,  type) {
    var ti = this._zimlets[type] = new DwtCheckbox({parent:this._picker});
    ti.setText(text);
    ti.addSelectionListener(new AjxListener(this, ZaXMBxZimletPicker.prototype._selectListener))
};

ZaXMBxZimletPicker.prototype._setupPicker =
function(parent) {
    this._zimlets = {};
   // var idxZimlets = this._appCtxt.getZimletMgr().getIndexedZimlets()
	var allZimlets = ZaZimlet.getAll(ZaZimlet.EXCLUDE_EXTENSIONS, new AjxCallback(this, this._loadZimlet, parent));
/*	
	if(allZimlets instanceof ZaItemList || allZimlets instanceof AjxVector)
		allZimlets = allZimlets.getArray();   
	
	var cnt = allZimlets.length;
	
    if (cnt) {
        var tree = this._tree = new DwtTree(parent, DwtTree.CHECKEDITEM_STYLE);
        tree.addSelectionListener(new AjxListener(this, ZaXMBxZimletPicker.prototype._treeListener));
        for (var i = 0; i < cnt; i ++) {
        	if(!allZimlets[i].attrs[ZaZimlet.A_zimbraZimletKeyword]) {
        		continue;
        	}
			allZimlets[i].load("name", allZimlets[i].name);
	    var desc = ZaZimletListView.__processMessage(allZimlets[i].name, allZimlets[i].attrs[ZaZimlet.A_zimbraZimletDescription ]); 
            this._addZimlet(tree, desc,  allZimlets[i].attrs[ZaZimlet.A_zimbraZimletKeyword]);
        }
    }*/
};

ZaXMBxZimletPicker.prototype._loadZimlet = 
function(parent, allZimlets) {
    if(allZimlets instanceof ZaItemList || allZimlets instanceof AjxVector)
        allZimlets = allZimlets.getArray();

    var cnt = allZimlets.length;

    if (cnt) {
        /*
        var tree  = new DwtTree(parent, DwtTree.CHECKEDITEM_STYLE);
        tree.delClassName("DwtTree");
        this._tree = tree;
        tree.addSelectionListener(new AjxListener(this, ZaXMBxZimletPicker.prototype._treeListener));
        for (var i = 0; i < cnt; i ++) {
            if(!allZimlets[i].attrs[ZaZimlet.A_zimbraZimletKeyword]) {
                continue;
            }
            allZimlets[i].load("name", allZimlets[i].name);
            var desc = ZaZimletListView.__processMessage(allZimlets[i].name, allZimlets[i].attrs[ZaZimlet.A_zimbraZimletDescription ]);
            this._addZimlet(tree, desc,  allZimlets[i].attrs[ZaZimlet.A_zimbraZimletKeyword]);
        }
        */

        for (var i = 0; i < cnt; i ++) {
            if(!allZimlets[i].attrs[ZaZimlet.A_zimbraZimletKeyword]) {
                continue;
            }
            allZimlets[i].load("name", allZimlets[i].name);
            var desc = ZaZimletListView.__processMessage(allZimlets[i].name, allZimlets[i].attrs[ZaZimlet.A_zimbraZimletDescription ]);
            this._addZimlet(desc,  allZimlets[i].attrs[ZaZimlet.A_zimbraZimletKeyword]);
        }
    }

}

ZaXMBxZimletPicker.prototype._updateQuery = 
function() {
	var types = new Array();
	for (var type in this._zimlets)
		//if (this._zimlets[type].getChecked())
		if (this._zimlets[type].isSelected())
			types.push(type);

	if (types.length) {
		var query = types.join(" OR ");
		if (types.length > 1)
			query = "(" + query + ")";
		this.setQuery("has:" + query);
	} else {
		this.setQuery("");
	}
//	this.execute();
}

/*
ZaXMBxZimletPicker.prototype._treeListener =
function(ev) {
 	if (ev.detail == DwtTree.ITEM_CHECKED) {
 		// bug fix #7057 - remove when new version of safari is release
 		// see http://bugzilla.opendarwin.org/show_bug.cgi?id=7279
 		if (AjxEnv.isSafari)
 			ev.item._checkBox.checked = !ev.item._checkBox.checked;
 		this._updateQuery();
 	}
}
*/

ZaXMBxZimletPicker.prototype._selectListener =
function(ev) {
	if (ev.detail) { // true or false, only two values
		if (AjxEnv.isSafari) {
			//sarafi 5.0 has fixed such problem
			//so not need to 'ev.item.checked = !ev.item.checked;'
		}
		this._updateQuery();
	}
}
