/*
 * ***** BEGIN LICENSE BLOCK *****
 * Zimbra Collaboration Suite, Network Edition.
 * Copyright (C) 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014 Zimbra, Inc.  All Rights Reserved.
 * ***** END LICENSE BLOCK *****
 */
if(ZaSettings && ZaSettings.EnabledZimlet["com_zimbra_backuprestore"]){
function ZaHotBackup() {

}
//ZaHotBackup.GlobalConfigTabIndex = 10;
ZaOperation.MAIL_RESTORE = ++ZA_OP_INDEX;
ZaOperation.IMMEDIATE_BACKUP = ++ZA_OP_INDEX;
ZaOperation.ABORT_BACKUP = ++ZA_OP_INDEX;
ZaOperation.CONFIGURE_BACKUP = ++ZA_OP_INDEX;
ZaOperation.MOVE_ACCOUNT = ++ZA_OP_INDEX;
ZaHotBackup.ABORT_OPERATION = 1;
ZaHotBackup.SEARCH_OPERATION = 2;
ZaZimbraAdmin._BACKUPS = ZaZimbraAdmin.VIEW_INDEX++;
ZaZimbraAdmin._BACKUPS_BY_SERVER_VIEW = ZaZimbraAdmin.VIEW_INDEX++;
ZaHotBackup.DEFAULT_BACKUP_TARGET = "/opt/zimbra/backup";
ZaHotBackup.BACKUP_MODE_STANDARD = "Standard";
ZaHotBackup.BACKUP_MODE_AUTOGROUP = "Auto-Grouped";
ZaHotBackup.BACKUP_MODE_CHOICES=[{value:ZaHotBackup.BACKUP_MODE_STANDARD, label:com_zimbra_backuprestore.BNR_backupModeStandard},{value:ZaHotBackup.BACKUP_MODE_AUTOGROUP, label:com_zimbra_backuprestore.BNR_backupModeAutoGroup}];
ZmCsfeException.INVALID_BACKUP_TARGET = "backup.INVALID_BACKUP_TARGET";
ZmCsfeException.NO_LABELS_FOUND = "backup.NO_LABELS_FOUND";
ZmCsfeException.CANNOT_ABORT_COMPLETED_BACKUP = "backup.CANNOT_ABORT_COMPLETED_BACKUP";
if(ZaGlobalConfig) {
	ZaGlobalConfig.A_zimbraComponentAvailable_hotbackup = "_"+ZaGlobalConfig.A_zimbraComponentAvailable+"_hotbackup";
	ZaGlobalConfig.A_zimbraBackupReportEmailRecipients  = "zimbraBackupReportEmailRecipients";	
	ZaGlobalConfig.A_zimbraBackupReportEmailSender  = "zimbraBackupReportEmailSender";	
	ZaGlobalConfig.A_zimbraBackupReportEmailSubjectPrefix  = "zimbraBackupReportEmailSubjectPrefix";
	ZaGlobalConfig.A_zimbraBackupTarget  = "zimbraBackupTarget";
	ZaGlobalConfig.A_zimbraBackupMode = "zimbraBackupMode";
	ZaGlobalConfig.A_zimbraBackupAutoGroupedNumGroups = "zimbraBackupAutoGroupedNumGroups";
	ZaGlobalConfig.A_zimbraBackupAutoGroupedThrottled = "zimbraBackupAutoGroupedThrottled";
	ZaGlobalConfig.A_zimbraBackupMinFreeSpace = "zimbraBackupMinFreeSpace";
 
	if(ZaGlobalConfig.myXModel) {
		ZaGlobalConfig.myXModel.items.push(
		  	{ id:ZaGlobalConfig.A_zimbraBackupTarget, ref:"attrs/" + ZaGlobalConfig.A_zimbraBackupTarget, type: _STRING_}
		  	);
		ZaGlobalConfig.myXModel.items.push(
		  	{ id:ZaGlobalConfig.A_zimbraBackupReportEmailSubjectPrefix, ref:"attrs/" + ZaGlobalConfig.A_zimbraBackupReportEmailSubjectPrefix, type: _STRING_}
		  	);
		ZaGlobalConfig.myXModel.items.push(
		  	{ id:ZaGlobalConfig.A_zimbraBackupReportEmailSender, ref:"attrs/" + ZaGlobalConfig.A_zimbraBackupReportEmailSender, type: _STRING_}
		  	);
		ZaGlobalConfig.myXModel.items.push(
		  	{ id:ZaGlobalConfig.A_zimbraBackupReportEmailRecipients, ref:"attrs/" + ZaGlobalConfig.A_zimbraBackupReportEmailRecipients, type: _LIST_,listItem:{type:_STRING_}}
		  	);
		ZaGlobalConfig.myXModel.items.push(
		  	{ id:ZaGlobalConfig.A_zimbraBackupMode, ref:"attrs/" + ZaGlobalConfig.A_zimbraBackupMode, type:_STRING_, choices:ZaHotBackup.BACKUP_MODE_CHOICES}
		  	);
		ZaGlobalConfig.myXModel.items.push(
		  	{ id:ZaGlobalConfig.A_zimbraBackupAutoGroupedNumGroups, ref:"attrs/" + ZaGlobalConfig.A_zimbraBackupAutoGroupedNumGroups, type:_NUMBER_}
		  	);
		ZaGlobalConfig.myXModel.items.push(
		  	{ id:ZaGlobalConfig.A_zimbraBackupAutoGroupedThrottled, ref:"attrs/" + ZaGlobalConfig.A_zimbraBackupAutoGroupedThrottled, type:_ENUM_, choices:ZaModel.BOOLEAN_CHOICES}
		  	);
        ZaGlobalConfig.myXModel.items.push(
                { id:ZaGlobalConfig.A_zimbraBackupMinFreeSpace, ref:"attrs/" + ZaGlobalConfig.A_zimbraBackupMinFreeSpace, type: _STRING_}
        );		  	
	}		
}

if(ZaSettings) {
	ZaSettings.BACKUP_VIEW = "backupsView";
	ZaSettings.ALL_UI_COMPONENTS.push({ value: ZaSettings.BACKUP_VIEW, label: com_zimbra_backuprestore.UI_Comp_backupsView });
	ZaSettings.OVERVIEW_TOOLS_ITEMS.push(ZaSettings.BACKUP_VIEW);
    ZaSettings.VIEW_RIGHTS [ZaSettings.BACKUP_VIEW] = "adminConsoleBackupRights" ;
}

if(ZaServer) {
	ZaServer.A_zimbraBackupMode = "zimbraBackupMode";
	ZaServer.A_zimbraBackupAutoGroupedThrottled = "zimbraBackupAutoGroupedThrottled";
	ZaServer.A_zimbraBackupAutoGroupedNumGroups = "zimbraBackupAutoGroupedNumGroups";
 	ZaServer.A_zimbraBackupMinFreeSpace = "zimbraBackupMinFreeSpace";	
	if(ZaServer.myXModel) {
		ZaServer.myXModel.items.push(
		  	{ id:ZaServer.A_zimbraBackupMode, ref:"attrs/" + ZaServer.A_zimbraBackupMode, type:_COS_STRING_}
		  	);	
		ZaServer.myXModel.items.push(
		  	{ id:ZaServer.A_zimbraBackupAutoGroupedNumGroups, ref:"attrs/" + ZaServer.A_zimbraBackupAutoGroupedNumGroups, type:_COS_NUMBER_}
		  	);
		ZaServer.myXModel.items.push(
		  	{ id:ZaServer.A_zimbraBackupAutoGroupedThrottled, ref:"attrs/" + ZaServer.A_zimbraBackupAutoGroupedThrottled, type:_COS_ENUM_, choices:ZaModel.BOOLEAN_CHOICES}
		  	);	
                ZaServer.myXModel.items.push(
                        { id:ZaServer.A_zimbraBackupMinFreeSpace, ref:"attrs/" + ZaServer.A_zimbraBackupMinFreeSpace, type:_COS_STRING_}
                        );
	  	
		  	
	}
}
ZaHotBackup.globConfigLoadMethod = 
function(by, val, withConfig) {
	if(this.attrs[ZaGlobalConfig.A_zimbraBackupTarget])
		ZaHotBackup.DEFAULT_BACKUP_TARGET = AjxStringUtil.trim(this.attrs[ZaGlobalConfig.A_zimbraBackupTarget]);
	if(!this.attrs[ZaGlobalConfig.A_zimbraBackupReportEmailRecipients])
		this.attrs[ZaGlobalConfig.A_zimbraBackupReportEmailRecipients] = [];
	else if(!(this.attrs[ZaGlobalConfig.A_zimbraBackupReportEmailRecipients] instanceof Array)) {
		this.attrs[ZaGlobalConfig.A_zimbraBackupReportEmailRecipients] = [this.attrs[ZaGlobalConfig.A_zimbraBackupReportEmailRecipients]];
	}
}
ZaItem.loadMethods["ZaGlobalConfig"].push(ZaHotBackup.globConfigLoadMethod);

ZaHotBackup.globConfigModifyMethod = 
function(mods) {
	if(mods[ZaGlobalConfig.A_zimbraBackupTarget]) {
		ZaHotBackup.DEFAULT_BACKUP_TARGET = mods[ZaGlobalConfig.A_zimbraBackupTarget]; 
	}	
	//if switched to autogroup run zmschedulebackup on all servers
	if(mods[ZaGlobalConfig.A_zimbraBackupMode] == ZaHotBackup.BACKUP_MODE_AUTOGROUP) {
		var allSrvrs = ZaApp.getInstance().getBackupServerList();
		if(allSrvrs) {
			allSrvrs = allSrvrs.getArray();
			var cnt = allSrvrs.length;
			for(var i=0; i<cnt; i++) {
				if(!allSrvrs[i].attrs[ZaServer.A_zimbraBackupMode])
					allSrvrs[i].scheduleBackups();
			}
		}
	}
}
ZaItem.modifyMethods["ZaGlobalConfig"].push(ZaHotBackup.globConfigModifyMethod);

ZaHotBackup.globConfigBeforeModify = 
function(mods) {
        if(mods[ZaGlobalConfig.A_zimbraBackupTarget]) {
                mods[ZaGlobalConfig.A_zimbraBackupTarget] = AjxStringUtil.trim(mods[ZaGlobalConfig.A_zimbraBackupTarget]);
	}
}
ZaItem.modifyMethodsExt["ZaGlobalConfig"].push(ZaHotBackup.globConfigBeforeModify);

ZaHotBackup.onRepeatRemove = 
function (index, form) {
	var list = this.getInstanceValue();
	if (list == null || typeof(list) == "string" || index >= list.length || index<0) return;
	list.splice(index, 1);
        this.setInstanceValue(list);
	form.parent.setDirty(true);
}

ZaHotBackup.GC_BNR_TAB_RIGHTS = [];
ZaHotBackup.GC_BNR_TAB_ATTRIBUTES = [ZaGlobalConfig.A_zimbraBackupMode,ZaGlobalConfig.A_zimbraBackupAutoGroupedNumGroups,
                                  ZaGlobalConfig.A_zimbraBackupAutoGroupedThrottled,ZaGlobalConfig.A_zimbraBackupTarget,
                                  ZaGlobalConfig.A_zimbraBackupReportEmailSender,ZaGlobalConfig.A_zimbraBackupReportEmailSubjectPrefix,
                                  ZaGlobalConfig.A_zimbraBackupReportEmailRecipients, ZaGlobalConfig.A_zimbraBackupMinFreeSpace];
ZaHotBackup.GlobalConfigXFormModifier = function (xFormObject, entry) {
	if(ZaTabView.isTAB_ENABLED(entry,ZaHotBackup.GC_BNR_TAB_ATTRIBUTES, ZaHotBackup.GC_BNR_TAB_RIGHTS)) {
		var tabBar = xFormObject.items[1] ;
		ZaHotBackup.GlobalConfigTabIndex = ++this.TAB_INDEX;
		tabBar.choices.push({value:ZaHotBackup.GlobalConfigTabIndex , label:com_zimbra_backuprestore.BNR_Tab_BNR});	
		
		var backupTabView = {
			type:_ZATABCASE_, caseKey:ZaHotBackup.GlobalConfigTabIndex,
			colSizes:["auto"],numCols:1, width: "100%",
			items:[
				{type:_ZA_TOP_GROUPER_, numCols:2, colSizes:["275", "*"], width: "100%",
                    label: com_zimbra_backuprestore.BNR_Tab_BNR,
                    items:[
					{ref:ZaGlobalConfig.A_zimbraBackupMode, type:_OSELECT1_,label:com_zimbra_backuprestore.BNR_zimbraBackupMode,labelLocation:_LEFT_, choices:ZaHotBackup.BACKUP_MODE_CHOICES},
					{ref:ZaGlobalConfig.A_zimbraBackupAutoGroupedNumGroups, type:_INPUT_,label:com_zimbra_backuprestore.BNR_zimbraBackupAutoGroupedNumGroups,width:"5em",
						enableDisableChecks:[[XForm.checkInstanceValue,ZaGlobalConfig.A_zimbraBackupMode,ZaHotBackup.BACKUP_MODE_AUTOGROUP]],
						enableDisableChangeEventSources:[ZaGlobalConfig.A_zimbraBackupMode]
					},
					{ref:ZaGlobalConfig.A_zimbraBackupAutoGroupedThrottled, type:_CHECKBOX_,
					  	label: com_zimbra_backuprestore.BNR_zimbraBackupAutoGroupedThrottled,
					  	trueValue: "TRUE", falseValue: "FALSE",
						enableDisableChecks:[[XForm.checkInstanceValue,ZaGlobalConfig.A_zimbraBackupMode,ZaHotBackup.BACKUP_MODE_AUTOGROUP]],
						enableDisableChangeEventSources:[ZaGlobalConfig.A_zimbraBackupMode]				  		
					},
					{ref:ZaGlobalConfig.A_zimbraBackupTarget, type:_TEXTFIELD_,
	                    cssClass:"admin_xform_name_input", width:230, label:com_zimbra_backuprestore.BNR_zimbraBackupTarget},
					{ref:ZaGlobalConfig.A_zimbraBackupReportEmailSender, type:_TEXTFIELD_,
	                    cssClass:"admin_xform_name_input", width:230, label:com_zimbra_backuprestore.BNR_zimbraBackupReportEmailSender},
					{ref:ZaGlobalConfig.A_zimbraBackupReportEmailSubjectPrefix, type:_TEXTFIELD_,
	                    cssClass:"admin_xform_name_input", width:230, label:com_zimbra_backuprestore.BNR_zimbraBackupReportEmailSubjectPrefix},
                                        { type: _DWT_ALERT_, containerCssStyle: "padding-bottom:0px", style: DwtAlert.INFO, iconVisible: true, content: com_zimbra_backuprestore.BNR_zimbraBackupMinFreespaceConfInfo},
					{ref:ZaGlobalConfig.A_zimbraBackupMinFreeSpace, type:_TEXTFIELD_,
                            cssClass:"admin_xform_name_input", width:230, label:com_zimbra_backuprestore.BNR_zimbraBackupMinFreeSpace},
					{ref:ZaGlobalConfig.A_zimbraBackupReportEmailRecipients,type:_REPEAT_,
						labelCssClass:"xform_repeat_label", label:com_zimbra_backuprestore.BNR_zimbraBackupReportEmailRecipients,
						addButtonLabel:ZaMsg.NAD_AddAddress, 
						align:_LEFT_,
						repeatInstance:"", showAddButton:true, showRemoveButton:true, 
						showAddOnNextRow:true, 
						removeButtonLabel:ZaMsg.NAD_RemoveAddress,								
						items: [
							{ref:".", type:_TEXTFIELD_, label:null,  width:230}
						],
						onRemove:ZaHotBackup.onRepeatRemove
					}				
				]}
			]
		};
		
		for (var i=0;i<xFormObject.items.length;i++) {
			if(xFormObject.items[i].type=="switch") {
				xFormObject.items[i].items.push(backupTabView);
				break;
			}
		}
	}
}
if(ZaTabView.XFormModifiers["GlobalConfigXFormView"]) {
	ZaTabView.XFormModifiers["GlobalConfigXFormView"].push(ZaHotBackup.GlobalConfigXFormModifier);
}

ZaHotBackup.SERVER_BNR_TAB_RIGHTS = [];
ZaHotBackup.SERVER_BNR_TAB_ATTRIBUTES = [ZaServer.A_zimbraBackupMode,ZaServer.A_zimbraBackupAutoGroupedNumGroups,
                                         ZaServer.A_zimbraBackupAutoGroupedThrottled, ZaServer.A_zimbraBackupMinFreeSpace];

ZaHotBackup.ServerXFormModifier = function (xFormObject, entry) {
	if(ZaTabView.isTAB_ENABLED(entry,ZaHotBackup.SERVER_BNR_TAB_ATTRIBUTES, ZaHotBackup.SERVER_BNR_TAB_RIGHTS)) {	
		var tabBar = xFormObject.items[1] ;
		ZaHotBackup.ServerConfigTabIndex = ++this.TAB_INDEX;
		tabBar.choices.push({value:ZaHotBackup.ServerConfigTabIndex , label:com_zimbra_backuprestore.BNR_Tab_BNR});	
		
		var backupTabView = {
			type:_ZATABCASE_, caseKey:ZaHotBackup.ServerConfigTabIndex,
			colSizes:["auto"],numCols:1, width:(appNewUI? "98%":"100%"),
			items:[
				{type:_ZA_TOP_GROUPER_, numCols:2, colSizes:["275", "*"],
                    label: com_zimbra_backuprestore.BNR_Tab_BNR, items:[
					{ref:ZaServer.A_zimbraBackupMode, type:_SUPER_SELECT1_,
	                    resetToSuperLabel:ZaMsg.NAD_ResetToGlobal,label:com_zimbra_backuprestore.BNR_zimbraBackupMode,
	                    labelLocation:_LEFT_, choices:ZaHotBackup.BACKUP_MODE_CHOICES},
					{ref:ZaServer.A_zimbraBackupAutoGroupedNumGroups, type:_INPUT_,label:com_zimbra_backuprestore.BNR_zimbraBackupAutoGroupedNumGroups,width:"5em",
						enableDisableChecks:[[XForm.checkInstanceValue,ZaServer.A_zimbraBackupMode,ZaHotBackup.BACKUP_MODE_AUTOGROUP]],
						enableDisableChangeEventSources:[ZaServer.A_zimbraBackupMode]
					},
					{ref:ZaServer.A_zimbraBackupAutoGroupedThrottled, type:_CHECKBOX_,
					  	label: com_zimbra_backuprestore.BNR_zimbraBackupAutoGroupedThrottled,
					  	trueValue: "TRUE", falseValue: "FALSE",
						enableDisableChecks:[[XForm.checkInstanceValue,ZaServer.A_zimbraBackupMode,ZaHotBackup.BACKUP_MODE_AUTOGROUP]],
						enableDisableChangeEventSources:[ZaServer.A_zimbraBackupMode]				  		
					},
                    { type: _DWT_ALERT_, colSpan: 3, containerCssStyle: "padding-bottom:0px",
                        style: DwtAlert.INFO, iconVisible: true,
                        content: com_zimbra_backuprestore.BNR_zimbraBackupMinFreespaceConfInfo},
                    { ref: ZaServer.A_zimbraBackupMinFreeSpace, type:_SUPER_TEXTFIELD_,
                        txtBoxLabel: com_zimbra_backuprestore.BNR_zimbraBackupMinFreeSpace,
                        width: "5em",resetToSuperLabel:ZaMsg.NAD_ResetToGlobal}
				]}

			]
		};
		
		for (var i=0;i<xFormObject.items.length;i++) {
			if(xFormObject.items[i].type=="switch") {
				xFormObject.items[i].items.push(backupTabView);
				break;
			}
		}	
	}
}
//if(ZaTabView.XFormModifiers["ZaServerXFormView"]) {
	ZaTabView.XFormModifiers["ZaServerXFormView"].push(ZaHotBackup.ServerXFormModifier);
//}

ZaApp.prototype.getBackupServerList =
function(refresh) {
	if (refresh || this._backupServerList == null) {
		this._backupServerList = ZaServerBackup.getAll();
	}
	return this._backupServerList;	
}

ZaApp.prototype.getBackupsViewController = function () {
    if (this._controllers[ZaZimbraAdmin._BACKUPS_BY_SERVER_VIEW] == null) {
        this._controllers[ZaZimbraAdmin._BACKUPS_BY_SERVER_VIEW] = new ZaBackupsViewController(this._appCtxt, this._container);
    }
    return this._controllers[ZaZimbraAdmin._BACKUPS_BY_SERVER_VIEW];
}

ZaApp.prototype.getBackupLabelViewController =
function(viewId) {
	if (viewId && this._controllers[viewId] != null) {
		return this._controllers[viewId];
	}else{
		return new ZaBackupLabelViewController(this._appCtxt, this._container, this);
	}
}

ZaApp.prototype.getBackupServerListController =
function() {
	if (this._controllers[ZaZimbraAdmin._BACKUPS] == null)
		this._controllers[ZaZimbraAdmin._BACKUPS] = new ZaBackupServerListController(this._appCtxt, this._container, this);
	return this._controllers[ZaZimbraAdmin._BACKUPS];
}

ZaHotBackup.backupsServerListTreeListener = function (ev) {
	if(ZaApp.getInstance().getCurrentController()) {
		ZaApp.getInstance().getCurrentController().switchToNextView(ZaApp.getInstance().getBackupServerListController(),ZaBackupServerListController.prototype.show, ZaServerBackup.getAll());
	} else {					
		ZaApp.getInstance().getBackupServerListController().show(ZaServerBackup.getAll());
	}
}

ZaHotBackup.backupsByServerTreeListener = function (ev) {
	var currentServer = ZaApp.getInstance().getBackupServerList().getItemById(ev.item.getData(ZaOverviewPanelController._OBJ_ID));	
	if(ZaApp.getInstance().getCurrentController()) {
		ZaApp.getInstance().getCurrentController().switchToNextView(ZaApp.getInstance().getBackupsViewController(),ZaBackupsViewController.prototype.show, currentServer);
	} else {					
		ZaApp.getInstance().getBackupsViewController().show(currentServer);
	}
}

ZaHotBackup.backupOvTreeModifier = function (tree) {
	if(ZaSettings.ENABLED_UI_COMPONENTS[ZaSettings.BACKUP_VIEW] || ZaSettings.ENABLED_UI_COMPONENTS[ZaSettings.CARTE_BLANCHE_UI]) {
		try {
			//add server statistics nodes
			var serverList = ZaApp.getInstance().getBackupServerList().getArray();
			if(serverList && serverList.length) {
                if (!appNewUI) {
                    this._backupTi = new DwtTreeItem({parent:this._toolsTi,className:"AdminTreeItem"});
                    this._backupTi.setText(com_zimbra_backuprestore.BNR_OVP_backups);
                    this._backupTi.setImage("Backup");

                    var cnt = serverList.length;
                    if(cnt>1) {
                        this._backupTi.setData(ZaOverviewPanelController._TID, ZaZimbraAdmin._BACKUPS);
                        for(var ix=0; ix< cnt; ix++) {
                            var ti1 = new DwtTreeItem({parent:this._backupTi,className:"AdminTreeItem"});
                            ti1.setText(serverList[ix].name);
                            ti1.setImage("Server");
                            ti1.setData(ZaOverviewPanelController._TID, ZaZimbraAdmin._BACKUPS_BY_SERVER_VIEW);
                            ti1.setData(ZaOverviewPanelController._OBJ_ID, serverList[ix].id);
                        }
                        ZaOverviewPanelController.overviewTreeListeners[ZaZimbraAdmin._BACKUPS] = ZaHotBackup.backupsServerListTreeListener;
                    } else {
                        this._backupTi.setData(ZaOverviewPanelController._OBJ_ID, serverList[0].id);
                        this._backupTi.setData(ZaOverviewPanelController._TID, ZaZimbraAdmin._BACKUPS_BY_SERVER_VIEW);
                    }
                } else {
                    var parentPath = ZaTree.getPathByArray([ZaMsg.OVP_home, ZaMsg.OVP_toolMig]);
                    var cnt = serverList.length;
                    var ti;
                    if (cnt > 0) {
                        ti = new ZaTreeItemData({
                                    parent:parentPath,
                                    id:ZaId.getTreeItemId(ZaId.PANEL_APP,"magHV",null, "BackUpHV"),
                                    className: "AdminHomeTreeItem",
                                    text: com_zimbra_backuprestore.BNR_OVP_backups,
                                    mappingId: ZaZimbraAdmin._BACKUPS});
                        ti.setData(ZaOverviewPanelController._TID, ZaZimbraAdmin._BACKUPS);
                        tree.addTreeItemData(ti);
                        var subParentPath = ZaTree.getPathByArray([ZaMsg.OVP_home, ZaMsg.OVP_toolMig, com_zimbra_backuprestore.BNR_OVP_backups]);
                        for(var ix=0; ix< cnt; ix++) {
                            var ti1 = new ZaTreeItemData({
                                    parent:subParentPath,
                                    id:DwtId._makeId(ti.id, ix + 1),
                                    text: serverList[ix].name,
                                    mappingId: ZaZimbraAdmin._BACKUPS_BY_SERVER_VIEW});
                            ti1.setData(ZaOverviewPanelController._OBJ_ID, serverList[ix].id);
                            tree.addTreeItemData(ti1);
                        }
                        ZaOverviewPanelController.overviewTreeListeners[ZaZimbraAdmin._BACKUPS] = ZaHotBackup.backupsServerListTreeListener;
                    } else {
                        ti = new ZaTreeItemData({
                                    parent:parentPath,
                                    id:ZaId.getTreeItemId(ZaId.PANEL_APP, "magHV", null, "BAckUpHV"),
                                    text: com_zimbra_backuprestore.BNR_OVP_backups,
                                    mappingId: ZaZimbraAdmin._BACKUPS_BY_SERVER_VIEW});
                        ti.setData(ZaOverviewPanelController._OBJ_ID, serverList[0].id);
                        tree.addTreeItemData(ti);
                    }
                }
				ZaOverviewPanelController.overviewTreeListeners[ZaZimbraAdmin._BACKUPS_BY_SERVER_VIEW] = ZaHotBackup.backupsByServerTreeListener;							
			}
		} catch (ex) {
			this._handleException(ex, "ZaOverviewPanelController.prototype._buildFolderTree", null, false);
		}
		

	}
}

ZaHotBackup.configureBackup = function(ev) {
    var tree = ZaZimbraAdmin.getInstance().getOverviewPanelController().getOverviewPanel().getFolderTree();
    var path = ZaTree.getPathByArray([ZaMsg.OVP_home, ZaMsg.OVP_configure, ZaMsg.OVP_global]);
    tree.setSelectionByPath(path, false);
    var path = ZaTree.getPathByArray([ZaMsg.OVP_home, ZaMsg.OVP_configure, ZaMsg.OVP_global, com_zimbra_backuprestore.BNR_Tab_BNR]);
    tree.setSelectionByPath(path, true);
}

if(ZaOverviewPanelController.treeModifiers)
	ZaOverviewPanelController.treeModifiers.push(ZaHotBackup.backupOvTreeModifier);


if (ZaHome && ZaHome.myXModel) {
    ZaHome.A2_lastBackupTime = "lastBackupTime";
    ZaHome.A2_lastBackup = "lastBackup";
    ZaHome.myXModel.items.push(
       {id:ZaHome.A2_lastBackupTime, type:_STRING_, ref: "attrs/" + ZaHome.A2_lastBackupTime}
    );
    ZaHome.myXModel.items.push(
       {id:ZaHome.A2_lastBackup, type:_ENUM_, ref: "attrs/" + ZaHome.A2_lastBackup, choices: ZaModel.BOOLEAN_CHOICES}
    );
    ZaHome.loadBackup = function () {
        this.attrs[ZaHome.A2_lastBackup] = true;
        this.attrs[ZaHome.A2_lastBackupTime] =  ZaMsg.MSG_HomeLoading;
    }
    ZaItem.loadMethods["ZaHome"].push(ZaHome.loadBackup);

    ZaHome.startLoadingBackups = function() {
    	if(!(ZaSettings.ENABLED_UI_COMPONENTS[ZaSettings.BACKUP_VIEW] || ZaSettings.ENABLED_UI_COMPONENTS[ZaSettings.CARTE_BLANCHE_UI])) {
            return ;
        }
   	 	ZaHome.backupInfo = {isError:false,lastBackupTime:null};
   	 	ZaHome.lastBackupTime = -1;
		var callback = new AjxCallback(this,ZaHome.startLoadingBackupsCallback);
		ZaServerBackup.getAll(callback);
   }
   
   ZaHome.startLoadingBackupsCallback = function(resp) {
		if(resp.getResponse() && resp.getResponse().Body && resp.getResponse().Body.GetAllServersResponse) {
			var list = new ZaItemList(ZaServerBackup);
			list.loadFromJS(resp.getResponse().Body.GetAllServersResponse);
			var serverArray = list.getArray();
			for(var i=0;i<serverArray.length;i++) {
				var server = serverArray[i];
				var callback = new AjxCallback(this,ZaHome.loadServerBackup);
				server.loadBackups(false,callback);
			}
		}
   }
   ZaHome.postLoadDataFunction.push(ZaHome.startLoadingBackups);
   
   ZaHome.lastBackupTime = -1;
   ZaHome.loadServerBackup = function (resp) {
   	if (resp && resp.getException) {
           if (!resp.getException()) {
               var response;
               if(resp.getResponse) {
                   response = resp.getResponse();
               } else if(resp.Body.BackupQueryResponse) {
                   response = resp;
               }

               var backup = null;
               if(response.Body.BackupQueryResponse.backup) {
                   backup = response.Body.BackupQueryResponse.backup;
                   if(!(backup instanceof Array)) {
                       backup = [backup];
                   }

                   var cnt = backup.length;
                   for(var i =0; i < cnt; i++) {
                   	ZaHome.backupInfo = {isError:false,lastBackupTime:null};
                       var bckpLabel = new ZaBackupLabel();
                       try {
                           bckpLabel.initFromJS(backup[i]);
                       } catch (ex) {
                       	//
                       }
                       if (bckpLabel.errorCount && bckpLabel.errorCount > 0) {
                       	ZaHome.backupInfo.isError = true;
                       }

                       if (bckpLabel.end && bckpLabel.end > ZaHome.lastBackupTime)  {
                    	   ZaHome.lastBackupTime = ZaHome.backupInfo.lastBackupTime = bckpLabel.end;
                       }
                       this.updateBackupInfo(ZaHome.backupInfo);
                   }
               } else {
            	   var homeController = ZaApp.getInstance().getHomeViewController();
            	   var lastBackTimeString = com_zimbra_backuprestore.BNR_NeverBackup;
            	   homeController.setInstanceValue(false, ZaHome.A2_lastBackup);	
            	   homeController.setInstanceValue(lastBackTimeString, ZaHome.A2_lastBackupTime);
               }
           }
       }
   }

   ZaHome.prototype.updateBackupInfo = function(backupInfo) {
        var homeController = ZaApp.getInstance().getHomeViewController();
        
        var lastBackTimeString = com_zimbra_backuprestore.BNR_NeverBackup;
        if (backupInfo.lastBackupTime > 0) {
        	homeController.setInstanceValue(!backupInfo.isError, ZaHome.A2_lastBackup);
        	var date = new Date(parseInt(backupInfo.lastBackupTime));
        	var formatter = AjxDateFormat.getDateInstance(AjxDateFormat.LONG);
        	var currentTime = formatter.format(date);
        	lastBackTimeString = currentTime;
        } else {
        	homeController.setInstanceValue(false, ZaHome.A2_lastBackup);	
        }
        homeController.setInstanceValue(lastBackTimeString, ZaHome.A2_lastBackupTime);
    }
}




if(ZaTabView.XFormModifiers["ZaHomeXFormView"]) {

    ZaHomeXFormView.onConfigureBackup = function(ev) {
        ZaHotBackup.configureBackup.call(this, ev);
    }

    ZaHotBackup.HomeXFormModifier = function (xFormObject) {
        if (ZaSettings.ENABLED_UI_COMPONENTS[ZaSettings.BACKUP_VIEW] ||
            ZaSettings.ENABLED_UI_COMPONENTS[ZaSettings.CARTE_BLANCHE_UI]) {

            var infoItem = ZaHomeXFormView.getWarningPanelItem(xFormObject);
            infoItem.items.push(
                {
                    type: _GROUP_,
                    numCols: 3,
                    width: "100%",
                    colSizes: ZaHomeXFormView.getWarningPanelCol(),
                    visibilityChecks: [
                        [
                            XForm.checkInstanceValue,
                            ZaHome.A2_lastBackup,
                            false
                        ]
                    ],
                    containerCssClass: "ZaHomeWarnginItem",
                    visibilityChangeEventSources: [
                        ZaHome.A2_lastBackup
                    ],
                    items: [
                        {
                            type: _OUTPUT_,
                            ref: ZaHome.A2_lastBackup,
                            bmolsnr: true,
                            valueChangeEventSources: [
                                ZaHome.A2_lastBackupTime
                            ],
                            getDisplayValue: function (value) {
                                var lastBackupTime = this.getInstanceValue(ZaHome.A2_lastBackupTime);
                                if (lastBackupTime != ZaMsg.MSG_HomeLoading) {
                                    if (!value) {
                                        return AjxImg.getImageHtml("Information");
                                    } else {
                                        return AjxImg.getImageHtml("Warning");
                                    }
                                }
                            }
                        },
                        {
                            type: _OUTPUT_,
                            ref: ZaHome.A2_lastBackup,
                            bmolsnr: true,
                            valueChangeEventSources: [
                                ZaHome.A2_lastBackupTime
                            ],
                            getDisplayValue: function (value) {
                                var lastBackupTime = this.getInstanceValue(ZaHome.A2_lastBackupTime);

                                var textStr = "";
                                if (lastBackupTime == com_zimbra_backuprestore.BNR_NeverBackup) {
                                    textStr = com_zimbra_backuprestore.BNR_NoBackupAvailable;
                                } else {
                                    textStr = com_zimbra_backuprestore.BNR_BackupFail;
                                }

                                return textStr;
                            }
                        },
                        {
                            type: _OUTPUT_,
                            value: com_zimbra_backuprestore.BNR_ViewBackup,
                            containerCssClass: "ZaLinkedItem",
                            onClick: ZaHomeXFormView.onConfigureBackup
                        }
                    ]
                }
            );

            var maintainItem = ZaHomeXFormView.getHomeMaintenanceItem(xFormObject);
            maintainItem.items.push(
                {
                    type: _OUTPUT_,
                    label: com_zimbra_backuprestore.LBL_HomeLastBackup,
                    ref: ZaHome.A2_lastBackup,
                    bmolsnr: true,
                    visibilityChecks: [],
                    valueChangeEventSources: [
                        ZaHome.A2_lastBackupTime
                    ],
                    cssStyle: "position:relative;",
                    getDisplayValue: function (value) {
                        var imgStr = "";
                        var lastBackupTime = this.getInstanceValue(ZaHome.A2_lastBackupTime);
                        var imgCssStyle;
                        if (lastBackupTime != ZaMsg.MSG_HomeLoading) {
                            imgCssStyle = "position:absolute;left:0px;"
                            if (value) {
                                imgStr =  AjxImg.getImageHtml ("Check", imgCssStyle);
                            } else {
                                imgStr =  AjxImg.getImageHtml ("Cancel", imgCssStyle);
                            }
                        }

                        var textStr = "";
                        if (lastBackupTime != "") {
                            textStr = [
                                "<span style='margin-left:16px;'>",
                                lastBackupTime,
                                "</span>"
                            ].join("");
                        }

                        return imgStr + textStr;
                    }
                }
            );

            var setupItem = ZaHomeXFormView.getHomeSetupItem(xFormObject);
            var labelItem = setupItem.headerLabels;
            var contentItem = setupItem.contentItems;
            var index;
            for (var index = 0; index < labelItem.length; index ++ ) {
                if (labelItem[index] == ZaMsg.LBL_HomeGetStared) {
                    break;
                }
            }
            if (index != labelItem.length) {
                var content = contentItem[index];
                content[1] = {
                    value: com_zimbra_backuprestore.LBL_HomeConfigBackup,
                    onClick: ZaHomeXFormView.onConfigureBackup
                };
            }
        }
    }

    ZaTabView.XFormModifiers["ZaHomeXFormView"].push(ZaHotBackup.HomeXFormModifier);
}

/*	
ZaHotBackup._restoreMailListener = 
function (ev) {
	try {
		this._newSingleAccountRestoreWizard = new SingleAccountRestoreXWizard(this._container, ZaApp.getInstance());		
		var restore = new ZaRestore(ZaApp.getInstance());
		this._newSingleAccountRestoreWizard.setObject(restore);		
		this._newSingleAccountRestoreWizard.popup();
	} catch (ex) {
		this._handleException(ex, "ZaHotBackup._restoreMailListener", null, false);
	}
	return;
}*/

ZaHotBackup._restoreMailListener = 
function (ev) {
	try {
		this._newSingleAccountRestoreWizard = new AccountRestoreXWizard(this._container);		
		var restore = new ZaRestore();
		this._newSingleAccountRestoreWizard.setObject(restore);		
		this._newSingleAccountRestoreWizard.popup();
	} catch (ex) {
		this._handleException(ex, "ZaHotBackup._restoreMailListener", null, false);
	}
	return;
}

ZaHotBackup._immediateBackupListener = 
function (ev) {
	try {
		this._ImmediateBackupWizard = new ZaBackupXWizard(this._container);		
		var backup = new ZaBackup();
		backup[ZaBackup.A_method]=ZaBackup.METHOD_FULL;
		backup[ZaBackup.A_target] = ZaHotBackup.DEFAULT_BACKUP_TARGET;
		backup[ZaServerBackup.A_backupAll] = 0;
		this._ImmediateBackupWizard.setObject(backup);		
		this._ImmediateBackupWizard.popup();
	} catch (ex) {
		this._handleException(ex, "ZaHotBackup._immediateBackupListener", null, false);
	}
	return;
}

/**
* @class ZaServerBackup
* This class represents a server object 
* @author Greg Solovyev
* @contructor
* @param app reference to the application instance
**/
function ZaServerBackup() {
	ZaItem.call(this, "ZaServerBackup");
	this[ZaBackup.A_target] = ZaHotBackup.DEFAULT_BACKUP_TARGET;
	this.attrs = {};
	this._init();
	this.poolPagenum = 0;
	this.poolNumPages=1;
	this.accounts = null;
	this.live=0;
	this[ZaModel.currentStep] = 1;
	this[ZaBackup.A_pageNumber] = 1;
	this[ZaBackup.A_accountListStatus] = ZaBackup.ACC_LIST_STATUS_NONE;
	this[ZaBackup.A_backupListOffset] = 0;
	this[ZaBackup.A_backupListCount] = ZaSettings.RESULTSPERPAGE;	
}
ZaServerBackup.prototype = new ZaItem;
ZaServerBackup.prototype.constructor = ZaServerBackup;
ZaItem.loadMethods["ZaServerBackup"] = new Array();
ZaItem.initMethods["ZaServerBackup"] = new Array();
ZaServerBackup.A_latestLabel = "latestLabel";
ZaServerBackup.A_latestLabelStatus = "backupStatus";
ZaServerBackup.A_src_acct_selection_pool = "src_acct_selection_pool";
ZaServerBackup.A_tgt_acct_selection_pool = "tgt_acct_selection_pool";
ZaServerBackup.A_poolPagenum = "poolPagenum";
ZaServerBackup.A_poolNumPages = "poolNumPages";
ZaServerBackup.A_activateSearch = "activateSearch";
ZaServerBackup.A_backupAll = "backupAll";
ZaServerBackup.A_activateOperation = "activeOperation";

//Next attribute doesn't exist in zimbra_attr.xml
ZaServerBackup.A_freeSpace = "freeSpace";
ZaServerBackup.A_totalSpace = "totalSpace";
/**
* @param callback {AjxCallback}
* @return {ZaItemList} a list of ZaServerBackup objects {@link ZaItemList}
**/
ZaServerBackup.getAll = function (callback) {
	var soapDoc = AjxSoapDoc.create("GetAllServersRequest", ZaZimbraAdmin.URN, null);	
	soapDoc.getMethod().setAttribute("service", "service");
	soapDoc.getMethod().setAttribute("applyConfig", "false");
	
	//var command = new ZmCsfeCommand();
	var params = new Object();
	params.asyncMode = callback ? true : false;
	params.callback = callback ? callback : null;
	params.soapDoc = soapDoc;	
	var reqMgrParams = {
		controller: ZaApp.getInstance().getCurrentController(),
		busyMsg: ZaMsg.BUSY_GET_ALL_SERVER
	}
	if(callback) {
		ZaRequestMgr.invoke(params, reqMgrParams);
	} else {
		var resp = ZaRequestMgr.invoke(params, reqMgrParams).Body.GetAllServersResponse;	
		var list = new ZaItemList(ZaServerBackup);
		list.loadFromJS(resp);	
		return list;
	}
		
}

ZaServerBackup.loadMethod = 
function(by, val) {
	var _by = by ? by : "id";
	var _val = val ? val : this.id
	var soapDoc = AjxSoapDoc.create("GetServerRequest", ZaZimbraAdmin.URN, null);
	soapDoc.getMethod().setAttribute("applyConfig", "1");	
	var elBy = soapDoc.set("server", _val);
	elBy.setAttribute("by", _by);
	//var command = new ZmCsfeCommand();
	var params = new Object();
	params.soapDoc = soapDoc;	
	params.asyncMode = false;
	var reqMgrParams = {
		controller : ZaApp.getInstance().getCurrentController(),
		busyMsg : ZaMsg.BUSY_GET_SERVER
	}
	resp = ZaRequestMgr.invoke(params, reqMgrParams);		
	this.initFromJS(resp.Body.GetServerResponse.server[0]);
}	
ZaItem.loadMethods["ZaServerBackup"].push(ZaServerBackup.loadMethod);

ZaServerBackup.getBackupServerListChoices =
function() {
	var serverList = ZaServerBackup.getAll();
	var arr = serverList.getArray();
	if(ZaServerBackup._serverChoices == null) {
		ZaServerBackup._serverChoices = new XFormChoices(arr, XFormChoices.OBJECT_LIST,"id",ZaServer.A_ServiceHostname);
	} else {	
		ZaServerBackup._serverChoices.setChoices(arr);
		ZaServerBackup._serverChoices.dirtyChoices();
	}
	return ZaServerBackup._serverChoices;	
}


ZaServerBackup.prototype.initFromJS  = function(server) {
	ZaServer.prototype.initFromJS.call(this, server);
}

ZaServerBackup.prototype.loadBackups = function (isSync, callback) {
	var soapDoc = AjxSoapDoc.create("BackupQueryRequest", ZaZimbraAdmin.URN, null);
	var queryEl = soapDoc.set("query", "");;		
	queryEl.setAttribute("target", this.attrs[ZaGlobalConfig.A_zimbraBackupTarget] ? this.attrs[ZaGlobalConfig.A_zimbraBackupTarget] : ZaHotBackup.DEFAULT_BACKUP_TARGET);	
	queryEl.setAttribute(ZaBackup.A_accountListStatus, ZaBackup.ACC_LIST_STATUS_NONE);
	queryEl.setAttribute(ZaBackup.A_backupListCount, "1");
	var command = new ZmCsfeCommand();
	var params = new Object();
	params.soapDoc = soapDoc;	
	params.noAuthToken = true;
	params.targetServer = this.id;
    if (!isSync) {
        params.asyncMode = true;
	    params.callback = callback ? callback : (new AjxCallback(this, this.loadBackupsCallback));
    }
	var resp = command.invoke(params);
    if (isSync) {
        ZaServerBackup.prototype.loadBackupsCallback.call(this, resp, isSync);
    }
}


ZaServerBackup.prototype.loadBackupsCallback = function (resp, isSync) {
	if(!resp) {
		var ex = new ZmCsfeException(ZMsg.errorEmptyResponse,ZmCsfeException.CSFE_SVC_ERROR,"ZaServerBackup.prototype.loadBackupsCallback");
		ZaApp.getInstance().getCurrentController()._handleException(ex, "ZaServerBackup.prototype.loadBackupsCallback");
		return;
	}	
	if(resp.isException && resp.isException()) {
		ZaApp.getInstance().getCurrentController()._handleException(resp.getException(), "ZaServerBackup.prototype.loadBackupsCallback");
		return;
	} else {
		var response;
		if(resp.getResponse) {
			response = resp.getResponse();
		} else if(resp.Body.BackupQueryResponse) {
			response = resp;
		}
		var labelArray = [];
		var backup = null;
                var isChanged = false;
		if(response.Body.BackupQueryResponse.backup) {
			backup = response.Body.BackupQueryResponse.backup;
			if(!(backup instanceof Array)) {
				backup = [backup];
			}			
			var cnt = backup.length;
			var bckpLabel = new ZaBackupLabel();
			bckpLabel.initFromJS(backup[0]);
			this[ZaServerBackup.A_latestLabel] = bckpLabel;
			for(var i =0; i < cnt; i++) {
				var bckpLabel = new ZaBackupLabel();
				bckpLabel.initFromJS(backup[i]);
				bckpLabel[ZaBackup.A_target] = this[ZaBackup.A_target];
				bckpLabel[ZaBackup.A_serverId] = this[ZaBackup.A_serverId];
				bckpLabel[ZaBackup.A_serverName] = this[ZaServer.A_serverName];				
				labelArray.push(bckpLabel);
			}
			this[ZaBackup.A_backupLabelList] =  labelArray;			
			isChanged = true;
		}	
                if(response.Body.BackupQueryResponse.freeSpace) {
                        this[ZaServerBackup.A_freeSpace] = Math.floor(response.Body.BackupQueryResponse.freeSpace/(1024*1024));
                        isChanged = true;
                }
                if(response.Body.BackupQueryResponse.totalSpace) {
                        this[ZaServerBackup.A_totalSpace] = Math.floor(response.Body.BackupQueryResponse.totalSpace/(1024*1024));
                        isChanged = true;
                }

                if(isChanged && !isSync){
                        ZaApp.getInstance().getBackupServerListController().handleServerChange({obj:this});
                }
	}
}


ZaServerBackup.myXModel = {
	items: [
		{id:ZaServerBackup.A_poolPagenum, type:_NUMBER_, defaultValue:0},
		{id:ZaServerBackup.A_src_acct_selection_pool, type:_LIST_},
		{id:ZaServerBackup.A_tgt_acct_selection_pool, type:_LIST_},
		{id:ZaServerBackup.A_backupAll, type:_NUMBER_, defaultValue:1},
		{id:ZaServerBackup.A_poolNumPages, type:_NUMBER_, defaultValue:1},		
		{id:ZaBackup.A_serverId, type:_STRING_, ref:ZaBackup.A_serverId},
		{id:ZaBackup.A_serverName, type:_STRING_, ref:ZaBackup.A_serverName},		
		{id:ZaBackup.A_target, type:_STRING_, ref:ZaBackup.A_target,defaultValue:"/opt/zimbra/backup"},
		{id:ZaBackup.A_label, type:_STRING_, ref:ZaBackup.A_label},
		{id:ZaBackup.A_fromDate, type:_STRING_, ref:ZaBackup.A_fromDate},
		{id:ZaBackup.A_method, type:_STRING_, ref:ZaBackup.A_method,defaultValue:ZaBackup.METHOD_FULL},		
		{id:ZaBackup.A_Accounts, type:_LIST_, ref:ZaBackup.A_Accounts, dataType: _STRING_},		
		{id:ZaBackup.A_accountPool, ref:ZaBackup.A_accountPool, type:_LIST_, dataType: _STRING_},				
		{id:ZaBackup.A_backupLabelList, type:_LIST_, listItem:
			{type:_OBJECT_, 
				items: [
					{id:ZaBackupLabel.A_label, type:_STRING_},
					{id:ZaBackupLabel.A_start, type:_NUMBER_},
					{id:ZaBackupLabel.A_end, type:_NUMBER_},
					{id:ZaBackupLabel.A_live, type:_NUMBER_},
					{id:ZaBackupLabel.A_status, type:_STRING_}
				]
			}
		},
		{id:ZaServerBackup.A_activateSearch, type:_NUMBER_},
		{id:ZaServerBackup.A_activateOperation, type:_NUMBER_},
        {id:ZaServerBackup.A_freeSpace, type:_NUMBER_, defaultValue:0},
        {id:ZaServerBackup.A_totalSpace, type:_NUMBER_, defaultValue:0}
	]
};

ZaServerBackup.prototype.scheduleBackups = 
function () {
	var soapDoc = AjxSoapDoc.create("ScheduleBackupsRequest", ZaZimbraAdmin.URN, null);
	var serverEl = soapDoc.set("server", "");
	serverEl.setAttribute("name", this.name);		

	//var command = new ZmCsfeCommand();
	var params = new Object();
	params.soapDoc = soapDoc;	
	params.asyncMode = false;
	var reqMgrParams = {
		controller : ZaApp.getInstance().getCurrentController(),
		busyMsg : com_zimbra_backuprestore.BNR_BUSY_SCHEDULING_BACKUPS
	}
	ZaRequestMgr.invoke(params, reqMgrParams);		
	
}

ZaServerBackup.serverModifyMethod = 
function(newObj) {
	if(newObj.attrs[ZaGlobalConfig.A_zimbraBackupMode] == ZaHotBackup.BACKUP_MODE_AUTOGROUP) {
		ZaServerBackup.prototype.scheduleBackups.call(this);
	}	
}
ZaItem.modifyMethods["ZaServer"].push(ZaServerBackup.serverModifyMethod);

/**
* This method is called from {@link ZaController#_initToolbar}
**/
/*
ZaHotBackup.initAccListToolbarMethod =
function () {
	if(ZaZimbraAdmin.currentAdminAccount.attrs[ZaAccount.A_zimbraIsAdminAccount] == 'TRUE') {
		if(this._defaultType == ZaItem.ACCOUNT || this._defaultType == ZaItem.ALIAS || this._defaultType == ZaItem.RESOURCE) {
			this._toolbarOperations[ZaOperation.MOVE_ACCOUNT] = new ZaOperation(ZaOperation.MOVE_ACCOUNT, com_zimbra_backuprestore.BNR_MoveMailbox, com_zimbra_backuprestore.BNR_MoveMailbox_tt, "MoveMailbox", "MoveMailbox", new AjxListener(this, ZaHotBackup.moveAcctListener));
			this._toolbarOrder.splice(AjxUtil.indexOf(this._toolbarOrder,ZaOperation.NONE),0,ZaOperation.MOVE_ACCOUNT);		    	
		}
	}
}

if(ZaController.initToolbarMethods["ZaAccountListController"])
	ZaController.initToolbarMethods["ZaAccountListController"].push(ZaHotBackup.initAccListToolbarMethod);

ZaHotBackup.initSearchListToolbarMethod =
function () {
	if(ZaZimbraAdmin.currentAdminAccount.attrs[ZaAccount.A_zimbraIsAdminAccount] == 'TRUE') {
		this._toolbarOperations[ZaOperation.MOVE_ACCOUNT] = new ZaOperation(ZaOperation.MOVE_ACCOUNT, com_zimbra_backuprestore.BNR_MoveMailbox, com_zimbra_backuprestore.BNR_MoveMailbox_tt, "MoveMailbox", "MoveMailbox", new AjxListener(this, ZaHotBackup.moveAcctListener));
		this._toolbarOrder.splice(AjxUtil.indexOf(this._toolbarOrder,ZaOperation.NONE),0,ZaOperation.MOVE_ACCOUNT);		    	
	}
}

if(ZaController.initToolbarMethods["ZaSearchListController"])
	ZaController.initToolbarMethods["ZaSearchListController"].push(ZaHotBackup.initSearchListToolbarMethod);
*/
ZaHotBackup.initPopupMenuMethod =
function () {
	if(ZaZimbraAdmin.currentAdminAccount.attrs[ZaAccount.A_zimbraIsAdminAccount] == 'TRUE') {
		if(this._defaultType == ZaItem.ACCOUNT || this._defaultType == ZaItem.ALIAS) {
			this._popupOperations[ZaOperation.MOVE_ACCOUNT] = new ZaOperation(ZaOperation.MOVE_ACCOUNT, com_zimbra_backuprestore.BNR_MoveMailbox, com_zimbra_backuprestore.BNR_MoveMailbox_tt, "MoveMailbox", "MoveMailbox", new AjxListener(this, ZaHotBackup.moveAcctListener));		    	
		}
	}
}

if(ZaController.initPopupMenuMethods["ZaAccountListController"])	
	ZaController.initPopupMenuMethods["ZaAccountListController"].push(ZaHotBackup.initPopupMenuMethod);

ZaHotBackup.initSearchListPopupMenuMethod =
function () {
	if(ZaZimbraAdmin.currentAdminAccount.attrs[ZaAccount.A_zimbraIsAdminAccount] == 'TRUE') {
		this._popupOperations[ZaOperation.MOVE_ACCOUNT] = new ZaOperation(ZaOperation.MOVE_ACCOUNT, com_zimbra_backuprestore.BNR_MoveMailbox, com_zimbra_backuprestore.BNR_MoveMailbox_tt, "MoveMailbox", "MoveMailbox", new AjxListener(this, ZaHotBackup.moveAcctListener));		    	
	}
}

if(ZaController.initPopupMenuMethods["ZaSearchListController"])	
	ZaController.initPopupMenuMethods["ZaSearchListController"].push(ZaHotBackup.initSearchListPopupMenuMethod);


ZaHotBackup.moveAcctListener = function () {
	if(ZaZimbraAdmin.currentAdminAccount.attrs[ZaAccount.A_zimbraIsAdminAccount] == 'TRUE') {
		if(this._contentView.getSelectionCount() == 1) {
			var item = this._contentView.getSelection()[0];
			//check if the item already open in a tab
			var itemId = item.id ;
			if((item.type == ZaItem.ALIAS) && item.attrs && item.attrs[ZaAlias.A_AliasTargetId]) {
				itemId = item.attrs[ZaAlias.A_AliasTargetId];
			}
			var type = item.type;
			var accMove = new ZaAccountMove();
			if (type == ZaItem.ACCOUNT) {
				//this._selectedItem = ev.item;
				accMove.account = item;
				accMove.id = "move_" + item.id;			
			} else if(type == ZaItem.ALIAS) {
				var account = new ZaAccount();
				if(item.attrs && item.attrs[ZaAlias.A_AliasTargetId]) {
					account.load("id", item.attrs[ZaAlias.A_AliasTargetId], (!ZaSettings.COSES_ENABLED));
				}			
				accMove.account = account;
				accMove.id = "move_" + account.id;
			} else if(type == ZaItem.RESOURCE) {
				accMove.account = item;
				accMove.id = "move_" + item.id;					
			}
			ZaApp.getInstance().getAccountMoveViewController().show(accMove);		
	
		}
	}
};
		
/**
* This method is called from {@link ZaController#_initToolbar}
**/
/*
ZaHotBackup.initAccViewToolbarMethod =
function () {
	if(ZaZimbraAdmin.currentAdminAccount.attrs[ZaAccount.A_zimbraIsAdminAccount] == 'TRUE') {
		this._toolbarOperations[ZaOperation.MOVE_ACCOUNT] = ZaOperation(ZaOperation.MOVE_ACCOUNT, com_zimbra_backuprestore.BNR_MoveMailbox, com_zimbra_backuprestore.BNR_MoveMailbox_tt, "MoveMailbox", "MoveMailbox", new AjxListener(this, ZaHotBackup.moveAcctViewListener));		    	
		this._toolbarOrder.splice(AjxUtil.indexOf(this._toolbarOrder,ZaOperation.NONE),0,ZaOperation.MOVE_ACCOUNT);
	}
}

if(ZaController.initToolbarMethods["ZaAccountViewController"])
	ZaController.initToolbarMethods["ZaAccountViewController"].push(ZaHotBackup.initAccViewToolbarMethod);
		
ZaHotBackup.setAccViewMethod = function () {
	if(ZaZimbraAdmin.currentAdminAccount.attrs[ZaAccount.A_zimbraIsAdminAccount] == 'TRUE') {
		if(!this._toolbar.getButton(ZaOperation.MOVE_ACCOUNT))
			return;
			
		if(ZaApp.getInstance().getServerList() && ZaApp.getInstance().getServerList().size()>1) {
			this._toolbar.getButton(ZaOperation.MOVE_ACCOUNT).setEnabled(true);
		} else {
			this._toolbar.getButton(ZaOperation.MOVE_ACCOUNT).setEnabled(false);
		}
	}
}
ZaController.setViewMethods["ZaAccountViewController"].push(ZaHotBackup.setAccViewMethod);
*/
ZaHotBackup.moveAcctViewListener = function () {
	var accMove = new ZaAccountMove();
	accMove.account = this._currentObject;
	accMove.id = "move_" + this._currentObject.id;
	ZaApp.getInstance().getAccountMoveViewController().show(accMove);
};

ZaApp.prototype.getAccountMoveViewController =
function(viewId) {
	if (viewId && this._controllers[viewId] != null) {
		return this._controllers[viewId];
	}else{
		return new ZaAccountMoveViewController(this._appCtxt, this._container, this);
	}
}

ZaHotBackup.changeAccListActionsStateMethod = 
function () {
	if(ZaZimbraAdmin.currentAdminAccount.attrs[ZaAccount.A_zimbraIsAdminAccount] == 'TRUE') {
		if(ZaApp.getInstance().getServerList() && ZaApp.getInstance().getServerList().size()>1) {
			var cnt = this._contentView.getSelectionCount();
			if(cnt == 1) {
				var item = this._contentView.getSelection()[0];
				if(item) {
					if(item.type != ZaItem.ALIAS && item.type !=ZaItem.RESOURCE && item.type != ZaItem.ACCOUNT){
						if(this._popupOperations[ZaOperation.MOVE_ACCOUNT]) {	
							this._popupOperations[ZaOperation.MOVE_ACCOUNT].enabled=false;
						}					
					}
				} else {
					if(this._popupOperations[ZaOperation.MOVE_ACCOUNT]) {	
						this._popupOperations[ZaOperation.MOVE_ACCOUNT].enabled=false;
					}					
				}		
			} else if (cnt > 1){
				if(this._popupOperations[ZaOperation.MOVE_ACCOUNT]) {	
					this._popupOperations[ZaOperation.MOVE_ACCOUNT].enabled=false;
				}					
			} else {
				if(this._popupOperations[ZaOperation.MOVE_ACCOUNT]) {	
					this._popupOperations[ZaOperation.MOVE_ACCOUNT].enabled=false;
				}					
			}
		} else {
			if(this._popupOperations[ZaOperation.MOVE_ACCOUNT]) {	
				this._popupOperations[ZaOperation.MOVE_ACCOUNT].enabled=false;
			}					
		}
	}
}
if(ZaController.changeActionsStateMethods["ZaAccountListController"])
	ZaController.changeActionsStateMethods["ZaAccountListController"].push(ZaHotBackup.changeAccListActionsStateMethod);

if(ZaController.changeActionsStateMethods["ZaSearchListController"])
	ZaController.changeActionsStateMethods["ZaSearchListController"].push(ZaHotBackup.changeAccListActionsStateMethod);
}
   
