/*
 * ***** BEGIN LICENSE BLOCK *****
 * Zimbra Collaboration Suite, Network Edition.
 * Copyright (C) 2009, 2010, 2011, 2012, 2013, 2014 Zimbra, Inc.  All Rights Reserved.
 * ***** END LICENSE BLOCK *****
 */
//if(ZaSettings && ZaSettings.EnabledZimlet["com_zimbra_xmbxsearch"]){
function ZaXMBxSearch() {
	//if (arguments.length == 0) return;
	ZaItem.call(this, "ZaXMBxSearch");
	this.attrs = {};
	this.name = com_zimbra_xmbxsearch.XMBX_newTaskName;
	this.id = ZaXMBxSearch.DEFAULT_ID;
	this.attrs[ZaXMBxSearch.A_query] = "";
	this[ZaXMBxSearch.A_advancedSearchOn] = false;
	this.activateSearch = true;
	this.poolPagenum = 0;
	this[ZaXMBxSearch.A_searchAll] = 1;
	this.attrs[ZaXMBxSearch.A_searchArchives] = 1;
	this.attrs[ZaXMBxSearch.A_searchLive] = 1;
	this.attrs[ZaXMBxSearch.A_inDumpster] = 0;
	this.attrs[ZaXMBxSearch.A_targetFolder] = com_zimbra_xmbxsearch.XMBX_targetFolder;
	this.attrs[ZaXMBxSearch.A_Accounts] = [];
	this.attrs[ZaXMBxSearch.A_limit] = 0;
	this.attrs[ZaXMBxSearch.A_notificationMessage] = com_zimbra_xmbxsearch.XMBX_notificationMessage_def;
	this.attrs[ZaXMBxSearch.A_notificationSubj] = com_zimbra_xmbxsearch.XMBX_notificationSubj_def;
	this[ZaXMBxSearch.A_doLimit] = false;
	this[ZaXMBxSearch.A_accountPool] = [];
	this[ZaXMBxSearch.A_accountQuery] = "";
}

ZaXMBxSearch.DEFAULT_ID = "new_search_task";
ZaXMBxSearch.prototype = new ZaItem;
ZaXMBxSearch.prototype.constructor = ZaXMBxSearch;

ZaOperation.RUN_XMBXSEARCH = ++ZA_OP_INDEX;
ZaOperation.ABORT_SEARCH = ++ZA_OP_INDEX;
ZaOperation.VIEW_XMBXSEARCH_RESULTS = ++ZA_OP_INDEX;

ZaXMBxSearch.iSTATUS_IDLE = 0;
ZaXMBxSearch.iSTATUS_STARTED = 2;
ZaXMBxSearch.iSTATUS_SEARCHING = 4;    
ZaXMBxSearch.iSTATUS_IMPORTING = 8;
ZaXMBxSearch.iSTATUS_SENDING_NOTIFICATIONS = 16;

ZaXMBxSearch.iSTATUS_ABORTING = 64;
ZaXMBxSearch.iSTATUS_FINISHED = 128;    
ZaXMBxSearch.iSTATUS_ABORTED = 256;
ZaXMBxSearch.iSTATUS_ERROR = 1;

ZaXMBxSearch.RIGHT_MANAGE_SEARCH_TASK = "manageCrossMailboxSearchTask";
    
ZaXMBxSearch.E_searchtask = "searchtask";
ZaXMBxSearch.A_doLimit = "doLimit";
ZaXMBxSearch.A_limit = "limit";
ZaXMBxSearch.A_sendNotification = "sendNotification";
ZaXMBxSearch.A_notificationReceivers = "notificationReceivers";
ZaXMBxSearch.A_notificationMessage = "notificationMessage";
ZaXMBxSearch.A_serverId = "serverId";
ZaXMBxSearch.A_serverName = "serverName";
ZaXMBxSearch.A_status = "status";
ZaXMBxSearch.A_searchID = "searchID";
ZaXMBxSearch.A_targetMbx = "targetMbx";
ZaXMBxSearch.A_searchesList = "searchesList";
ZaXMBxSearch.A_query = "query";
ZaXMBxSearch.A_accountID = "accountId";
ZaXMBxSearch.A_accountQuery = "accountQuery";
ZaXMBxSearch.A_advancedSearchOn = "advancedSearchOn";
ZaXMBxSearch.A_searchAll = "searchAll";
ZaXMBxSearch.A_searchArchives = "searchArchives";
ZaXMBxSearch.A_searchLive = "searchLive";
ZaXMBxSearch.A_accountPool = "accountPool";
ZaXMBxSearch.A_Accounts = "accounts";
ZaXMBxSearch.A_targetFolder = "targetFolder";
ZaXMBxSearch.A_notificationSubj = "notificationSubj";
ZaXMBxSearch.A_numMsgs = "numMsgs";
ZaXMBxSearch.A_activateSearch = "activateSearch";
ZaXMBxSearch.A_poolNumPages = "poolNumPages";
ZaXMBxSearch.A_poolPagenum = "poolPagenum"; 
ZaXMBxSearch.A_src_acct_selection_pool = "src_acct_selection_pool";
ZaXMBxSearch.A_tgt_acct_selection_pool = "tgt_acct_selection_pool";
ZaXMBxSearch.A_hideArchivesAndSystemRes = "hideArchivesAndSystemResources";
ZaXMBxSearch.A_inDumpster = "inDumpster";


if(ZaServer.A_zimbraServiceInstalled && ZaServer.A_zimbraServiceEnabled) {
	ZaServer.A_zimbraArchivingServiceInstalled = "_"+ZaServer.A_zimbraServiceInstalled+"_archiving";
	ZaServer.A_zimbraArchivingServiceEnabled = "_"+ZaServer.A_zimbraServiceEnabled+"_archiving";	
}

if(ZaSettings) {
	ZaSettings.XMBX_SEARCH_VIEW = "crossMailboxSearchView";
	ZaSettings.ALL_UI_COMPONENTS.push({ value: ZaSettings.XMBX_SEARCH_VIEW, label: com_zimbra_xmbxsearch.UI_Comp_searchMail});
	ZaSettings.OVERVIEW_TOOLS_ITEMS.push(ZaSettings.XMBX_SEARCH_VIEW);
    ZaSettings.VIEW_RIGHTS [ZaSettings.XMBX_SEARCH_VIEW] = "adminConsoleCrossMailboxSearchRights" ;
}

ZaApp.prototype.getXMbxServerList =
function(refresh) {
	if (refresh || this._mbsList == null) {
		this._mbsList = ZaServer.getAllMBSs([ZaServer.A_ServiceHostname, ZaServer.A_description, ZaServer.A_zimbraServiceEnabled, ZaServer.A_zimbraServiceInstalled, ZaItem.A_zimbraId]);
		//this._serverList = ZaServer.getAll([ZaServer.A_ServiceHostname, ZaServer.A_description, ZaServer.A_zimbraServiceEnabled, ZaServer.A_zimbraServiceInstalled, ZaItem.A_zimbraId]);
	} else {
		if(this._xmbsList != null)
			return this._xmbsList;
	}
	
	this._xmbsList = new ZaItemList(ZaServer);
	this._xmbsList.loadedRights = this._mbsList.loadedRights;
	
	var servers = this._mbsList.getArray();
	var cnt = servers.length;
	for(var i = 0; i < cnt; i++) {
		if(servers[i].attrs[ZaServer.A_zimbraMailboxServiceEnabled] &&
		 ZaItem.hasRight(ZaXMBxSearch.RIGHT_MANAGE_SEARCH_TASK, servers[i])) {
			this._xmbsList.add(servers[i]);
		}
	}
	return this._xmbsList;
}

ZaApp.prototype.getMbxServerIdListChoices =
function(refresh) {
	if (refresh || this._xmbsList == null) {
		this.getXMbxServerList(refresh);
	}
	if(refresh || this._xmbxServerIdChoices == null) {
		var hashMap = this._xmbsList.getIdHash();
		var mailServerArr = [];
		for (var i in hashMap) {
			if (ZaItem.hasRight(ZaXMBxSearch.RIGHT_MANAGE_SEARCH_TASK, hashMap[i])){
				var obj = new Object();
				obj[ZaServer.A_ServiceHostname] = hashMap[i].attrs[ZaServer.A_ServiceHostname];
				obj.id = hashMap[i].id;
				mailServerArr.push(obj);
			}
		}
		if(this._xmbxServerIdChoices == null) {
			this._xmbxServerIdChoices = new XFormChoices(mailServerArr, XFormChoices.OBJECT_LIST, "id", ZaServer.A_ServiceHostname);
		} else {	
			this._xmbxServerIdChoices.setChoices(mailServerArr);
			this._xmbxServerIdChoices.dirtyChoices();
		}
	}
	return this._xmbxServerIdChoices;	
}

ZaXMBxSearch.prototype.initFromJS = 
function (obj) {
	if(!obj)
		return;

	ZaItem.prototype.initFromJS.call(this, obj);
	
	if(this.attrs[ZaXMBxSearch.A_Accounts] && this.attrs[ZaXMBxSearch.A_Accounts]=="*") {
		this[ZaXMBxSearch.A_searchAll] = 1;
		this.attrs[ZaXMBxSearch.A_Accounts] = [];
	} else
		this[ZaXMBxSearch.A_searchAll] = 0;
	
	if(!(this.attrs[ZaXMBxSearch.A_Accounts] instanceof Array) && this.attrs[ZaXMBxSearch.A_Accounts] != null) {
		this.attrs[ZaXMBxSearch.A_Accounts] = [this.attrs[ZaXMBxSearch.A_Accounts]];
	}
	
	//this.attrs[ZaXMBxSearch.A_searchArchives] = (this.attrs[ZaXMBxSearch.A_searchArchives]=="1");
	//this.attrs[ZaXMBxSearch.A_searchLive] = (this.attrs[ZaXMBxSearch.A_searchLive]=="1");	
	this[ZaXMBxSearch.A_doLimit] = (this.attrs[ZaXMBxSearch.A_limit]>0);
	this.id = this.attrs[ZaXMBxSearch.A_searchID];
	this.name = AjxMessageFormat.format (com_zimbra_xmbxsearch.XMBX_TABT_SearchTask, this.id);
}


ZaZimbraAdmin._XMBX_SEARCH_LIST = ZaZimbraAdmin.VIEW_INDEX++;
ZaZimbraAdmin._XMBX_SEARCH_VIEW = ZaZimbraAdmin.VIEW_INDEX++;

ZaApp.prototype.getXMbxSearchListController =
function() {
	if (this._controllers[ZaZimbraAdmin._XMBX_SEARCH_LIST] == null)
		this._controllers[ZaZimbraAdmin._XMBX_SEARCH_LIST] = new ZaXMBxSearchListController(this._appCtxt, this._container);
	return this._controllers[ZaZimbraAdmin._XMBX_SEARCH_LIST];
}

ZaApp.prototype.getXMbxSearchViewController =
function(viewId) {
	if (viewId && this._controllers[viewId] != null) {
		return this._controllers[viewId];
	}else{
		return new ZaXMBxSearchViewController(this._appCtxt, this._container);
	}

}

ZaXMBxSearch.xmbxSearchListTreeListener = function (ev) {
	var serverList = ZaApp.getInstance().getXMbxServerList();
	var servers = [];
	if(serverList) {
		servers = serverList.getArray();
	}
	if(ZaApp.getInstance().getCurrentController()) {
		ZaApp.getInstance().getCurrentController().switchToNextView(ZaApp.getInstance().getXMbxSearchListController(),ZaXMBxSearchListController.prototype.show, [servers]);
	} else {					
		ZaApp.getInstance().getXMbxSearchListController().show(servers);
	}
}

ZaXMBxSearch.xmbxsrchOvTreeModifier = function (tree) {
	//find out if we have any xmbx rights on any servers
	var serverList = ZaApp.getInstance().getXMbxServerList();

	if(serverList.size()>0) {
        if (!appNewUI) {
            if(!this._toolsTi) {
                this._toolsTi = new DwtTreeItem(tree, null, null, null, null, "overviewHeader");
                this._toolsTi.enableSelection(false);
                this._toolsTi.setText(ZaMsg.OVP_tools);
                this._toolsTi.setData(ZaOverviewPanelController._TID, ZaZimbraAdmin._TOOLS);
            }

            this._xmbxsrchTi = new DwtTreeItem({parent:this._toolsTi,className:"AdminTreeItem"});
            this._xmbxsrchTi.setText(com_zimbra_xmbxsearch.OVP_xmbxsrch);
            this._xmbxsrchTi.setImage("CrossMailboxSearch");
            this._xmbxsrchTi.setData(ZaOverviewPanelController._TID, ZaZimbraAdmin._XMBX_SEARCH_LIST);
        } else {
            ti = new ZaTreeItemData({
                                        parent:ZaTree.getPathByArray([ZaMsg.OVP_home,ZaMsg.OVP_toolMig]),
                                        id:ZaId.getTreeItemId(ZaId.PANEL_APP,"magHV",null, "xmbSearch"),
                                        text: com_zimbra_xmbxsearch.OVP_xmbxsrch,
                                        canShowOnRoot: false,
                                        forceNode: false,
                                        mappingId: ZaZimbraAdmin._XMBX_SEARCH_LIST
                                        });

            tree.addTreeItemData(ti);
        }
		if(ZaOverviewPanelController.overviewTreeListeners) {
			ZaOverviewPanelController.overviewTreeListeners[ZaZimbraAdmin._XMBX_SEARCH_LIST] = ZaXMBxSearch.xmbxSearchListTreeListener;
		}
	}
}

if(ZaOverviewPanelController.treeModifiers)
	ZaOverviewPanelController.treeModifiers.push(ZaXMBxSearch.xmbxsrchOvTreeModifier);
	

ZaXMBxSearch.getXMbxSearchesList = 
function (server, callback) {
	var soapDoc = AjxSoapDoc.create("GetXMbxSearchesListRequest", "urn:zimbraAdmin", null);

	this.asynCommand = new ZmCsfeCommand();
	var params = new Object();
	params.soapDoc = soapDoc;
	params.noAuthToken = true;	
	params.targetServer = server.id;
	if(callback) {
		params.asyncMode = true;
		params.callback = callback;
	}
	this.asynCommand.invoke(params);	
}

ZaXMBxSearch.abortXMbxSearch = 
function (obj, callback) {
	var soapDoc = AjxSoapDoc.create("AbortXMbxSearchRequest", "urn:zimbraAdmin", null);
	var srchTaskEl = soapDoc.set(ZaXMBxSearch.E_searchtask, "");
	srchTaskEl.setAttribute(ZaXMBxSearch.A_searchID, obj.attrs[ZaXMBxSearch.A_searchID]);
	var attr = soapDoc.set("account", obj.attrs[ZaXMBxSearch.A_accountID]);
	attr.setAttribute("by", "id");
	this.asynCommand = new ZmCsfeCommand();
	var params = new Object();
	params.soapDoc = soapDoc;
	params.noAuthToken = true;	
	params.targetServer = obj.attrs[ZaXMBxSearch.A_serverId];
	if(callback) {
		params.asyncMode = true;
		params.callback = callback;
	}
	this.asynCommand.invoke(params);	
}

ZaXMBxSearch.deleteXMbxSearch = 
function (obj, callback) {
	var soapDoc = AjxSoapDoc.create("DeleteXMbxSearchRequest", "urn:zimbraAdmin", null);
	var srchTaskEl = soapDoc.set(ZaXMBxSearch.E_searchtask, "");
	srchTaskEl.setAttribute(ZaXMBxSearch.A_searchID, obj.attrs[ZaXMBxSearch.A_searchID]);
	var attr = soapDoc.set("account", obj.attrs[ZaXMBxSearch.A_accountID]);
	attr.setAttribute("by", "id");
	this.asynCommand = new ZmCsfeCommand();
	var params = new Object();
	params.soapDoc = soapDoc;
	params.noAuthToken = true;	
	params.targetServer = obj.attrs[ZaXMBxSearch.A_serverId];
	if(callback) {
		params.asyncMode = true;
		params.callback = callback;
	}
	this.asynCommand.invoke(params);	
}

ZaXMBxSearch.createXMbxSearch = 
function (tmpObj, callback) {
	var soapDoc = AjxSoapDoc.create("CreateXMbxSearchRequest", "urn:zimbraAdmin", null);
	
	if(tmpObj[ZaXMBxSearch.A_searchAll]==1) {
		tmpObj.attrs[ZaXMBxSearch.A_Accounts]="*";
	}

	if(!tmpObj[ZaXMBxSearch.A_doLimit]) {
		tmpObj.attrs[ZaXMBxSearch.A_limit]=0;
	}
	
	for (var aname in tmpObj.attrs) {
		if(aname == ZaXMBxSearch.A_searchID || aname == ZaXMBxSearch.A_searchesList || aname == ZaXMBxSearch.A_accountPool ) {
			continue;
		}	
		
		if(tmpObj.attrs[aname] instanceof Array) {
			var cnt = tmpObj.attrs[aname].length;
			if(cnt) {
				for(var ix=0; ix <cnt; ix++) {
					if(typeof(tmpObj.attrs[aname][ix])=="object") {
						var attr = soapDoc.set("a", tmpObj.attrs[aname][ix].toString());
						attr.setAttribute("n", aname);
					} else {
						var attr = soapDoc.set("a", tmpObj.attrs[aname][ix]);
						attr.setAttribute("n", aname);						
					}
				}
			} 
		} else if (tmpObj.attrs[aname] instanceof AjxVector) {
			var tmpArray = tmpObj.attrs[aname].getArray();
			var cnt = tmpArray.length;
			if(cnt) {
				for(var ix=0; ix <cnt; ix++) {
					if(tmpArray[ix] !=null) {
						if(typeof(tmpArray[ix])=="object") {
							var attr = soapDoc.set("a", tmpArray[ix].toString());
							attr.setAttribute("n", aname);
						} else {
							var attr = soapDoc.set("a", tmpArray[ix]);
							attr.setAttribute("n", aname);
						}
					}
				}
			} 			
			
		} else {	
			if(tmpObj.attrs[aname] != null) {
				if(typeof(tmpObj.attrs[aname]) == "object") {				
					var attr = soapDoc.set("a", tmpObj.attrs[aname].toString());
					attr.setAttribute("n", aname);
				} else {
					var attr = soapDoc.set("a", tmpObj.attrs[aname]);
					attr.setAttribute("n", aname);					
				}
			}
		}
	}
	this.asynCommand = new ZmCsfeCommand();
	var params = new Object();
	params.soapDoc = soapDoc;
	params.noAuthToken = true;	
	params.targetServer = tmpObj.attrs[ZaXMBxSearch.A_serverId];
	if(callback) {
		params.asyncMode = true;
		params.callback = callback;
	}
	this.asynCommand.invoke(params);	
}
	
ZaXMBxSearch.myXModel = {
	items: [
		{id:ZaXMBxSearch.A_serverId, type:_STRING_,ref:"attrs/"+ZaXMBxSearch.A_serverId},
		{id:ZaXMBxSearch.A_serverName, type:_STRING_,ref:"attrs/"+ZaXMBxSearch.A_serverName},
		{id:ZaXMBxSearch.A_status, type:_STRING_,ref:"attrs/"+ZaXMBxSearch.A_status},
		{id:ZaXMBxSearch.A_searchID, type:_STRING_,ref:"attrs/"+ZaXMBxSearch.A_searchID},		
		{id:ZaXMBxSearch.A_targetMbx, type:_STRING_,ref:"attrs/"+ZaXMBxSearch.A_targetMbx},
		{id:ZaXMBxSearch.A_query, type:_STRING_,ref:"attrs/"+ZaXMBxSearch.A_query},
		{id:ZaXMBxSearch.A_advancedSearchOn, type:_ENUM_, choices:[true,false]},
		{id:ZaXMBxSearch.A_activateSearch, type:_NUMBER_},
		{id:ZaXMBxSearch.A_doLimit,type:_ENUM_,choices:[true,false]},
		{id:ZaXMBxSearch.A_poolPagenum, type:_NUMBER_},
		{id:ZaXMBxSearch.A_targetFolder, type:_STRING_,ref:"attrs/"+ZaXMBxSearch.A_targetFolder, defaultValue:"xmbx results", pattern:"^[^\\x00-\\x1F\\x7F:\\\"]+$",maxLength:128},
		{id:ZaXMBxSearch.A_limit, type:_NUMBER_,ref:"attrs/"+ZaXMBxSearch.A_limit, defaultValue:0, minInclusive:0},
		{id:ZaXMBxSearch.A_numMsgs, type:_NUMBER_,ref:"attrs/"+ZaXMBxSearch.A_numMsgs},				
		{id:ZaXMBxSearch.A_accountQuery, type:_STRING_},
		{id:ZaXMBxSearch.A_searchAll, type:_NUMBER_, ref:ZaXMBxSearch.A_searchAll,defaultValue:0},		
		{id:ZaXMBxSearch.A_searchArchives, type:_NUMBER_, ref:"attrs/"+ZaXMBxSearch.A_searchArchives,defaultValue:1},				
		{id:ZaXMBxSearch.A_searchLive, type:_NUMBER_, ref:"attrs/"+ZaXMBxSearch.A_searchLive,defaultValue:1},						
		{id:ZaXMBxSearch.A_Accounts, type:_LIST_, ref:"attrs/"+ZaXMBxSearch.A_Accounts, dataType: _STRING_},		
		{id:ZaXMBxSearch.A_accountPool, ref:ZaXMBxSearch.A_accountPool, type:_LIST_, dataType: _STRING_},
		{id:ZaXMBxSearch.A_sendNotification,type:_NUMBER_, ref:"attrs/"+ZaXMBxSearch.A_sendNotification},
		{id:ZaXMBxSearch.A_notificationReceivers, type:_STRING_, ref:"attrs/"+ZaXMBxSearch.A_notificationReceivers},
		{id:ZaXMBxSearch.A_notificationMessage, type:_STRING_, ref:"attrs/"+ZaXMBxSearch.A_notificationMessage},
		{id:ZaXMBxSearch.A_notificationSubj, type:_STRING_, ref:"attrs/"+ZaXMBxSearch.A_notificationSubj},
		{id:ZaXMBxSearch.A_poolNumPages, type:_NUMBER_},
		{id:ZaXMBxSearch.A_src_acct_selection_pool, type:_LIST_},
		{id:ZaXMBxSearch.A_tgt_acct_selection_pool, type:_LIST_},
		{id:ZaXMBxSearch.A_hideArchivesAndSystemRes, type:_ENUM_,choices:[true,false]},
		{id:ZaXMBxSearch.A_inDumpster, type:_NUMBER_, ref:"attrs/"+ZaXMBxSearch.A_inDumpster, defaultValue:0}
	]
};

ZaXMBxSearch.listXModel = {
	items: [
		{id:ZaXMBxSearch.A_searchesList, type:_LIST_, 
			listItem:{type:_OBJECT_, items:ZaXMBxSearch.myXModel.items}
		}		
	]
};

if(ZaServer.myXModel && ZaServer.myXModel.items && ZaServer.myXModel.items instanceof Array) {
	ZaServer.myXModel.items.push({id:ZaServer.A_zimbraArchivingServiceEnabled, ref:"attrs/"+ZaServer.A_zimbraArchivingServiceEnabled, type: _ENUM_, choices: [false,true] });
	ZaServer.myXModel.items.push({id:ZaServer.A_zimbraArchivingServiceInstalled, ref:"attrs/"+ZaServer.A_zimbraArchivingServiceInstalled, type: _ENUM_, choices: [false,true] });	
}

ZaXMBxSearch.XMBXAccListsearchButtonListener = function (ev) {
	var newSrch = new ZaXMBxSearch(ZaApp.getInstance());
	newSrch[ZaXMBxSearch.A_searchAll]=0;
	if(this._contentView.getSelectionCount()>0) {
		var arrItems = this._contentView.getSelection();
		var cnt = arrItems.length;
		for(var key =0; key < cnt; key++) {
			if(arrItems[key] && arrItems[key].type == ZaItem.ACCOUNT)
				newSrch.attrs[ZaXMBxSearch.A_Accounts].push(arrItems[key]);
		}
	}
	ZaApp.getInstance().getXMbxSearchViewController().show(newSrch);
}

/**
* This method is called from {@link ZaController#_initToolbar}
**/
ZaXMBxSearch.AccountListInitPopupMenuMethod =
function () {
	if(ZaZimbraAdmin.haveAnyTargetRight(ZaItem.ACCOUNT,ZaAccount.VIEW_MAIL_RIGHT) && ZaXMBxSearch.canManageXMBXSearchTask() && 
			(ZaSettings.ENABLED_UI_COMPONENTS[ZaSettings.XMBX_SEARCH_VIEW]  || ZaSettings.ENABLED_UI_COMPONENTS[ZaSettings.CARTE_BLANCHE_UI])) {
	    this._popupOperations[ZaOperation.RUN_XMBXSEARCH] = new ZaOperation(ZaOperation.RUN_XMBXSEARCH, com_zimbra_xmbxsearch.OVP_xmbxsrch, com_zimbra_xmbxsearch.XMBX_RunSearch_tt, "CrossMailboxSearch", "CrossMailboxSearch", new AjxListener(this, ZaXMBxSearch.XMBXAccListsearchButtonListener));    			
	}
}
ZaController.initPopupMenuMethods["ZaAccountListController"].push(ZaXMBxSearch.AccountListInitPopupMenuMethod);
ZaController.initPopupMenuMethods["ZaSearchListController"].push(ZaXMBxSearch.AccountListInitPopupMenuMethod);

if(ZaTabView.XFormModifiers["ZaServerXFormView"] && ZaServer.A_zimbraArchivingServiceEnabled && ZaServer.A_zimbraArchivingServiceInstalled) {
	ZaXMBxSearch.serverXFormModifier = function(xFormObject) {	
		if(xFormObject && xFormObject.items && xFormObject.items.length)	 {
			var cntItems = xFormObject.items.length;
			for(var i = 0; i < cntItems; i++) {
				if(xFormObject.items[i] && (xFormObject.items[i].type==_SWITCH_) && xFormObject.items[i].items && xFormObject.items[i].items.length) {
					var tabs = xFormObject.items[i].items;
					var cntTabs = tabs.length;
					for(var j = 0; j< cntTabs; j++) {
						if(tabs[j] && tabs[j].id=="server_services_tab" && tabs[j].items && tabs[j].items instanceof Array) {
							var cntGroups = tabs[j].items.length;
							for(var k=0;k<cntGroups;k++) {
								if(tabs[j].items[k] && tabs[j].items[k].type==_ZA_TOP_GROUPER_ && tabs[j].items[k].items instanceof Array) {
									tabs[j].items[k].items.push(
										{ ref: ZaServer.A_zimbraArchivingServiceEnabled, type: _CHECKBOX_,
									  	  enableDisableChecks:[[XForm.checkInstanceValue,ZaServer.A_zimbraArchivingServiceInstalled,true]],
									  	  label: com_zimbra_xmbxsearch.XMBX_Service_Archiving,
								  	      onChange: ZaServerXFormView.onFormFieldChanged
									  	});
									break;
								}
							}
							break;
						}
					}
					break;
				}
			}
		}
	}
	ZaTabView.XFormModifiers["ZaServerXFormView"].push(ZaXMBxSearch.serverXFormModifier);
}
//}

ZaXMBxSearch.canManageXMBXSearchTask = function() {
	return (ZaZimbraAdmin.isGlobalAdmin() || (ZaSettings.targetRights[ZaItem.SERVER]
	&& ZaSettings.targetRights[ZaItem.SERVER][ZaXMBxSearch.RIGHT_MANAGE_SEARCH_TASK]
	&& ZaSettings.targetRights[ZaItem.SERVER][ZaXMBxSearch.RIGHT_MANAGE_SEARCH_TASK].some)
	|| (ZaSettings.targetRights[ZaItem.GLOBAL_GRANT]
		&& ZaSettings.targetRights[ZaItem.GLOBAL_GRANT][ZaXMBxSearch.RIGHT_MANAGE_SEARCH_TASK]
		&& ZaSettings.targetRights[ZaItem.GLOBAL_GRANT][ZaXMBxSearch.RIGHT_MANAGE_SEARCH_TASK].some));
}